/**************************
 * BlackJack Game written *
 *     by Greg Perry      *
 *   for Sams Publishing  *
 *       (c) 1994         *
 * Rework done for use in *
 * Death's Domain Mud by  *
 *    Wolfman, (c) 2001   *
 **************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
/* BJ_DEALER, BJ_GAMBLER, BJ_ACELOW, BJ_ACEHIGH */

int askedForName = 0;

void dispTitle(void);
void initCardsScreen(int cards[52], int playerPoints[2], int dealerPoints[2], int total[2], int * numCards);
int dealCard(int * numCards, int cards[52]);
void dispCard(int cardDrawn, int points[2]);
void totalIt(int points[2], int total[2], int who);
void dealerGetsCard(int *numCards, int cards[52], int dealerPoints[2]);
void playerGetsCard(int *numCards, int cards[52], int playerPoints[2]);
char getAns(char mesg[]);
void findWinner(int total[2]);
{
int numCards;
int cards[52], playerPoints[2], dealerPoints[2], total[2];
char ans;
do { initCardsScreen(cards, playerPoints, dealerPoints, total, &numCards);
dealerGetsCard(&numCards, cards, dealerPoints);
printf("\n");
playerGetsCard(&numCards, cards, playerPoints);
playerGetsCard(&numCards, cards, playerPoints);
do {
ans = getAns("Hit or Stand (H/S)? ");
if (ans == 'H')
{ playerGetsCard(&numCards, cards, playerPoints);
}
} while (ans != 'S');
totalIt(playerPoints, total, PLAYER);
do {
dealerGetsCard(&numCards, cards, dealerPoints);
} while (dealerPoints[ACEHIGH] < 17);
totalIt(dealerPoints, total, DEALER);
findWinner(total);
ans = getAns("\nPlay Again (Y/N)? ");
} while (ans == 'Y');
return;
}
void initCardsScreen(int cards[52], int playerPoints[2], int dealerPoints[2], int total[2], int *numCards)
{
int sub, val = 1;
char firstName[15];
*numCards = 52;
for (sub = 0; sub <= 51; sub++) {
val = (val == 14) ? 1 : val;
cards[sub] = val;
val++; }
for (sub = 0; sub <= 1; sub++)
{ playerPoints[sub]=dealerPoints[sub]=total[sub]=0; }
dispTitle();
if (askedForName == 0)
{ printf("\nWhat is your first name? ");
scanf(" %s", firstName);
askedForName = 1;
printf("Ok, %s, get ready for casino action!\n\n", firstName);
getchar();
}
return;
}
void playerGetsCard (int *numCards, int cards[52], int playerPoints[2])
{
int newCard;
newCard = dealCard(numCards, cards);
printf("You draw: ");
dispCard(newCard, playerPoints);
}
void dealerGetsCard(int *numCards, int cards[52], int dealerPoints[2])
{
int newCard;
newCard = dealCard(numCards, cards);
printf("The dealer draws: ");
dispCard(newCard, dealerPoints);
}
int dealCard(int * numCards, int cards[52])
{
int cardDrawn, subDraw;
time_t t;
srand(time(&t));
subDraw = (rand() % (*numCards));
cardDrawn = cards[subDraw];
cards[subDraw] = cards[*numCards -1];
(*numCards);
return cardDrawn;
}
void dispCard(int cardDrawn, int points[2])
{
switch (cardDrawn) {
case (11) : printf("%s\n", "Jack");
points[ACELOW] += 10;
points[ACEHIGH] += 10;
break;
case (12) : printf("%s\n", "Queen");
points[ACELOW] += 10;
points[ACEHIGH] += 10;
break;
case (13) : printf("%s\n", "King");
points[ACELOW] += 10;
points[ACEHIGH] += 10;
break;
default : points[ACELOW] += cardDrawn;
if (cardDrawn == 1)
{ printf("%s\n", "Ace");
  points[ACEHIGH] += 11;
}
else
{  points[ACEHIGH] += cardDrawn;
   printf("%d\n", cardDrawn); }
}
return;
}
void totalIt(int points[2], int total[2], int who)
{
if ((points[ACELOW] == points[ACEHIGH]) || (points[ACEHIGH] > 21))
{ total[who] = points[ACELOW]; }
else
{ total[who] = points[ACEHIGH]; }
if (who == PLAYER)
{ printf("You have a total of %d\n\n", total[PLAYER]); }
else
{ printf("The house stands with a total of %d\n\n", total[DEALER]); }
return;
}
void findWinner(int total[2])
{
if (total[DEALER] == 21)
{ printf("The house wins.\n");
return; }
if ((total[DEALER] > 21) && (total[PLAYER] > 21))
{ printf("%s", "Nobody wins.\n");
return; }
if ((total[DEALER] >= total[PLAYER])&&(total[DEALER]<21))
{ printf("The house wins.\n");
return; }
if ((total[PLAYER] > 21 ) && (total[DEALER] < 21))
{ printf("The house wins.\n");
return; }
printf("%s%c", "You win!\n");
return;
}
char getAns(char mesg[])
{
char ans;
printf("%s", mesg);
ans = getchar();
getchar();
return toupper(ans);
}
void dispTitle(void)
{
int i = 0;
while (i < 25)
{ printf("\n");
i++; }
printf("\n\n*Step right up to the Blackjack tables*\n\n");
return;
}
