/******************************************************************************<><> Bile's Bots.h - by Bile for Deaths Domain                             <><>
<><>                                                                       <><>
******************************************************************************/

/* Bots are kept in the players inventory until activated. The bot stats
   will be stored in the pfile in case of crash, etc. Also, (since pets
   are not saved) if the bot is not found in the game it will load back
   into the owners inventory or in_room depending on if it is activated or 
   not (unless its destroyed, then maybe some junk would be left over).
   When a bot is activated it becomes a mob and is petted to the owner. 
   If the Owner changes rooms in any way besides walking, the mob will be 
   placed in_room with the owner. --Bile                                  */



/****** Macros **********************************************************/

#define GET_CHASSIS(ch, bot)     (ch->bot.chassis)
#define GET_SLOT_MEMORY(ch, bot, slot)  (ch->bot->memory.slot->stats[1])
#define CHASSIS_HARD_SLOTS(num)  (chassis_stats[num].stats[0])
#define CHASSIS_RAM_SLOTS(num)   (chassis_stats[num].stats[1])
#define CHASSIS_MAXHP(num)       (chassis_stats[num].stats[2])
#define CHASSIS_MAXAC(num)       (chassis_stats[num].stats[3])
#define CHASSIS_DAMCAP(num)      (chassis_stats[num].stats[4])
#define CHASSIS_MAKE_PREQ(num)   (chassis_stats[num].stats[5])
#define CHASSIS_USE_PREQ(num)    (chassis_stats[num].stats[6])
#define CHASSIS_SLAB_COST(num)   (chassis_stats[num].stats[7])


/******* Bot Chassis *****************************************************/

#define MAX_CHASSIS  6
const struct bot_chassis chassis_stats [MAX_CHASSIS]=
{

  /*HW    RAM                    DamCap  Make  Use  Slab
    Slots Slots  Max HP  Max AC  ADD     Preq  Preq Cost 
    ---------------------------------------------------- */
 { "TinyBot V1.0#n", 
   {1,    2,     100,    1000,   100,    10,   10,  1000} },
 { "TinyBot V2.0#n", 
   {1,    3,     100,    1000,   100,    15,   15,  2000} } ,
 { "TinyBot V3.0#n", 
   {1,    4,     100,    1000,   100,    20,   20,  3000} },
 { "TinyBot V4.0#n", 
   {1,    5,     100,    1000,   100,    25,   25,  4000} },
 { "TinyBot V5.0#n", 
   {1,    6,     100,    1000,   100,    30,   30,  5000} },
 { "TinyBot V6.0#n", 
   {1,    7,     100,    1000,   100,    35,   35,  6000} }
}  
struct bot_chassis
{
  char *name;
  int stats[8]; 
}
/******* Memory Chips **************************************************/

#define MAX_RAMCHIPS 6
const struct bot_ram_module ram_chips [MAX_RAMCHIPS]=
{
  /* Name_________        Memory       MakePreq      SlabCost 
    --------------------------------------------------------- */
  { "Empty RAM Slot.",    {0,           -1            -1 } },
  { "(tm) RAMchip 1.0#n", {1,            0            100} },
  { "(tm) RAMchip 1.0#n", {2,           15            110} },
  { "(tm) RAMchip 1.0#n", {3,           20            120} },
  { "(tm) RAMchip 1.0#n", {4,           25            130} },
  { "(tm) RAMchip 1.0#n", {5,           30            140} }
}
struct bot_ram_module
{
  char *name;
  int stats[3]; 
}
struct bot_memory
{
  char * name;     /* taken from the item installed                */
  int ram;         /* Amount of memory from the ram object         */
  struct bot_memory * next;
}

/********** HardWarez *****************************************************/
/* Hardware Module Types */
#define MODULE_NONE         0
#define MODULE_EYE          1
#define MODULE_NIGHTVISION  2
#define MODULE_SHADOWVISION 3
#define MODULE_INFRARED     4
#define MAX_HARDWARE_MODULE 5

const struct bot_hard_module hardware_module [MAX_HARDWARE_MODULE]=
{
  /* Slots        Item          Make     HR  DR  AC  DamCap AFF Slab
     Needed       Number        Preq     Add Add Add Add    Add Cost
     --------------------------------------------------------------- */
  { "Empty Slot.", 
    {1,           0,            -1,      0,  0,  0,  0,     0,  -1  } },
  { "(tm) Optic Sensor#n", 
    {1,           1,            10,     70, 70, 0,  100,   0,  500  } },
  { "(tm) Nightvision Modulator#n", 
    {1,           2,            15,     70, 70, 0,  100,   0,  500  } },
  { "(tm) Shadow_vision Enhancer#n", 
    {1,           3,            20,     70, 70, 0,  100,   0,  500  } },
  { "(tm) Infra-red Optical Decoder#n", 
    {1,           4,            30,     70, 70, 0,  100,   0,  500  } }
}

struct bot_hard_module
{
  char *name;
  int stats[9]; 
}

/* Maybe add software reqs for each hardware ?                     */
struct bot_hardware
{
  int slots_taken; /* How many slots this thing is taking up       */
  int item_number; /* So we know what this thing is supposed to do */
  int ac_add;      /* adds to the botmob's AC                      */
  int dam_add;     /* adds to the botmob's DamRoll                 */
  int hit_add;     /* adds to the botmob's Hitroll                 */
  int damcap_add;  /* adds to the botmob's damcap                  */
  int affections;  /* Any botmob affections                        */
  char * name;     /* taken from the item installed                */
  struct bot_hardware * next;
}
/********** SoftWarez *****************************************************/

/* Software Module Types */
#define WAREZ_DOS         0
#define WAREZ_WINDOZE3    1
#define WAREZ_95          2
#define WAREZ_98          3
#define WAREZ_2K          4
#define WAREZ_UNIX        5

#define MAX_WAREZ_MODULE 5

const struct bot_soft_module software_module [MAX_WAREZ_MODULE]=
{
  /* Item         Make     HR  DR  AC  DamCap AFF Memory  CPU
     Number       Preq     Add Add Add Add    Add Cost    Demand
     ----------------------------------------------------------- */
  { "#PDOS Operating System#n", 
    {1,           0,       0,  0,  0,  0,     0,  10,     1000} },
  { "-soft #PWindoze 3.0 Operating System#n", 
    {2,           10,      0,  0,  0,  0,     0,  15       800} },
  { "-soft #P'95 Operating System#n", 
    {3,           20,      10, 0,  0,  0,     0,  20       800} },
  { "-soft #P'98 Operating System#n", 
    {4,           30,      20, 0,  0,  0,     0,  30       799} },
  { "2K #POperating System#n", 
    {5,           40,      40, 0,  0,  0,     0,  20       600} },
  { "NIX #rOperating System#n", 
    {6,           50,      80, 10, 0,  10,    0,  10       400} }
}

struct bot_soft_module
{
  char *name;
  int stats[9]; 
}

/* Maybe add software reqs for each hardware ?                     */
struct bot_software
{
  int mem_cost;    /* How much memory this thing is taking up      */
  int cpu_cost;    /* How demanding it is on the CPU               */
  int item_number; /* So we know what this thing is supposed to do */
  int ac_add;      /* adds to the botmob's AC                      */
  int dam_add;     /* adds to the botmob's DamRoll                 */
  int hit_add;     /* adds to the botmob's Hitroll                 */
  int damcap_add;  /* adds to the botmob's damcap                  */
  int affections;  /* Any botmob affections                        */
  char * name;     /* taken from the item installed                */
  struct bot_software * next;
}
/******** The Bot Itself ************************************************/

struct bot_data
{
  int number;                    /* Number in the players Bot-List     */
  int onoff;                     /* on(1)=mob off(0)=obj               */
  int vnum;                      /* Vnum of obj/mob representing it    */
  int pos;                       /* What the bot is doing              */
  char * name;                   /* Players can name their bots :P     */
  int * chassis;                 /* Have to start out with a chassis   */
  int * board;
  int hp;
  int max_hp;
  int goal;                      /* Roomnum guarded, playernum hunted, etc */
  struct bot_hardware * parts;
  struct bot_memory * memory;
  struct bot_software * warez;
  struct bot_data * next;
}
