/*
 * The Mythran Mud Economy Snippet Version 2 (used to be banking.c)
 *
 * Copyrights and rules for using the economy system:
 *
 *      The Mythran Mud Economy system was written by The Maniac, it was
 *      loosly based on the rather simple 'Ack!'s banking system'
 *
 *      If you use this code you must follow these rules.
 *              -Keep all the credits in the code.
 *              -Mail Maniac (v942346@si.hhs.nl) to say you use the code
 *              -Send a bug report, if you find 'it'
 *              -Credit me somewhere in your mud.
 *              -Follow the envy/merc/diku license
 *              -If you want to: send me some of your code
 *
 * All my snippets can be found on http://www.hhs.nl/~v942346/snippets.html
 * Check it often because it's growing rapidly  -- Maniac --
 */

#if defined( macintosh )
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "merc.h"

int     share_value = SHARE_VALUE;     

void do_bank( CHAR_DATA *ch, char *argument )
{
        CHAR_DATA *mob;
        char buf[MAX_STRING_LENGTH];
        char arg1[MAX_INPUT_LENGTH];
        char arg2[MAX_INPUT_LENGTH];

        if ( IS_NPC( ch ) )
        {
                send_to_char( "Banking Services are only available to players!\n\r", ch );
                return;
        }

        /* Check for mob with act->banker */
        for ( mob = ch->in_room->people; mob; mob = mob->next_in_room )
        {
                if ( IS_NPC(mob) && IS_SET(mob->act, ACT_BANKER ) )
                        break;
        }

        if ( mob == NULL )
        {
                send_to_char( "You can't do that here.\n\r", ch );
                return;
        }

        /* if ((time_info.hour < 9) || (time_info.hour > 17))
        {
                send_to_char( "The bank is closed, it is open from 9 to 5.\n\r", ch);
                return;
        } */

        if ( argument[0] == '\0' )
        {
                send_to_char( "Bank Options:\n\r\n\r", ch );
                send_to_char( "Bank balance: Displays your balance.\n\r", ch );
                send_to_char( "Bank deposit : Deposit qp into your account.\n\r", ch );
                send_to_char( "Bank withdraw : Withdraw qp from your account.\n\r", ch );
#if defined BANK_TRANSFER
                send_to_char( "Bank transfer  : Transfers qp to another account.\n\r", ch);
                send_to_char( "Bank buy #: Buy # shares (in developement)\n\r", ch);
                send_to_char( "Bank sell #: Sell # shares (in developement)\n\r", ch);
                send_to_char( "Bank check: Check the current rates of the shares. (in developement)\n\r", ch);
#endif
                return;
        }

        argument = one_argument( argument, arg1 );
        argument = one_argument( argument, arg2 );

        /* Now work out what to do... */
        if ( !str_prefix( arg1, "balance" ) )
        {
                sprintf(buf,"Your current balance is: %d QP.\n\r",ch->pcdata->balance );
                do_say(mob, buf);
                return;
        }

        if ( !str_prefix( arg1, "deposit" ) )
        {
                int amount;

                if ( is_number ( arg2 ) )
                {
                        amount = atoi( arg2 );
                        if (amount > ch->pcdata->quest )
                        {
                                sprintf( buf, "How can you deposit %d QP when you only have %d?\n\r", amount, ch->pcdata->quest ); 
                                do_say(mob, buf );
                                return;
                        }

                        if (amount < 0 )
                        {
                                do_say (mob, "Only positive amounts allowed...");
                                return;
                        }

                        ch->pcdata->quest -= amount;
                        ch->pcdata->balance += amount;
                        sprintf ( buf, "You deposit %d QP.  Your new balance is %d QP.\n\r",
                        amount, ch->pcdata->balance );
                        send_to_char( buf, ch );
                        do_save( ch, "" );
                        return;
                }
        }

        /* We only allow transfers if this is true... so define it... */

#if defined BANK_TRANSFER
        if ( !str_prefix( arg1, "transfer" ) )
        {
                int amount;
                CHAR_DATA *victim;

                if ( is_number ( arg2 ) )
                {
                        amount = atoi( arg2 );
                        if ( amount > ch->pcdata->balance )
                        {
                                sprintf( buf, "How can you transfer %d QP when your balance is %d?\n\r",
                                amount, ch->pcdata->balance );
                                do_say( mob, buf);
                                return;
                        }

                        if (amount < 0 )
                        {
                                do_say (mob, "Only positive amounts allowed...");
                                return;
                        }

                        if ( !( victim = get_char_world( ch, argument ) ) )
                        {
                                sprintf (buf, "%s doesn't have a bank account.\n\r", argument );
                                do_say( mob, buf );
                                return;
                        }

                        if (IS_NPC(victim))
                        {
                                do_say( mob, "You can only transfer money to players.");
                                return;
                        }

                        ch->pcdata->balance     -= amount;
                        victim->pcdata->balance += amount;
                        sprintf( buf, "You transfer %d QP. Your new balance is %d QP.\n\r",
                        amount, ch->pcdata->balance );
                        send_to_char( buf, ch );
                        sprintf (buf, "[BANK] %s has transferred %d qp's to your account.\n\r", ch->name, amount); 
                        send_to_char( buf, victim );
                        do_save( ch, "" );
                        do_save( victim, "");
                        return;
                }
        }
#endif

        if ( !str_prefix( arg1, "withdraw" ) )
        {
                int amount;

                if ( is_number ( arg2 ) )
                {
                        amount = atoi( arg2 );
                        if ( amount > ch->pcdata->balance )
                        {
                                sprintf( buf, "How can you withdraw %d QP when your balance is %d?\n\r",
                                amount, ch->pcdata->balance );
                                do_say (mob, buf );
                                return;
                        }

                        if (amount < 0 )
                        {
                                do_say( mob, "Only positive amounts allowed...");
                                return;
                        }

                        ch->pcdata->balance -= amount;
                        ch->pcdata->quest += amount;
                        sprintf( buf, "You withdraw %d QP.  Your new balance is %d QP.\n\r", amount, ch->pcdata->balance );
                        send_to_char( buf, ch );
                        do_save( ch, "" );
                        return;
                }
        }

        /* If you want to have an invest option... define BANK_INVEST */

#if defined BANK_INVEST
        if ( !str_prefix( arg1, "buy" ) )
        {
                int amount;

                if ( is_number ( arg2 ) )
                {
                        amount = atoi( arg2 );
                        if ( (amount * share_value) > ch->pcdata->balance )
                        {
                                sprintf( buf, "%d shares will cost you %d, get more money.\n\r", amount, (amount * share_value) );
                                do_say(mob, buf);
                                return;
                        }

                        if (amount < 0 )
                        {
                                do_say(mob, "If you want to sell shares you have to say so...");
                                return;
                        }

                        ch->pcdata->balance -= (amount * share_value);
                        ch->pcdata->shares  += amount;
                        sprintf( buf, "You buy %d shares for %d QP, you now have %d shares.\n\r", amount, (amount * share_value), ch->pcdata->shares );
                        do_say(mob, buf);
                        do_save( ch, "" );
                        return;
                }
        }

        if ( !str_prefix( arg1, "sell" ) )
        {
                int amount;

                if ( is_number ( arg2 ) )
                {
                        amount = atoi( arg2 );
                        if ( amount > ch->pcdata->shares )
                        {
                                sprintf( buf, "You only have %d shares.\n\r", ch->pcdata->shares );
                                do_say(mob, buf);
                                return;
                        }

                        if (amount < 0 )
                        {
                                do_say (mob, "If you want to buy shares you have to say so...");
                                return;
                        }

                        ch->pcdata->balance += (amount * share_value);
                        ch->pcdata->shares  -= amount;
                        sprintf( buf, "You sell %d shares for %d QP, you now have %d shares.\n\r", amount, (amount * share_value), ch->pcdata->shares );
                        do_say (mob, buf);
                        do_save( ch, "" );
                        return;
                }
        }

        if ( !str_prefix( arg1, "check" ) )
        {
                sprintf (buf, "The current shareprice is %d.\n\r",share_value);
                do_say(mob, buf);
                if (ch->pcdata->shares)
                {
                    sprintf (buf, "You currently have %d shares, (%d a share) worth a total of %d qp.\n\r",
                        ch->pcdata->shares, share_value, (ch->pcdata->shares * share_value) ); 
                    do_say(mob, buf);
                }
                return;
        }
#endif

        do_say(mob, "I don't know what you mean");
        do_bank( ch, "" );              /* Generate Instructions */
        return;
}

