/*******************************************************
 *  Elemental class redesigned for Death's Domain Mud  *
 *  by Wolfman (c) 2001. Elemental Class is originally *
 *  from the WotK codebase.			       *
 *******************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"
#include "element.h" 


void do_study( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );

    if (IS_NPC(ch)) return; 
    if (!IS_CLASS(ch, CLASS_ELEMENT))
    {
	send_to_char("Huh?\n\r",ch);
        return; 
    }
    if (arg1[0] == '\0' && arg2[0] == '\0')
    {
	sprintf(buf,"Elemental: Fire (%d), Water (%d), Wind (%d), Earth (%d), Spirit (%d).\n\r",
	ch->pcdata->powers[EL_FIRE], ch->pcdata->powers[EL_WATER],
	ch->pcdata->powers[EL_WIND], ch->pcdata->powers[EL_EARTH],
	ch->pcdata->powers[EL_SPIRIT]);
	send_to_char(buf,ch);
	return;
	}
	if (arg2[0] == '\0')
	{
        if (!str_cmp(arg1,"fire")) 
        {
            if (ch->pcdata->powers[EL_FIRE] < 1)
		send_to_char("You have no fire powers yet.\n\r",ch);
            if (ch->pcdata->powers[EL_FIRE] > 0)
            	send_to_char("#RFireStorm - Send a firey tornado at your opponent.\n\r",ch);
            if (ch->pcdata->powers[EL_FIRE] > 1)
            	send_to_char("#RFlame Assist - Extra attack per round.\n\r",ch);
            if (ch->pcdata->powers[EL_FIRE] > 2)
            	send_to_char("#RFlameTrue - Improve your flameblades.\n\r",ch);
            if (ch->pcdata->powers[EL_FIRE] > 3)
            	send_to_char("#RFire General - You are a higher rank and get an increased damcap.\n\r",ch);
            if (ch->pcdata->powers[EL_FIRE] > 4)
            	send_to_char("#RFireBless - An Elemental Bless.\n\r",ch);
            if (ch->pcdata->powers[EL_FIRE] > 5)
            	send_to_char("#RMeteorStorm - Pray to a fire diety and call forth a meteorstorm on your enemy.\n\r",ch);
            if (ch->pcdata->powers[EL_FIRE] > 6)
            	send_to_char("#RElementalform - You transform into a fire elemental.\n\r",ch);
	    if (ch->pcdata->powers[EL_FIRE] > 7)
		send_to_char("#RFireHands - Ignite your hands for a firey attack.\n\r",ch);
            return;
        }
        else if (!str_cmp(arg1,"water"))
        {
            if (ch->pcdata->powers[EL_WATER] < 1 )
            {stc("You have no water powers.\n\r",ch);return;}
            if (ch->pcdata->powers[EL_WATER] > 0)
            stc("#lSneaky Water - Super invis.\n\r",ch);
            if (ch->pcdata->powers[EL_WATER] > 1)
            stc("#lWater Assist - extra attack per round.\n\r",ch);
            if (ch->pcdata->powers[EL_WATER] > 2)
            stc("#lRipTide - improve your RushDaggers.\n\r",ch);
            if (ch->pcdata->powers[EL_WATER] > 3)
            stc("#lWater Lord - You are a higher rank, and get an increased damcap.\n\r",ch);
            if (ch->pcdata->powers[EL_WATER] > 4)
            stc("#lWaterBind - entrap your enemy in water.\n\r",ch);
            if (ch->pcdata->powers[EL_WATER] > 5)
            stc("#lWaterwall - Create walls of water.\n\r",ch);
            if (ch->pcdata->powers[EL_WATER] > 6)
            stc("#lTsunami- The Water God summons a Tsunami to attack your foes.\n\r",ch);
            if (ch->pcdata->powers[EL_WATER] > 7)
            stc("#lWater Transform - Turn into a Water Elemental.\n\r",ch);
            return;
        }
        else if (!str_cmp(arg1,"wind"))
        {
            if (ch->pcdata->powers[EL_WIND] < 1 )
            {stc("You have no wind powers.\n\r",ch);return;}
            if (ch->pcdata->powers[EL_WIND] > 0)
            stc("Air Shriek: a powerful curse from the wind god.\n\r",ch);
            if (ch->pcdata->powers[EL_WIND] > 1)
            stc("Wind Assist: A small blast of wind knocks the wind out of the enemy.\n\r",ch);
            if (ch->pcdata->powers[EL_WIND] > 2)
            stc("Wind Ruler: You are promoted to the Wind Ruler, extra damcap and can recruit wind warriors.\n\r",ch);
            if (ch->pcdata->powers[EL_WIND] > 3)
            stc("Tornado: A tornado brings you to your enemies.\n\r",ch);
            if (ch->pcdata->powers[EL_WIND] > 4)
            stc("Wind Crush: A Powerful Attack with your Wind Staves.\n\r",ch);
            if (ch->pcdata->powers[EL_WIND] > 5)
            stc("Wind God: The Wind God causes a tornadoe to strike your enemies.\n\r",ch);
            if (ch->pcdata->powers[EL_WIND] > 6)
            stc("Wind Transform: Transform into the Wind Elemental Ruler.\n\r",ch);
	    if (ch->pcdata->powers[EL_WIND] > 7)
	    stc("Hurricane: Gain the speed of a force 5 hurricane to defeat your enemies.\n\r",ch);
            return;
        }
        else if (!str_cmp(arg1,"earth"))
        {
            if (ch->pcdata->powers[EL_EARTH] < 1)
            {stc("You have no earth powers.\n\r",ch);return;}
            if (ch->pcdata->powers[EL_EARTH] > 0)
            stc("Earth Reinforce: add extra powers to equipment.\n\r",ch);
            if (ch->pcdata->powers[EL_EARTH] > 1)
            stc("Earth Assist: You hurl boulders at your opponents.\n\r",ch);
            if (ch->pcdata->powers[EL_EARTH] > 2)
            stc("Earth Hammers: Improve your Earth Hammers Greatly.\n\r",ch);
            if (ch->pcdata->powers[EL_EARTH] > 3)
            stc("Earth Saint: Upgraded rank, extra damcap and can create earth minions.\n\r",ch);
            if (ch->pcdata->powers[EL_EARTH] > 4)
            stc("Earth Bless: Enchant your weapons with the power of earth.\n\r",ch);
            if (ch->pcdata->powers[EL_EARTH] > 5)
            stc("Earth Smash: Crush your opponent with both hammers at the same time.\n\r",ch);
            if (ch->pcdata->powers[EL_EARTH] > 6)
            stc("Avalanche: The Earth God causes an avalanche to destroy your opponent's armor.\n\r",ch);
            if (ch->pcdata->powers[EL_EARTH] > 7)
            stc("Earth Form: Transform into The Earth Saint.\n\r",ch);
            return;
        }
        else if(!str_cmp(arg1,"spirit"))
        {
            if (ch->pcdata->powers[EL_SPIRIT] < 1)
            {stc("You have no Spirit Powers.\n\r",ch);return;}
            if (ch->pcdata->powers[EL_SPIRIT] > 0)
            stc("Spirit Absorb: Absorb your spirit weapons and your arms will shift between them in battle.\n\r",ch);
            if (ch->pcdata->powers[EL_SPIRIT] > 1)
            stc("Spirit Assist: All 4 elementals attack your enemy, and the spirit guardian heals you.\n\r",ch);
            if (ch->pcdata->powers[EL_SPIRIT] > 2)
            stc("True Spirit: Enchant your blasters.\n\r",ch);
            if (ch->pcdata->powers[EL_SPIRIT] > 3)
            stc("Spirit Guardian: Upgrade Your rank to Spirit Guardian.\n\r",ch);
            if (ch->pcdata->powers[EL_SPIRIT] > 4)
            stc("Spirit Kill: When you surprise attack, you do 2x your damcap.\n\r",ch);
            if (ch->pcdata->powers[EL_SPIRIT] > 5)
            stc("Spirit Sense: Ultimate Truesight, see everything.\n\r",ch);
            if (ch->pcdata->powers[EL_SPIRIT] > 6)
            stc("Elemental Blast: All of the elementals come to your aid and blast your opponent.\n\r",ch);
            if (ch->pcdata->powers[EL_SPIRIT] > 7)
            stc("Spirit Trueform: Transform into the Spirit Guardian!\n\r",ch);
            return;
        }
            sprintf(buf,"Fire (%d), Water (%d), Wind (%d), Earth (%d), Spirit (%d).\n\r",
            ch->power[EL_FIRE],ch->power[EL_WATER],ch->power[EL_WIND], 
            ch->power[EL_EARTH],ch->power[EL_SPIRIT]); 
            stc(buf,ch);
            return;
    }
    if(!str_cmp(arg2,"improve"))
    {
        int improve;
	int cost;
        int max;
 
        if (!str_cmp(arg1,"fire")) { improve = EL_FIRE;max=7;}
        else if(!str_cmp(arg1,"water")) { improve = EL_WATER;max=8;}
        else if(!str_cmp(arg1,"wind")) { improve = EL_WIND;max=7;}
        else if(!str_cmp(arg1,"earth")) { improve = EL_EARTH;max=8;}
        else if(!str_cmp(arg1,"spirit")){ improve = EL_SPIRIT;max=8;}
        else
        {
            stc("Syntax: study (fire/water/wind/earth/spirit) improve\n\r",ch);
            return;
        }
        cost = (ch->pcdata->powers[improve]+1) * 10;
	arg1[0] = UPPER(arg1[0]);
        if (ch->pcdata->powers[improve] >= max)
	{
			sprintf(buf,"You already have all of your %s powers.\n\r", arg1);
                        send_to_char(buf,ch);
			return;}
        if (cost > ch->practice )
        {
            sprintf(buf,"You do not have the %d primal to improve %s.\n\r",cost, arg1);
            stc(buf,ch);
            return;
        }
	ch->pcdata->powers[improve] += 1;
        ch->practice -= cost;
        sprintf(buf,"You improve your %s power.\n\r",arg1);
        stc(buf,ch);
	}
	if (ch->pcdata->powers[EL_FIRE] > 4 &&
	    ch->pcdata->powers[EL_WATER] < 4 &&
	    ch->pcdata->powers[EL_WIND] < 4 &&
	    ch->pcdata->powers[EL_EARTH] < 4 &&
	    ch->pcdata->powers[EL_SPIRIT] < 4 ) 
	{
	ch->generation = 4; 
	return;}

	if (ch->pcdata->powers[EL_FIRE] > 4 &&
	    ch->pcdata->powers[EL_WATER] > 4 &&
	    ch->pcdata->powers[EL_WIND] < 4 &&
	    ch->pcdata->powers[EL_EARTH] < 4 &&
	    ch->pcdata->powers[EL_SPIRIT] < 4 ) 
	{
	ch->generation = 3; 
	return;}
	if (ch->pcdata->powers[EL_FIRE] > 4 &&
            ch->pcdata->powers[EL_WATER] > 4 &&
            ch->pcdata->powers[EL_WIND] > 4 &&
            ch->pcdata->powers[EL_EARTH] < 4 &&
            ch->pcdata->powers[EL_SPIRIT] < 4 )
	{
        ch->generation = 2;
	return;}
        if (ch->pcdata->powers[EL_FIRE] > 4 &&
            ch->pcdata->powers[EL_WATER] > 4 &&
            ch->pcdata->powers[EL_WIND] > 4 &&
            ch->pcdata->powers[EL_EARTH] > 4 &&
            ch->pcdata->powers[EL_SPIRIT] < 4 )
	{
	ch->generation = 1;
	return;}
        if (ch->pcdata->powers[EL_FIRE] > 4 &&
            ch->pcdata->powers[EL_WATER] > 4 &&
            ch->pcdata->powers[EL_WIND] > 4 &&
            ch->pcdata->powers[EL_EARTH] > 4 &&
            ch->pcdata->powers[EL_SPIRIT] > 4 )
	{
	ch->generation = 0;
	return;
   }
}
void do_elementalform( CHAR_DATA *ch, char *argument )  {
	char arg[MAX_INPUT_LENGTH]; 
        char buf1[MAX_STRING_LENGTH];
	argument = one_argument( argument, arg);

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch,CLASS_ELEMENT))
        {return;}
	
	if (IS_AFFECTED(ch, AFF_POLYMORPH))
	{
	stc("You return to normal form.\n\r",ch);
	REMOVE_BIT(ch->affected_by,AFF_POLYMORPH);
        clear_stats(ch);
        free_string( ch->morph );
        ch->morph = str_dup( "" );
	return;
	}	

	if (arg[0] == '\0')
	{
	stc("Syntax: elementalform (fire wind water earth spirit)\n\r",ch);
	return;
	}
	else if (!str_cmp(arg,"fire"))
	{
	if (ch->pcdata->powers[EL_FIRE] < 7)
	{
        stc("You need to have fire power 7 to do that.\n\r",ch);
	return;
	}
	else
	{
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
	clear_stats(ch);
	ch->hitroll += 900;
	ch->damroll += 900;
	ch->armor -= 2500;
        sprintf(buf1, "%s the Huge fire elemental", ch->name);
	free_string(ch->morph);
        ch->morph = str_dup(buf1);
	SET_BIT(ch->affected_by,AFF_POLYMORPH);
	return;
	}
	}
        else if (!str_cmp(arg,"water"))
        {
        if (ch->pcdata->powers[EL_WATER] < 8)
        {
        stc("You need to be maxxed in the water power to do that.\n\r",ch);
        return;
        }
        else
        {
          if (ch->stance[0] != -1) do_stance(ch,"");
          if (ch->mounted == IS_RIDING) do_dismount(ch,"");
          clear_stats(ch);
          ch->hitroll += 750;
          ch->damroll += 750;
          ch->armor -= 4000;
          sprintf(buf1, "%s the Large water elemental", ch->name);
          free_string(ch->morph);
          ch->morph = str_dup(buf1);
          SET_BIT(ch->affected_by,AFF_POLYMORPH);
          return;
        }
        }
        else if (!str_cmp(arg,"wind"))
        {
        if (ch->pcdata->powers[EL_WIND] < 7)
        {
        stc("You need to be maxxed in the wind power to do that.\n\r",ch);
        return;
        }
        else
        {
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        clear_stats(ch);
        ch->hitroll += 650;
        ch->damroll += 650;
        ch->armor -= 4500;
        sprintf(buf1, "%s the small wind elemental", ch->name);
	free_string(ch->morph);
        ch->morph = str_dup(buf1);
        SET_BIT(ch->affected_by,AFF_POLYMORPH);
        return;
        }
        }
        else if (!str_cmp(arg,"earth"))
        {
        if (ch->pcdata->powers[EL_EARTH] < 8)
        {
        stc("You need to be maxxed in the Earth power to do that.\n\r",ch);
        return;
        }
        else
        {
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        clear_stats(ch);
        ch->hitroll += 900;
        ch->damroll += 900;
	ch->armor -= 6000;
        sprintf(buf1, "%s the Enermous earth Saint", ch->name);
	free_string(ch->morph);
        ch->morph = str_dup(buf1);
        SET_BIT(ch->affected_by,AFF_POLYMORPH);
        return;
        }
        }
        else if (!str_cmp(arg,"spirit"))
        {
        if (ch->pcdata->powers[EL_SPIRIT] < 8)
        {
        stc("You need to be maxxed in the spirit power to do that.\n\r",ch);
        return;
        }
        else
        {
	clear_stats(ch);
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        ch->hitroll += 1800;
        ch->damroll += 1800;
	ch->armor -= 9000;
        sprintf(buf1, "%s the Spirit God", ch->name);
	free_string(ch->morph);
        ch->morph = str_dup(buf1);
        SET_BIT(ch->affected_by,AFF_POLYMORPH);
        return;
        }
        }
	else
	{stc("Syntax: elementalform (fire/earth/wind/water/spirit)\n\r",ch);
	return;
	}
	return;
}
void do_elemweapon( CHAR_DATA *ch, char *argument )
{
    OBJ_INDEX_DATA *pObjIndex;
    OBJ_DATA *obj; 
    char arg[MAX_INPUT_LENGTH];
    int vnum = 0;
    argument = one_argument( argument, arg );
         
    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_ELEMENT))
	{stc("Huh?\n\r",ch);return;}

	if (arg[0] == '\0')
	{
	stc("syntax: elemweapon (flameblade/rushdagger/windstave/earthhammer/spiritblaster)\n\r",ch);
	stc("(Note: you must have at least 1 in a power to get the weapon.\n\r",ch);
	return;
	}
	else if(!str_cmp(arg,"flameblade"))
	{
	if (ch->pcdata->powers[EL_FIRE] < 1)
	{
	stc("You need at least a little fire power before you can create flameblades.\n\r",ch);
	return;
	}
	else vnum = 33363;
	}
	else if(!str_cmp(arg,"rushdagger"))
	{
	if (ch->pcdata->powers[EL_WATER] < 1)
	{
	stc("You need at least a little water power to make rushdaggers.\n\r",ch);
	return;
	}
	else vnum = 33364;
	}
	else if(!str_cmp(arg,"windstave"))
	{
	if (ch->pcdata->powers[EL_WIND] < 1)
	{
	stc("You need at least a little wind power to make windstaves.\n\r",ch);
	return;
	}
	else vnum = 33365;
	}
	else if(!str_cmp(arg,"earthhammer"))
	{
	if (ch->pcdata->powers[EL_EARTH] < 1)
	{
	stc("You need at least a little earth power to create earth hammers.\n\r",ch);
	return;
	}
	else vnum = 33366;
	}
	else if (!str_cmp(arg,"spiritblaster"))
	{
	if (ch->pcdata->powers[EL_SPIRIT] < 1)
	{
	stc("You need at least 1 spirit power before you can make the blasters.\n\r",ch);
	return;
	}
	else vnum = 33367;
	}
	else
	{
        stc("syntax: elemweapon (flameblade/rushdagger/windstave/earthhammer/spiritblaster)\n\r",ch);
        stc("(Note: you must have at least 1 in a power to get the weapon.\n\r",ch);
        return;
        }

        if (ch->practice < 150)
	{
        stc("You do not have the required 150 primal points.\n\r",ch); 
	return;
	}

    if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
    {
        send_to_char("Missing object, please inform an imp.\n\r",ch);
        return;
    }
    ch->practice -= 150;
    obj = create_object(pObjIndex, 50);
    obj->questowner = str_dup(ch->name);
    obj->questmaker = str_dup(ch->name);
    obj->value[1] = 50;
    obj->value[2] = 100;
      
    SET_BIT(obj->quest, QUEST_RELIC);
    obj_to_char(obj, ch);
    act("$p appears in your hands in a great explosion.",ch,obj,NULL,TO_CHAR);
    act("$p appears in $n's hands in a great explosion.",ch,obj,NULL,TO_ROOM);
    return;
}

void do_sneakywater( CHAR_DATA *ch, char *argument )
{
    if (IS_NPC(ch)) return;
         
        if (!IS_CLASS(ch, CLASS_ELEMENT) )
        {
                send_to_char("Huh?\n\r", ch);
                return;
        }
        
        if (IS_CLASS(ch, CLASS_ELEMENT) && ch->pcdata->powers[EL_WATER] < 1)
        {
          send_to_char("You need a little water power to be absorbed in water.\n\r", ch);
          return;
        }

    if ( IS_SET(ch->act, PLR_WIZINVIS) )
    {
        REMOVE_BIT(ch->act, PLR_WIZINVIS);
        act( "$n reforms from water.", ch, NULL, NULL, TO_ROOM );
        send_to_char( "You reform from water.\n\r", ch );
    }
    else
    {   
        act( "$n is absorbed into water.", ch, NULL, NULL, TO_ROOM );
        send_to_char( "You are absorbed into water.\n\r", ch );
        SET_BIT(ch->act, PLR_WIZINVIS);
    }
    return;
}

void do_elementarmor( CHAR_DATA *ch, char *argument )                             
{                                                                               
    OBJ_INDEX_DATA *pObjIndex;                                                  
    OBJ_DATA *obj;                                                              
    char arg[MAX_INPUT_LENGTH];                                                 
    int vnum = 0;                                                               

    argument = one_argument( argument, arg );                                   

    if (IS_NPC(ch)) return;                                                     
        if(!IS_EMPLOYEE(ch))                                                    
        {                                                                       
    if (!IS_CLASS(ch, CLASS_ELEMENT))                                             
    {                                                                           
        send_to_char("What?\n\r",ch);                                           
        return;                                                                 
    }                                                                           
        }                                                                       
    if (arg[0] == '\0')                                                         
    {                                                                           
    send_to_char("Please specify which piece of elemental eq you wish to make: Ring Collar Bracer Plate Leggings Sleeves Boots Mask Helmet Belt Cloak.\n\r",ch); 
    return;                                                                     
    }                                                                           
    if ( ch->practice < 75 )                                            
    {                                                                           
       send_to_char("You don't have the 75 primal needed.\n\r",ch);            
        return;                                                                 
    }                                                                           
    if (!str_cmp(arg,"ring"     )) vnum = 33352;                                
    else if (!str_cmp(arg,"collar" )) vnum = 33353;                             
    else if (!str_cmp(arg,"bracer"   )) vnum = 33354;
    else if (!str_cmp(arg,"plate"    )) vnum = 33355;                            
    else if (!str_cmp(arg,"leggings"  )) vnum = 33356; 
    else if (!str_cmp(arg,"sleeves"   )) vnum = 33357;                           
    else if (!str_cmp(arg,"boots"   )) vnum = 33358;                             
    else if (!str_cmp(arg,"mask"   )) vnum = 33359;                              
    else if (!str_cmp(arg,"helmet"   )) vnum = 33360;                         
    else if (!str_cmp(arg,"belt"   )) vnum = 33361;                            
    else if (!str_cmp(arg,"cloak"   )) vnum = 33362;                           
    else                                                                        
    {                                                                           
    do_elementarmor(ch,"");                                             
    return;                                                                     
    }                                                                           
    if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)              
    {                                                                           
    send_to_char("Missing object, please inform a God .\n\r",ch);               
    return;                                                                     
    }                                                                           
    ch->practice -= 75;                                             
    obj = create_object(pObjIndex, 50);                                         
    obj->questowner = str_dup(ch->pcdata->switchname);                          
    obj_to_char(obj, ch);                                                       
    act("$p comes to you in a blast of flames.",ch,obj,NULL,TO_CHAR);       
    act("$p arrives in a blast of flames",ch,obj,NULL,TO_ROOM);             
    return;                                                                     
}                                                                               

void do_tornado (CHAR_DATA *ch, char *argument) 
{
        CHAR_DATA *victim;                                                      
        char arg[MAX_STRING_LENGTH];                                            
        ROOM_INDEX_DATA *location;                                              

        one_argument (argument, arg);                                           

        if (IS_NPC(ch)) return;                                                 
        if (!IS_CLASS(ch, CLASS_ELEMENT))                  
        {                                                                       
                send_to_char("Huh?\n\r",ch);                                    
                return;                                                         
        }                                                                       
        if (IS_CLASS(ch, CLASS_ELEMENT) && ch->hit < 1 )                          
        {                                                                       
                send_to_char("You are too start up a tornado.\n\r",ch);
                return;                                                         
        }                                                                       
        if (IS_CLASS(ch, CLASS_ELEMENT) && ch->position == POS_SLEEPING)          
        {                                                                       
                send_to_char("You can't start up a tornado while SLEEPING!!\n\r",ch);
                return; 
        }                                                                       
        if (IS_CLASS(ch, CLASS_ELEMENT) && ch->position == POS_RESTING)           
        {                                                                       
                send_to_char("You must be standing in order to start up a tornado.\n\r",ch);
                return;                                                         
        }                                                                       
        else if (ch->pcdata->powers[EL_WIND] < 4 )                          
        {                                                                       

                send_to_char( "You need wind 4 to make a tornado.\n\r",ch);
                return;                                                         
        }                                                                       
        if ((victim = get_char_world(ch, arg)) == NULL)                         
        {                                                                       
                send_to_char("Where is your tornado going to take you?\n\r", ch );
                return;                                                         
        }                                                                       
    if (ch->fight_timer > 0)                                                    
    {                                                                           
     stc( "No tornadoes with a fight timer.\n\r",ch);                    
      return;                                                                   
        }                                                                       
        location = victim->in_room;                                             
        act("You stir up the winds around you into a tornado and fly away in the wind.\n\r",ch, NULL, NULL, TO_CHAR);
        act("$n stirs the winds in the room up into a tornado, and is sucked inside as the tornado moves away.\n\r",ch, NULL, NULL, TO_ROOM);
        char_from_room(ch); 
        char_to_room(ch, location);                                             
        do_look(ch, "auto");                                                    
        act("As the tornado dies away, you find yourself in another place!\n\r",ch, NULL, NULL, TO_CHAR);
        act("As a tornado whisks into the room, it dies away, and $n falls out.\n\r",ch, NULL, NULL, TO_ROOM);
        WAIT_STATE(ch, 2);                                                      
        return;                                                                 
}                                                                               
void do_flametrue(CHAR_DATA *ch, char *argument) 
{
  char arg[MAX_STRING_LENGTH];                                                  
  OBJ_DATA *obj;                                                                
  argument=one_argument(argument,arg);                                          
  if (IS_NPC(ch)) return;                                                       

  if (!IS_CLASS(ch,CLASS_ELEMENT))                                              
  {                                                                             
     send_to_char("Huh?\n\r",ch);                                               
     return;                                                                    
  }                                                                             
  if (ch->pcdata->powers[EL_FIRE] < 3)                                            
  {                                                                             
     send_to_char("You need Fire 3 to use flametrue.\n\r",ch);                     
     return;                                                                    
  }                                                                             
  if (arg[0] == '\0')                                                           
  {                                                                             
     send_to_char("Which flameblade are you going to sharpen?\n\r",ch);                       
     return;                                                                    
  }                                                                             
  if ( ( obj = get_obj_carry(ch,arg) ) == NULL )                                
  {                                                                             
     send_to_char("Where's your flameblade?\n\r",ch);                         
     return;                                                                    
  }                                                                             
  if (obj->item_type != ITEM_WEAPON || obj->pIndexData->vnum != 33363)      
  {                                                                             
     send_to_char("That isn't a flameblade!\n\r",ch);                        
     return;                                                                    
  }                                                                             
  if (obj->value[0] == 18000)                                                   
  {                                                                             
     send_to_char("This flameblade is already sharp!\n\r",ch);                        
     return;                                                                    
  }                                                                             
  obj->value[0] = 18000;
  obj->value[1] += 50;
  obj->value[2] += 50;
  sprintf(arg, "You grind away at %s until it is razor sharp!",obj->short_descr); 
  send_to_char(arg,ch);                                                         
  sprintf(arg, "%s grinds away at %s until it is razor sharp!",ch->name,obj->short_descr);
  act(arg,ch,NULL,NULL,TO_ROOM);                                                
  return;                                                                       
}                                                                               

void do_firestorm(CHAR_DATA *ch, char *argument)                                  
{                                                                               
CHAR_DATA *victim;
ROOM_INDEX_DATA *inroom;
char            arg1      [MAX_INPUT_LENGTH];
char            arg2      [MAX_INPUT_LENGTH];
int i;
int count;
int sn;
int level;
int spelltype; 
    argument = one_argument( argument, arg1 ); 
    argument = one_argument( argument, arg2 );
inroom= ch->in_room;

 if (IS_NPC(ch)) return; 
 if (!IS_CLASS(ch,CLASS_ELEMENT)) 
  {                                                                             
 send_to_char("Huh?\n\r",ch);                                                  
  return;                                                                       
  }                                                                             
 if (ch->pcdata->powers[EL_FIRE] < 1)                                             
  {                                                                             
  send_to_char("You need fire 1 to use firestorm.\n\r",ch);                  
  return;                                                                       
  }                                                                             
 if (IS_SET(ch->in_room->room_flags,ROOM_FLAMING))                              
  {                                                                             
  send_to_char("There is already a firestorm in this room!\n\r",ch);              
  return;                                                                       
  }                                                                             
 if (IS_SET(ch->in_room->room_flags, ROOM_SAFE))                                 
 {                                                                               
 send_to_char("Not in a safe room, please.\n\r",ch);          
 return;                                                                         
 }                                                                               
    if ( arg1[0] == '\0' )
    {
 send_to_char("Who are you going to firestorm?\n\r", ch);
 return;
 }
     if ( ( victim = get_char_room( ch, arg1 ) ) == NULL )
   {
        send_to_char("They are not here.\n\r", ch);
	return;
   }
 if ( victim == ch )
 {
 send_to_char( "Not on yourself!\n\r", ch );
 return;
 }
        if (ch->mana < 500)
 {
                send_to_char("You need 500 mana or more.\n\r", ch);
                return;
 }
 SET_BIT(inroom->room_flags,ROOM_FLAMING); 
 act("You ignite yourself and spin wildly around, touching off a firey tornado.", ch, NULL, victim, TO_CHAR); 
 act("$n ignites an arm and spins wildly around, touching off a firey tornado.", ch, NULL, victim, TO_NOTVICT); 
 act("$n ignites an arm and spins wildly around, touching off a firey tornado.", ch, NULL, victim,TO_VICT);
     if (victim->position == POS_DEAD || ch->in_room != victim->in_room)         
      return;
    count = 0; 
    for (i = 0;i<3;i++)                                                         
    {                                                                           
      if (i==0) {sn = skill_lookup("flamestrike");}
    spelltype = skill_table[sn].target;
    level = ch->spl[spelltype]*5;
    (*skill_table[sn].spell_fun) ( sn, level, ch, victim );
      if (i==1) {sn = skill_lookup("fireball");}
    spelltype = skill_table[sn].target;
    level = ch->spl[spelltype]*5;
    (*skill_table[sn].spell_fun) ( sn, level, ch, victim );
      if (i==2) {sn = skill_lookup("fire breath");}
    spelltype = skill_table[sn].target;
    level = ch->spl[spelltype]*5;
    (*skill_table[sn].spell_fun) ( sn, level, ch, victim );
        continue; 
      count++;                                                                  
    }
    SET_BIT(victim->affected_by, AFF_FLAMING);
    ch->mana = ch->mana - 500; 
    WAIT_STATE(ch,2);                                                           
    return;                                                                     
  }                                                                             

void do_firebless (CHAR_DATA *ch, char *argument)                                   
{                                                                               
  char arg1[MAX_STRING_LENGTH];                                                 
  CHAR_DATA *victim;                                                            
  AFFECT_DATA af;                                                               
  int i, dam, count, sn;                                                        
  int red_magic = ch->spl[RED_MAGIC];                                           

  argument=one_argument(argument,arg1);                                         

  if (IS_NPC(ch)) return;                                                       

  if (!IS_CLASS(ch, CLASS_ELEMENT))                                                
  {                                                                             
    send_to_char("Huh?\n\r",ch);                                                
    return;                                                                     
  }
  if (ch->pcdata->powers[EL_FIRE] < 5)
  {
    send_to_char("You need fire 5 to use firebless.\n\r",ch);
    return;
  }
  if (arg1[0] == '\0') 
  {                                                                             
    send_to_char("Who do you want to fire bless?\n\r",ch); 
    return;                                                                     
  }                                                                             
    if ((victim = get_char_room(ch, arg1)) == NULL)                             
    {                                                                           
      send_to_char("They are not here.\n\r", ch );                              
      return;                                                                   
    }                                                                           
    if (ch->mana < 2500)                                                         
    {                                                                           
      send_to_char("You need 2500 mana.\n\r",ch);                               
      return;                                                                   
    }                                                                           
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room)         
      return;
    if (ch->fighting != NULL) return;                                                                   
    count = 0; 
    for (i = 0; i<1 ; i++)                                                      
    {                                                                           
      if (i==0) {sn = skill_lookup("red sorcery");dam=red_magic;}               
      if (is_affected(victim, sn))                                              
        continue;                                                               
      count++;                                                                  
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_HIT;                                                 
      af.modifier  = dam*2;                                                     
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_AC;                                                  
      af.modifier  = -dam/2;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_MOVE;                                                
      af.modifier  = dam*2;                                                     
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_MANA;                                                
      af.modifier  = dam*2;                                                     
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_HITROLL;                                             
      af.modifier  = dam/3;                                                     
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_DAMROLL;                                             
      af.modifier  = dam/3;                                                     
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
    }                                                                           
    ch->mana -= count * 500;                                                    
    WAIT_STATE(ch,6);                                                           
    act("You firebless $N.\n\r", ch, NULL, victim, TO_CHAR);                                       
    act("You have been fireblessed.\n\r", ch, NULL, victim, TO_VICT); 
    return;                                                                     
}                                                                             
void do_meteorstorm(CHAR_DATA *ch, char *argument)                                 
{                                                                               
    CHAR_DATA *vch, *vch_next;                                                  
    if(IS_NPC(ch)) return;
    if(!IS_CLASS(ch, CLASS_ELEMENT))
    {
	send_to_char("Huh?\n\r",ch);
	return;
    }
    if (ch->pcdata->powers[EL_FIRE] < 6)
    {
	send_to_char("You need fire 6 in order to use meteorstorm.\n\r",ch);
    	return;
    }
    act("$n prays to a fire diety, and calls forth a meteorstorm!!",ch, NULL, NULL, TO_ROOM);
    send_to_char("You pray to a fire diety, and call forth a meteorstorm!!\n\r",ch);       
    for (vch = ch->in_room->people; vch != NULL; vch = vch_next)                
    {                                                                           
            vch_next = vch->next_in_room;                                       
            if (vch != ch)                                                      
            {                                                                   
                damage(ch, vch, number_range(1500,2000), gsn_inferno);          
                damage(ch, vch, number_range(1500,2000), gsn_inferno);
                fire_effect(vch, ch->level, 2000, TARGET_CHAR);                 
            }                                                                   
    }                                                                           
    WAIT_STATE(ch, 4);                                                         
    SET_TIMER(ch, TIMER_INFERNO, 25);                                           
}                                                                               

void do_riptide(CHAR_DATA *ch, char *argument)                                
{                                                                               
  char arg[MAX_STRING_LENGTH];                                                  
  OBJ_DATA *obj;                                                                
  argument=one_argument(argument,arg);                                          
  if (IS_NPC(ch)) return;                                                       

  if (!IS_CLASS(ch,CLASS_ELEMENT))                                              
  {                                                                             
     send_to_char("Huh?\n\r",ch);                                               
     return;                                                                    
  }                                                                             
  if (ch->pcdata->powers[EL_WATER] < 3)
  {                                                                             
     send_to_char("You need Water 3 to use riptide.\n\r",ch);
     return;                                                                    
  }                                                                             
  if (arg[0] == '\0')                                                           
  {                                                                             
     send_to_char("Which rushdagger are you going to sharpen?\n\r",ch);
     return;                                                                    
  }                                                                             
  if ( ( obj = get_obj_carry(ch,arg) ) == NULL )                                
  {                                                                             
     send_to_char("Where's your rushdagger?\n\r",ch);                           
     return;                                                                    
  }                                                                             
  if (obj->item_type != ITEM_WEAPON || obj->pIndexData->vnum != 33364)
  {                                                                             
     send_to_char("That isn't a rushdagger!\n\r",ch);                           
     return;                                                                    
  }                                                                             
  if (obj->value[0] == 18000)                                                   
  {                                                                             
     send_to_char("This rushdagger is already sharp!\n\r",ch);
     return;                                                                    
  }                                                                             
  obj->value[0] = 18000;                                                        
  obj->value[1] += 50;                                                          
  obj->value[2] += 50;                                                          
  sprintf(arg, "You grind away at %s until it is razor sharp!",obj->short_descr);
  send_to_char(arg,ch);                                                         
  sprintf(arg, "%s grinds away at %s until it is razor sharp!",ch->name,obj->short_descr);
  act(arg,ch,NULL,NULL,TO_ROOM);                                                
  return;                                                                       
}                                                                               
void do_waterbind( CHAR_DATA *ch, char *argument ) 
{
    CHAR_DATA *victim;                                                          
    char arg [MAX_INPUT_LENGTH];                                                
    int sn;                                                                     
    int level;                                                                  
    int spelltype;                                                              

    argument = one_argument( argument, arg );                                   
    if (IS_NPC(ch)) return;                                                     
    if (!IS_CLASS(ch, CLASS_ELEMENT))
    {                                                                           
        send_to_char("Huh?\n\r",ch);                                            
        return;                                                                 
    }                                                                           
        if (ch->pcdata->powers[EL_WATER] < 5)
    {
	send_to_char("You need water 5 to use waterbind.\n\r", ch ); 
	return;
    }
	if ((victim = get_char_room(ch, arg)) == NULL )                        
    {                                                                           
        send_to_char( "They aren't here.\n\r", ch );                            
        return;                                                                 
    }                                                                           
    if ( ch == victim )                                                         
    {                                                                           
        send_to_char( "You trying to anger your water diety?\n\r", ch ); 
        return;                                                                 
    }                                                                           
    if ( IS_AFFECTED(victim, AFF_ETHEREAL) )                                    
    {                                                                           
        send_to_char( "The water passes right through them.\n\r", ch );  
        return;                                                                 
    }                                                                           
    if ( ( sn = skill_lookup( "waterbind" ) ) < 0 ) return;  
    spelltype = skill_table[sn].target;                                         
    level = ch->spl[spelltype] * 2;                                          
    (*skill_table[sn].spell_fun) ( sn, level, ch, victim );                     
    WAIT_STATE( ch, 5 );                                                       
    return;                                                                     
}
/*
void do_tsunami(CHAR_DATA *ch, char *argument)
{                                                                               

CHAR_DATA *victim;                                                              
ROOM_INDEX_DATA *inroom;                                                        
char            arg1      [MAX_INPUT_LENGTH];                                   
char            arg2      [MAX_INPUT_LENGTH];                                   
int i;                                                                          
int count;                                                                      
int sn;                                                                         
int level;                                                                      
int spelltype;                                                                  

    argument = one_argument( argument, arg1 );                                  
    argument = one_argument( argument, arg2 );                                  

inroom= ch->in_room;                                                            

 if (IS_NPC(ch)) return;                                                        
 if (!IS_CLASS(ch,CLASS_ELEMENT))                                               
  {                                                                             
 send_to_char("Huh?\n\r",ch);                                                   
  return;                                                                       
  }                                                                             
 if (ch->pcdata->powers[EL_WATER] < 7)
  {                                                                             
  send_to_char("You need water 7 to use tsunami.\n\r",ch);                     
  return;                                                                       
  }                                                                             
 if (IS_SET(ch->in_room->room_flags,ROOM_UNDER_WATER))                
  {                                                                             
  send_to_char("There is already a tsunami in this room!\n\r",ch);
  return;                                                                       
  }                                                                             
 if (IS_SET(ch->in_room->room_flags, ROOM_SAFE))
 {
 send_to_char("Not in a safe room, please.\n\r",ch);                            
 return;
 }
    if ( arg1[0] == '\0' )                                                      
    {                                                                           
 send_to_char("Who are you going to engulf in a tsunami?\n\r", ch);                       
 return;                                                                        
 }                                                                              
     if ( ( victim = get_char_room( ch, arg1 ) ) == NULL )                      
   {                                                                            
        send_to_char("They are not here.\n\r", ch);                             
        return;                                                                 
   }                                                                            
 if ( victim == ch )                                                            
 {                                                                              
 send_to_char( "Not on yourself!\n\r", ch );                                    
 return;                                                                        
 }                                                                              
        if (ch->mana < 500)                                                     
 {                                                                              
                send_to_char("You need 500 mana or more.\n\r", ch);             
                return;                                                         
 }                                                                              
 SET_BIT(inroom->room_flags,ROOM_FLAMING);                                      
 act("You twirl your hand in the air like you don't care... it touches off a tsunami!!", ch, NULL, victim, TO_CHAR);
 act("$n twirls $s hand in the air like $e doesn't care... it touches off a tsunami!!", ch, NULL, victim, TO_NOTVICT);
 act("$n twirls $s hand in the air like $e doesn't care... it touches off a tsunami!!", ch, NULL, victim,TO_VICT); 
     if (victim->position == POS_DEAD || ch->in_room != victim->in_room)
      return;                                                                   
    count = 0;                                                                  
    for (i = 0;i<3;i++)                                                         
    {                                                                           
      if (i==0) {sn = skill_lookup("flamestrike");}                             

    spelltype = skill_table[sn].target;                                         

    level = ch->spl[spelltype]*5;                                               

    (*skill_table[sn].spell_fun) ( sn, level, ch, victim );                     

      if (i==1) {sn = skill_lookup("fireball");}                                

    spelltype = skill_table[sn].target;                                         

    level = ch->spl[spelltype]*5;                                               

    (*skill_table[sn].spell_fun) ( sn, level, ch, victim );                     

      if (i==2) {sn = skill_lookup("fire breath");}                             

    spelltype = skill_table[sn].target;                                         

    level = ch->spl[spelltype]*5;                                               

    (*skill_table[sn].spell_fun) ( sn, level, ch, victim );                     

        continue;                                                               

      count++;                                                                  

    }                                                                           

    SET_BIT(victim->affected_by, AFF_FLAMING);                                  

    ch->mana = ch->mana - 500;                                                  

    WAIT_STATE(ch,2);                                                           

    return;                                                                     
  }                                                                             
*/

void do_waterwall(CHAR_DATA *ch, char *argument)                                     
{                                                                               
OBJ_DATA *obj = NULL;                                                           
OBJ_DATA *objc;                                                                 
char arg[MAX_STRING_LENGTH];                                                    
char wall[MAX_STRING_LENGTH];                                                   
char buf[MAX_STRING_LENGTH];                                                    
argument=one_argument(argument,arg);                                            
if (IS_NPC(ch)) return;                                                         
if (!IS_CLASS(ch,CLASS_ELEMENT))                                                
{                                                                               
send_to_char("Huh?\n\r",ch);                                                    
return;                                                                         
}                                                                               
if (ch->pcdata->powers[EL_WATER] < 6)                                          
  {                                                                             
  send_to_char("You need water 6 to make walls of water.\n\r",ch);                      
  return;                                                                       
}
if (arg[0] == '\0' || (str_cmp(arg,"n")                                         
                   && str_cmp(arg,"s")                                          
                   && str_cmp(arg,"e")                                          
                   && str_cmp(arg,"w")                                          
                   && str_cmp(arg,"u")                                          
                   && str_cmp(arg,"d")))                                        
{                                                                               
send_to_char("You may wall n, w, s, e, d or u.\n\r",ch);                        
return;                                                                         
}                                                                               
sprintf(buf,"%s prays to the water deities, and a wall of water appears!\n\r",ch->name);         
act(buf,ch,NULL,NULL,TO_ROOM);                                                  
send_to_char("You pray to the water deities, and a wall of water appears!\n\r",ch);          
if (!str_cmp(arg,"n")) sprintf(wall,"walln");                                   
if (!str_cmp(arg,"w")) sprintf(wall,"wallw");                                   
if (!str_cmp(arg,"s")) sprintf(wall,"walls");                                   
if (!str_cmp(arg,"e")) sprintf(wall,"walle");                                   
if (!str_cmp(arg,"d")) sprintf(wall,"walld");                                   
if (!str_cmp(arg,"u")) sprintf(wall,"wallu");                                   
objc = get_obj_list(ch,wall,ch->in_room->contents);                             
if ( objc != NULL)                                                              
{                                                                               
send_to_char("There is already a wall blocking that direction.\n\r",ch);        
return;                                                                         
}                                                                               
WAIT_STATE(ch,25);                                                              
sprintf(buf,"A wall of water pours out of the ground.");                        
act(buf,ch,NULL,NULL,TO_ROOM);                                                  
send_to_char(buf,ch);                                                           
if (!str_cmp(arg,"n")) obj=create_object(get_obj_index(30043),0);               
if (!str_cmp(arg,"s")) obj=create_object(get_obj_index(30044),0);               
if (!str_cmp(arg,"e")) obj=create_object(get_obj_index(30045),0);               
if (!str_cmp(arg,"w")) obj=create_object(get_obj_index(30046),0);               
if (!str_cmp(arg,"d")) obj=create_object(get_obj_index(30047),0);               
if (!str_cmp(arg,"u")) obj=create_object(get_obj_index(30048),0);               
obj_to_room(obj,ch->in_room);                                                   
obj->timer=3;                                                                   
obj->item_type = ITEM_WALL;                                                     
return;                                                                         
}                                                                               

void do_firehands( CHAR_DATA *ch, char *argument)                              
{                                                                               
    if ( IS_NPC(ch) )                                                           
     return;                                                                    
                                                                                
    if (!IS_CLASS(ch, CLASS_ELEMENT))                                           
    {                                                                           
          send_to_char("Huh?\n\r",ch);                                          
          return;                                                               
    }                                                                           

  if (ch->pcdata->powers[EL_FIRE] < 8)                                           
  {                                                                             
  send_to_char("You need fire 8 to ignite your hands.\n\r",ch);
  return;                                                                       
  }                                                                               

    if (IS_SET(ch->newbits, NEW_MONKFLAME))                                     
    {                                                                           
          REMOVE_BIT(ch->newbits, NEW_MONKFLAME);                               
        send_to_char("Your hands are no longer engulfed by flames.\n\r",ch);    
          act("$n's hands are no longer engulfed by flames.\n\r",ch,NULL,NULL,TO_ROOM);
          return;                                                               
    }                                                                           
    if (!IS_SET(ch->newbits, NEW_MONKFLAME))                                    
    {                                                                           
          SET_BIT(ch->newbits, NEW_MONKFLAME);                                  
          send_to_char("Your hands are engulfed by flames!\n\r",ch);            
          act("$n's hands are engulfed by flames!\n\r",ch,NULL,NULL,TO_ROOM);   
          return;                                                               
    }                                                                           
}                                                                               

void do_hurricane( CHAR_DATA *ch, char *argument )                                  
{                                                                               
   char       buf[MAX_STRING_LENGTH];                                           
                                                                                
    if (IS_NPC(ch)) return;                                                     
    if (!IS_CLASS(ch, CLASS_ELEMENT))                                           
    {                                                                           
      send_to_char("Huh?\n\r", ch);                                             
      return;                                                                   
    }                                                                           
    if (ch->pcdata->powers[EL_WIND] < 8)                              
    {                                                                           
      send_to_char("You require level 8 Wind to gain Hurricane speed.\n\r",ch);
     return;                                                                   
    }                                                                           
    if (IS_EXTRA(ch, EXTRA_FLASH))                                              
    {                                                                           
     send_to_char("You are already moving at the speed of a hurricane.\n\r", ch);                   
      return;                                                                   
    }                                                                           
    SET_BIT(ch->extra, EXTRA_FLASH);                                            
    sprintf(buf, "%s prays to the wind deities and starts to move at hurricane force speed.",ch->name);           
    act(buf,ch,NULL,NULL,TO_ROOM);                                              
    send_to_char("You pray to the wind deities and start to move at hurricane force speed.\n\r",ch);             
    return;                                                                     
}                                                                               

