/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/



#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"


void do_forge( CHAR_DATA *ch, char *argument )
{   
  char arg1[MAX_STRING_LENGTH];
  char arg2[MAX_STRING_LENGTH];
  OBJ_DATA *obj = NULL;
  OBJ_DATA *obj2 = NULL;

  argument = one_argument( argument, arg1 );
  argument = one_argument( argument, arg2 );

  if (IS_NPC(ch)) return;

  if ( arg1[0] == '\0' || arg2[0] == '\0' )
  {
    send_to_char("Syntax : forge <slab> <item>   (read HELP FORGE for details)\n\r",ch);
    return;
  }
  if ((obj = get_obj_carry( ch, arg2) ) == NULL)
  {
    send_to_char( "You are not carrying that item.\n\r", ch );
    return;
  }
  if (!str_prefix(arg1, "adamantite"))
  {
    if ((obj2 = get_obj_carry( ch, (arg1))) == NULL )
    {
      send_to_char( "You require an adamantite forging slab.\n\r", ch);
      return;
    }
    if (obj2->item_type != ITEM_ADAMANTITE)
    {
      send_to_char("That thing isn't adamantite!\n\r",ch);
      return;
    }
    else if (IS_SET(obj->spectype, SITEM_ADAMANTITE) || IS_SET(obj->spectype, SITEM_PLATINUM) || IS_SET(obj->spectype, SITEM_URANIUM) || IS_SET(obj->spectype, SITEM_PLUTONIUM))
    {
      send_to_char("That item is already forged.\n\r",ch);
      return;
    }
    SET_BIT(obj->spectype, SITEM_ADAMANTITE);
    forge_affect(obj, 150);
    extract_obj( obj2 );
    act("You forge adamantite onto $p.\n\r",ch, obj,NULL,TO_CHAR);
    act("$n forges adamantite onto $p.\n\r",ch,obj,NULL,TO_ROOM);	
    return;
  }
  if (!str_prefix(arg1, "platinum"))
  {
    if ((obj2 = get_obj_carry( ch, (arg1))) == NULL )
    {
      send_to_char( "You require a platinum forging slab.\n\r", ch);
      return;
    }
    if (obj2->item_type != ITEM_PLATINUM)
    {
      send_to_char("That thing isn't platinum!\n\r",ch);
      return;
    }
    else if (IS_SET(obj->spectype, SITEM_ADAMANTITE) || IS_SET(obj->spectype, SITEM_PLATINUM) || IS_SET(obj->spectype, SITEM_URANIUM) || IS_SET(obj->spectype, SITEM_PLUTONIUM))
    {
      send_to_char("That item is already forged.\n\r",ch);
      return;
    }
    SET_BIT(obj->spectype, SITEM_PLATINUM);
    forge_affect(obj, 125);
    extract_obj( obj2 );
    act("You forge platinum onto $p.\n\r",ch, obj,NULL,TO_CHAR);
    act("$n forges platinum onto $p.\n\r",ch,obj,NULL,TO_ROOM);
    return;
  }
  if (!str_prefix(arg1, "uranium"))
  {
    if ((obj2 = get_obj_carry( ch, (arg1))) == NULL )
    {
      send_to_char( "You require a uranium forging slab.\n\r", ch);
      return;
    }
    if (obj2->item_type != ITEM_URANIUM)
    {
      send_to_char("That thing isn't uranium!\n\r",ch);
      return;
    }
    else if (IS_SET(obj->spectype, SITEM_ADAMANTITE) || IS_SET(obj->spectype, SITEM_PLATINUM) || IS_SET(obj->spectype, SITEM_URANIUM) || IS_SET(obj->spectype, SITEM_PLUTONIUM))
    {
      send_to_char("That item is already forged.\n\r",ch);
      return;
    }
    SET_BIT(obj->spectype, SITEM_URANIUM);
    forge_affect(obj, 100);
    extract_obj( obj2 );
    act("You forge uranium onto $p.\n\r",ch, obj,NULL,TO_CHAR);
    act("$n forges uranium onto $p.\n\r",ch,obj,NULL,TO_ROOM);
    return;
  }
  if (!str_prefix(arg1, "plutonium"))
  {
    if ((obj2 = get_obj_carry( ch, (arg1))) == NULL )
    {
      send_to_char( "You require a plutonium forging slab.\n\r", ch);
      return;
    }
    if (obj2->item_type != ITEM_PLUTONIUM)
    {
      send_to_char("That thing isn't plutonium!\n\r",ch);
      return;
    }
    else if (IS_SET(obj->spectype, SITEM_ADAMANTITE) || IS_SET(obj->spectype, SITEM_PLATINUM) || IS_SET(obj->spectype, SITEM_URANIUM) || IS_SET(obj->spectype, SITEM_PLUTONIUM))
    {
      send_to_char("That item is already forged.\n\r",ch);
      return;
    }
    SET_BIT(obj->spectype, SITEM_PLUTONIUM);
    forge_affect(obj, 75);
    extract_obj( obj2 );
    act("You forge plutonium onto $p.\n\r",ch, obj,NULL,TO_CHAR);
    act("$n forges plutonium onto $p.\n\r",ch,obj,NULL,TO_ROOM);
    return;
  }
  else send_to_char("You cannot forge that.\n\r", ch);
  return;
}

void forge_affect(OBJ_DATA *obj, int value)                                     
{                                                                               
  AFFECT_DATA paf;                                                              
                                                                                
  paf.type           = 0;                                                       
  paf.duration       = -1;                                                      
  paf.location       = APPLY_HITROLL;                                           
  paf.modifier       = value;                                                   
  paf.bitvector      = 0;                                                       
  affect_to_obj(obj, &paf);                                                     

  paf.type           = 0;                                                       
  paf.duration       = -1;                                                      
  paf.location       = APPLY_DAMROLL;                                           
  paf.modifier       = value;                                                   
  paf.bitvector      = 0;                                                       
  affect_to_obj(obj, &paf);                                                     
}

