/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/


#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"


void do_ride ( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  char buf[MAX_STRING_LENGTH];
  char arg[MAX_INPUT_LENGTH];
  argument = one_argument(argument, arg);
      
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_UNDEAD_KNIGHT))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }  
  if (ch->move < 2000)
  {
    stc("You do not have enough vitality to do that!\n\r",ch);
    return;
  }
  if (arg[0] == '\0')
  {
    send_to_char( "Ride your skeleton steed to whom?\n\r", ch );
    return;
  }
  if ( ( victim = get_char_world( ch, arg ) ) == NULL )
  {
    send_to_char( "They aren't here.\n\r", ch );
    return;
  }
  if( victim == ch )
  {
    stc ( "Not to yourself.\n\r",ch);
    return;
  }
  if( IS_SET(victim->in_room->room_flags, ROOM_ASTRAL))
  {
    stc( "You can't find it's room.\n\r",ch);
    return;
  }
  if( IS_SET(ch->in_room->room_flags, ROOM_ASTRAL))
  {
    stc( "Your room is not connected to the astral plane.\n\r",ch);
    return;
  }
  if (victim->in_room->vnum == ch->in_room->vnum)
  {
    send_to_char("But you're already there!\n\r",ch);
    return;
  }
  act("#R$n#n rides away on#R $s#n skeletal steed!#n\n\r",ch,NULL,NULL,TO_ROOM);
  char_from_room(ch);
  char_to_room(ch,victim->in_room);
  if (IS_NPC(victim))
  {
    sprintf(buf,"#RYou#n ride your skeletal steed to#R %s#n!#n\n\r",victim->short_descr);
    send_to_char(buf, ch);
  }
  if (!IS_NPC(victim) && !IS_EMPLOYEE(victim))
  {
    sprintf(buf,"#RYou#n ride your skeletal steed to#R %s#n!\n\r",victim->name);
    send_to_char(buf, ch);
  }
  act("#R$n#n rides toward you on#R $s#n skeletal steed!#n\n\r",ch,NULL,NULL,TO_ROOM);
  do_look(ch, "auto");
  ch->move -= 2000;
  return;
}

void do_knightarmor( CHAR_DATA *ch, char *argument )
{
  OBJ_INDEX_DATA *pObjIndex;
  OBJ_DATA *obj;
  char arg[MAX_INPUT_LENGTH];
  int vnum = 0;

  argument = one_argument( argument, arg );
  if (IS_NPC(ch)) return;
  if( !IS_CLASS(ch, CLASS_UNDEAD_KNIGHT) )
  {
    send_to_char("You are not one of the undead!!!\n\r",ch);
    return;
  }
  if (arg[0] == '\0')
  {
    send_to_char("Please specify which piece of unholy armor you wish to make: 
plate ring bracer collar helmet leggings boots gauntlets chains cloak belt visor longsword shortsword.\n\r",ch);
    return;
  }
  if ( ch->practice < 150 )
  {
    send_to_char("It costs 150 points of primal to create a piece of unholy armor.\n\r",ch);
    return;
  }
  if (!str_cmp(arg,"plate")) vnum = 33337;
  else if (!str_cmp(arg,"longsword")) vnum = 33338;
  else if (!str_cmp(arg,"shortsword")) vnum = 33339;
  else if (!str_cmp(arg,"ring")) vnum = 33340;
  else if (!str_cmp(arg,"bracer")) vnum = 33341;
  else if (!str_cmp(arg,"collar")) vnum = 33342;
  else if (!str_cmp(arg,"helmet")) vnum = 33343;
  else if (!str_cmp(arg,"leggings")) vnum = 33344;
  else if (!str_cmp(arg,"boots")) vnum = 33345;
  else if (!str_cmp(arg,"gauntlets")) vnum = 33346;
  else if (!str_cmp(arg,"chains")) vnum = 33347;
  else if (!str_cmp(arg,"cloak")) vnum = 33348;
  else if (!str_cmp(arg,"belt")) vnum = 33349;
  else if (!str_cmp(arg,"visor")) vnum = 33350;
  else
  {
    send_to_char("Please specify which piece of unholy armor you wish to make: 
plate ring bracer collar helmet leggings boots gauntlets chains cloak belt visor longsword shortsword.\n\r",ch);
    return;
  }
  if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
  {
    send_to_char("Missing object, please inform An SG Admin.\n\r",ch);
    return;
  }
  obj = create_object(pObjIndex, 50);
  obj->questowner = str_dup(ch->pcdata->switchname);
  obj_to_char(obj, ch);
  act("An aura of death forms $p.",ch,obj,NULL,TO_CHAR);
  act("An aura of death forms $p in $n's hands.",ch,obj,NULL,TO_ROOM);
  ch->practice -=150;
  return;
}

void do_unholyrite (CHAR_DATA *ch, char *argument)
{
  if (IS_NPC(ch)) return;
  if( !IS_CLASS(ch, CLASS_UNDEAD_KNIGHT) && !IS_CLASS(ch, CLASS_TANARRI))
  {
    send_to_char("Huh.\n\r",ch);
    return;
  }
  if (ch->mana < 500)
  {
    send_to_char("You don't have the mystical energies to make the rite.\n\r",ch);
    return;
  }
  if (ch->hit < ch->max_hit)
  {
    ch->hit += number_range(500,1000);
    send_to_char("You make a#r blood sacrifice#n to the God of#L Death#n.\n\r",ch);
  }
  if (ch->hit > ch->max_hit) ch->hit=ch->max_hit;
  ch->mana -= 500;
  WAIT_STATE(ch,18);
}

void do_aura (CHAR_DATA *ch, char *argument)
{
  char arg[MAX_INPUT_LENGTH];
  
  argument = one_argument( argument, arg );

  if (IS_NPC(ch)) return;
  if( !IS_CLASS(ch, CLASS_UNDEAD_KNIGHT) )
  {
    send_to_char("Huh.\n\r",ch);
    return;
  }
  if (arg[0] == '\0')
  {
    send_to_char("#RSyntax#7: #rAura#y <#LBog#y/#CDeath#y/#GFear#y/#PMight#y>#n\n\r",ch);
    return;
  }
  if (!str_cmp(arg,"bog"))
  {
    if (ch->pcdata->powers[NECROMANCY] < 6)
    {
      send_to_char("You don't have that aura yet.\n\r",ch);
      return;
    }
    if (IS_SET(ch->pcdata->powers[AURAS], BOG_AURA))
    {
      REMOVE_BIT(ch->pcdata->powers[AURAS], BOG_AURA);
      send_to_char("Your aura of#L Bog#n fades.#n\n\r",ch);
      return;
    }
    else
    {
      send_to_char("An aura of#L Bog#n surrounds you.#n\n\r",ch);
      SET_BIT(ch->pcdata->powers[AURAS], BOG_AURA);
      return;
    }
  }
  if (!str_cmp(arg,"might"))
  {
    if (ch->pcdata->powers[NECROMANCY] < 4)
    {
      send_to_char("You don't have that aura yet.\n\r",ch);
      return;
    }
    if (IS_SET(ch->pcdata->powers[AURAS], MIGHT_AURA))
    {
      REMOVE_BIT(ch->pcdata->powers[AURAS], MIGHT_AURA);
      send_to_char("Your aura of#P Might#n fades.\n\r",ch);
      ch->damroll -= 500;
      ch->hitroll -= 500;
      return;
    }
    else
    {   
      send_to_char("An aura of#P Might#n surrounds you.#n\n\r",ch);
      SET_BIT(ch->pcdata->powers[AURAS], MIGHT_AURA);
      ch->damroll += 500;
      ch->hitroll += 500;  
      return;
    }
  }  
  else if (!str_cmp(arg,"death"))
  {
    if (ch->pcdata->powers[NECROMANCY] < 2) 
    {
      send_to_char("You don't have that aura yet.\n\r",ch);
      return;
    }
    if (IS_SET(ch->pcdata->powers[AURAS], DEATH_AURA))
    {
      REMOVE_BIT(ch->pcdata->powers[AURAS], DEATH_AURA);
      send_to_char("Your aura of#C Death#n fades away.#n\n\r",ch);
      return;
    }
    else
    {
      SET_BIT(ch->pcdata->powers[AURAS], DEATH_AURA);
      send_to_char("An aura of#C Death#n surrounds you.#n\n\r",ch);
      return;
    }
  }
  else if (!str_cmp(arg,"fear"))
  {  
    if (ch->pcdata->powers[NECROMANCY] < 9)
    {
      send_to_char("You don't have that aura yet.\n\r",ch);
      return;
    }
    if (IS_SET(ch->pcdata->powers[AURAS], FEAR_AURA))
    {      
      REMOVE_BIT(ch->pcdata->powers[AURAS], FEAR_AURA);
      send_to_char("Your aura of#G Fear#n fades away.#n\n\r",ch);
      return;
    }
    else
    {
      SET_BIT(ch->pcdata->powers[AURAS], FEAR_AURA);
      send_to_char("An aura of#G Fear#n surrounds you.#n\n\r",ch);
      return;
    }
  }
  return;
}

void do_gain (CHAR_DATA *ch, char *argument)
{
  char arg[MAX_INPUT_LENGTH];
  char buf[MAX_STRING_LENGTH];

  argument = one_argument( argument, arg );
  if (IS_NPC(ch)) return;
  if( !IS_CLASS(ch, CLASS_UNDEAD_KNIGHT) )
  {
    send_to_char("Huh.\n\r",ch);
    return;
  }
  if (arg[0] == '\0')
  {
    sprintf(buf, "#RCurrent Tracks#7: #yNecromancy#L [#7%d#L] #yInvocation#L [#7%d#L]  #ySpirit#L [#7%d#L]  #yWeaponSkill#L [#7%d#L]#n\n\r",
      ch->pcdata->powers[NECROMANCY], ch->pcdata->powers[INVOCATION], ch->pcdata->powers[SPIRIT], ch->pcdata->powers[WEAPONSKILL]);
    send_to_char(buf,ch);
    send_to_char("#RSyntax#7:#R Gain#y <#LTrack#y>#n\n\r",ch);
    return;
  }
  if (!str_cmp(arg,"necromancy"))
  {
    if (ch->pcdata->powers[NECROMANCY]>9)
    {
      send_to_char("You have mastered the art of #LNecromancy#n.\n\r",ch);
      return;
    }
    else if (ch->practice < ch->pcdata->powers[NECROMANCY] * 60 + 60)
    {
      sprintf(buf,"You need#R %d#n more primal to improve the art of #LNecromancy#n.\n\r", ch->pcdata->powers[NECROMANCY] *60 +60 - ch->practice );
      send_to_char(buf,ch);
      return;
    }
    else
    {
      ch->practice -= ch->pcdata->powers[NECROMANCY] * 60 + 60;
      send_to_char("You have improved in the art of#L Death#n.\n\r",ch);
      ch->pcdata->powers[NECROMANCY] += 1;
      return;
    }
  }
  else if (!str_cmp(arg,"invocation"))  /* attacks like powerwords */
  {
    if (ch->pcdata->powers[INVOCATION]>4)
    {
      send_to_char("You have mastered the art of#L Invocation#n.\n\r",ch);
      return;
    }
    else if (ch->practice < ch->pcdata->powers[INVOCATION] * 60 + 60)
    {
      sprintf(buf,"You need#R %d#n more primal to improve the art of#L Invocation#n.\n\r",ch->pcdata->powers[INVOCATION] * 60 + 60 - ch->practice);
      send_to_char(buf,ch);
      return;
    }
    else
    {
      ch->practice -= ch->pcdata->powers[INVOCATION] * 60 + 60;
      send_to_char("Your mastery of the ancient#L Invocations#n increases.\n\r",ch);
      ch->pcdata->powers[INVOCATION] += 1;
      return;
    }
  }
  else if (!str_cmp(arg,"spirit"))  /* toughness */
  {
    if (ch->pcdata->powers[UNDEAD_SPIRIT] > 9)
    {
      send_to_char("You have mastered your restless#L Spirit#n.\n\r",ch);
      return;
    }
    if (ch->practice < ch->pcdata->powers[UNDEAD_SPIRIT] * 60 + 60)
    {
      sprintf(buf,"You need#R %d#n more primal to tame your#L Spirit#n further.\n\r",ch->pcdata->powers[UNDEAD_SPIRIT] * 60 + 60 - ch->practice );
      send_to_char(buf,ch);
      return;
    }
    else  
    {
      ch->practice -= ch->pcdata->powers[UNDEAD_SPIRIT] * 60 + 60;
      send_to_char("You have tamed your restless#L Spirit#n a slight amount more.\n\r",ch);
      ch->pcdata->powers[UNDEAD_SPIRIT] += 1;
      return;
    }  
  } 
  else if (!str_cmp(arg,"weaponskill") || !str_cmp(arg,"weapon skill") || !str_cmp(arg,"weapon_skill") || !str_cmp(arg,"weaponskills") || !str_cmp(arg,"weapon skills"))
  {
    if (ch->pcdata->powers[WEAPONSKILL] > 9)
    { 
      send_to_char("You are already a grandmaster in all aspects of#L Combat#n.\n\r",ch);
      return;
    }
    if (ch->practice < ch->pcdata->powers[WEAPONSKILL] * 60 + 60)
    {
      sprintf(buf,"You need#R %d#n more primal to improve your#L Weaponskills#n.\n\r", ch->pcdata->powers[WEAPONSKILL] * 60 + 60 - ch->practice );
    send_to_char(buf, ch);
    return;
    }
    else  
    {
      ch->practice -= ch->pcdata->powers[WEAPONSKILL]* 60 + 60;
      send_to_char("As you continue your training, you feel your#L Weaponskills#n improving.\n\r",ch);
      ch->pcdata->powers[WEAPONSKILL] += 1;
      return;
    }
  }
 return;
}
void do_powerword (CHAR_DATA *ch, char *argument)
{
  char arg[MAX_INPUT_LENGTH];
  char arg2[MAX_INPUT_LENGTH];
  char buf1[MAX_STRING_LENGTH];
  char buf2[MAX_STRING_LENGTH];
  char buf3[MAX_STRING_LENGTH];
  AFFECT_DATA af;
  CHAR_DATA *ich;
  CHAR_DATA *victim;
  
  argument = one_argument( argument, arg );
  argument = one_argument( argument, arg2 );
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_UNDEAD_KNIGHT))
  {
    send_to_char("Huh.\n\r",ch);
    return;
  }
  if (arg[0] == '\0')
  {
    send_to_char("#RSyntax#7:#R Powerword#y <#GKill#y/#CStun#y/#LBlind#y/#yFlames#y>#n\n\r",ch);
    return;
  }
  if (!str_cmp(arg,"stun") && ch->pcdata->powers[INVOCATION] > 4)
  {
    if (!(arg2[0] == '\0') || ch->fighting != NULL)
    {
      if (arg2[0] == '\0') victim = ch->fighting;
      else if ((victim = get_char_room(ch, arg2)) == NULL)
      {
        send_to_char("They are not here.\n\r", ch );
        return;
      }
      if (ch->pcdata->powers[POWER_TICK] > 0)
      {
        send_to_char("You cannot cast another powerword yet.\n\r",ch);
        return;
      }
      if (is_safe(ch, victim)) return;
      act("#R$n#n points his finger at#R $N#n and says '#CFREEZE!!!#n'",ch,NULL,victim,TO_NOTVICT);
      act("#RYou#n point your finger at#R $N#n and say '#CFREEZE!!!#n'",ch,NULL,victim,TO_CHAR);
      act("#R$n#n points his finger at#R you#n and says '#CFREEZE!!!#n'",ch,NULL,victim,TO_VICT);
      WAIT_STATE(victim, 8);
      WAIT_STATE(ch, 1);
      if (number_range(1,8) == 4)
      {
        WAIT_STATE(victim, victim->wait * number_range(1.1,2.25));
        act("$N falls stunned as $n's powerword strikes!",ch,NULL,victim,TO_NOTVICT);
        act("Your powerword causes $N to fall over stunned!",ch,NULL,victim,TO_CHAR);
        act("$n's powerword causes you to fall over stunned!",ch,NULL,victim,TO_VICT);
        victim->position = POS_STUNNED;
        update_pos(victim);
        stop_fighting( victim, TRUE);
        return;
      }
      ch->pcdata->powers[POWER_TICK] = 4;
      return;
    }
    else
    {
      send_to_char("Stun whom?\n\r",ch);
      return;
    }
  }
  else if (!str_cmp(arg,"blind") && ch->pcdata->powers[INVOCATION] > 0)
  {
    if (!(arg2[0] == '\0') || ch->fighting != NULL)
    {
      if (arg2[0] == '\0') victim = ch->fighting;
      else if ((victim = get_char_room(ch, arg2)) == NULL)
      {
        send_to_char("They are not here.\n\r", ch );
        return;
      }
      if (ch->pcdata->powers[POWER_TICK] > 0)
      {
        send_to_char("You cannot cast another powerword yet.\n\r",ch);
        return;
      }
      if (is_safe(ch, victim)) return;
      act("#R$n#n touches#R $N#n's forhead and screams '#lMIDNIGHT!!!#n'.",ch,NULL,victim,TO_NOTVICT);
      act("#RYou#n touch#R $N#n's forehead and scream '#lMIDNIGHT!!!#n'.",ch,NULL,victim,TO_CHAR);
      act("#R$n#n touches#R your#n forehead and screams '#lMIDNIGHT!!!#n'.",ch,NULL,victim,TO_VICT);
      if (IS_SET(victim->affected_by, AFF_DETECT_HIDDEN)) 
        REMOVE_BIT(victim->affected_by, AFF_DETECT_HIDDEN);
      if (IS_SET(victim->affected_by, AFF_DETECT_INVIS))
        REMOVE_BIT(victim->affected_by, AFF_DETECT_INVIS);
      af.type      = skill_lookup("blindness");
      af.location  = APPLY_HITROLL;
      af.modifier  = number_range(-100,-250) + number_range(-50,90);
      af.duration  = 60;
      af.bitvector = AFF_BLIND;
      affect_to_char( victim, &af );
      WAIT_STATE(ch,12);
      ch->pcdata->powers[POWER_TICK] = 4;
      return;
    }
    else
    {
      send_to_char("Blind whom?\n\r",ch);
      return;
    }
  }
  else if (!str_cmp(arg,"kill") && ch->pcdata->powers[INVOCATION] > 2)
  {
    if (!(arg2[0] == '\0'))
    {
      if ((victim = get_char_room(ch, arg2)) == NULL)
      {
        send_to_char("They are not here.\n\r", ch );
        return;
      }
      if (ch->pcdata->powers[POWER_TICK] > 0)
      {
        send_to_char("You cannot cast another powerword yet.\n\r",ch);
        return;
      }
      if (ch == victim)
      {
        send_to_char("Don't be silly.\n\r",ch);
        return;
      }
      if (is_safe(ch, victim)) return;
      act("#R$n#n looks at#R $N#n and utters '#rDIE!!!#n'.",ch,NULL,victim,TO_NOTVICT);
      act("#RYou#n look at#R $N#n and say '#rDIE!!!#n'.",ch,NULL,victim,TO_CHAR);
      act("#R$n#n looks at#R you#n and utters '#rDIE!!!#n'.",ch,NULL,victim,TO_VICT);
      if (victim->position > POS_STUNNED)
      {
        if (victim->fighting == NULL) set_fighting(victim, ch);
        if (ch->fighting == NULL) set_fighting(ch, victim);
      }
      if (!IS_NPC(victim) || victim->level > 100)
      {
        int dam = victim->hit *.1;
        if (IS_NPC(victim) && dam > 5000) dam = 5000;
        if (!IS_NPC(victim) && dam > 1500) dam = 1500;
        hurt_person(ch,victim,dam);
        sprintf(buf1,"$n's powerword strikes $N [#C%d#n]" , dam);
        sprintf(buf2,"Your powerword strikes $N [#C%d#n]" , dam);
        sprintf(buf3,"$n's powerword strikes you [#C%d#n]" , dam);
        act(buf1,ch,NULL,victim, TO_NOTVICT);
        act(buf2,ch,NULL,victim, TO_CHAR);
        act(buf3,ch,NULL,victim, TO_VICT);
        ch->pcdata->powers[POWER_TICK] = 4;
        return;
      }
      ch->level = 12;
      do_slay(ch, arg2);
      ch->level = 3;
      ch->pcdata->powers[POWER_TICK] = 4;
      return;
    }
    else
    {
      send_to_char("Kill whom?\n\r",ch);
      return;
    }
  }
  else if (!str_cmp(arg,"flames") && ch->pcdata->powers[INVOCATION] > 3)
  {
    if (ch->pcdata->powers[POWER_TICK] > 0)
    {
      send_to_char("You cannot cast another powerword yet.\n\r",ch);
      return;
    }
    for (ich = ch->in_room->people; ich != NULL; ich = ich->next_in_room )
      if (ich != ch)
      {
         if (is_safe(ch,ich)) continue;
         one_hit(ch,ich,gsn_fireball,1);
         one_hit(ch,ich,gsn_fireball,1);
      }
    WAIT_STATE(ch,12);
    ch->pcdata->powers[POWER_TICK] = 4;
    return;
  }
  else
  {
    send_to_char("You have not learned that powerword yet.\n\r",ch);
    return;
  }
}
