/****************************************************
 ** Vampire Class rework done by Wolfman, (c) 2001 **
 ** for the Prometheus Unbound Mud.                **
 ****************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"


void do_vampirearmor( CHAR_DATA *ch, char *argument )
{
  OBJ_INDEX_DATA *pObjIndex;
  OBJ_DATA *obj;
  char arg[MAX_INPUT_LENGTH];
  int vnum = 0;

  argument = one_argument( argument, arg );
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_VAMPIRE))
  {
      send_to_char("What?\n\r",ch);
      return;
  }
  if (arg[0] == '\0')
  {
    send_to_char("Please specify which piece of vampire armor you wish to make: Ring Collar Plate Helmet
Leggings Boots Gloves Sleeves Cape Belt Bracer Visor Dagger Longsword.\n\r",ch);
    return;
  }

    if ( ch->practice < 60 )
    {
        send_to_char("It costs 60 points of primal to create vampire equipment.\n\r",ch);
        return;
    }

    if      (!str_cmp(arg,"ring"	)) vnum = 33042;    
    else if (!str_cmp(arg,"plate"	)) vnum = 33044;
    else if (!str_cmp(arg,"helmet"	)) vnum = 33045;
    else if (!str_cmp(arg,"collar"	)) vnum = 33043;
    else if (!str_cmp(arg,"leggings" )) vnum = 33046;
    else if (!str_cmp(arg,"boots" )) vnum = 33047;
    else if (!str_cmp(arg,"gloves" )) vnum = 33048;
    else if (!str_cmp(arg,"sleeves" )) vnum = 33049;
    else if (!str_cmp(arg,"cape" )) vnum = 33050;
    else if (!str_cmp(arg,"belt" )) vnum = 33051;
    else if (!str_cmp(arg,"bracer" )) vnum = 33052;
    else if (!str_cmp(arg,"visor" )) vnum = 33053;
    else if (!str_cmp(arg,"longsword" )) vnum = 33040;
    else if (!str_cmp(arg,"dagger" )) vnum = 33041;
    else
    {
    do_vampirearmor(ch,"");
    return;
    }
    
    if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
    {
    send_to_char("Missing object, please inform a God.\n\r",ch);
    return;
    }

    ch->practice -= 60;
    obj = create_object(pObjIndex, 50);
    obj->questowner = str_dup(ch->pcdata->switchname);
    obj_to_char(obj, ch);
    act("$p appears in your hands.",ch,obj,NULL,TO_CHAR);
    act("$p appears in $n's hands.",ch,obj,NULL,TO_ROOM);
    return;
}

void do_batshriek( CHAR_DATA *ch, char *argument )
{
   CHAR_DATA *vch;
   CHAR_DATA *vch_next;
   CHAR_DATA *mount;
   char arg[MAX_INPUT_LENGTH];

   argument = one_argument( argument, arg );

   if ( IS_NPC(ch) ) return;
 
   if ( !IS_CLASS(ch, CLASS_VAMPIRE) )
   {
     stc("Huh?\n\r",ch);
     return;
   }

   if ( ch->power[DISC_VAMP_OFFENSIVE] < 5 )
   {
     stc("You must obtain level 5 Offensive to shriek like a bat.\n\r",ch);
     return;
   }

   if ( IS_SET(ch->in_room->room_flags, ROOM_SAFE) ||
 	(ch->in_room->sector_type == SECT_FIELD) ||
	(ch->in_room->sector_type == SECT_AIR) ||
	(ch->in_room->sector_type == SECT_DESERT) ||
	(ch->in_room->sector_type == SECT_UNDERWATER) ||
	(ch->in_room->room_flags == ROOM_UNDER_WATER) )
   {
     stc("You shriek like a bat, but there is no return echo!\n\r",ch);
     return;
   }

   if ( ch->pcdata->condition[COND_THIRST] < 100 )
   {
     stc("You have insufficient blood.\n\r",ch);
     return;
   }

    for ( vch = char_list; vch != NULL; vch = vch_next )
    {
        vch_next        = vch->next;

        if ( vch->in_room == NULL )
            continue;
        if ( !IS_NPC(vch) && vch->pcdata->chobj != NULL )
            continue;
        if ( ch == vch )
              continue;
	if ( vch->level < 3 )
	    continue;
        if ( vch->in_room == ch->in_room )
        {
            if ( ( mount = ch->mount ) != NULL )
            {
                if ( mount == vch )
                continue;
            }
            if (can_see(ch,vch))
            {
              if ( number_range( 1, (12 - ch->power[DISC_VAMP_OFFENSIVE])) == 2 )
              {
                act("$n shrieks like a bat, exploding your ear drums!",ch,NULL,vch,TO_ROOM);
                stc("You fall to the ground, blood spurting from your ears!\n\r",vch);
                vch->position = POS_STUNNED;
		vch->hit -= 2500;
                act("$n falls to the ground, stunned and bleeding heavily!",vch,NULL,vch,TO_NOTVICT);
                return;
              }
	      else
	      {
                act("$n shrieks like a bat!",ch,NULL,vch,TO_ROOM);
	        return;
	      }
	    }
	    else continue;

	    return;
        }
    }

  return;
}

void do_fear( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char arg[MAX_INPUT_LENGTH];
    char buf[MAX_STRING_LENGTH];

    argument = one_argument( argument, arg );

    if ( IS_NPC(ch) ) return;

    if ( !IS_CLASS(ch, CLASS_VAMPIRE) )
    {
	stc("Huh?\n\r",ch);
	return;
    }

    if ( ch->power[DISC_VAMP_OFFENSIVE] < 5 )
    {
      stc("You must obtain level 5 Offensive to use Fear.\n\r",ch);
      return;
    }

    if ( ( victim = get_char_room( ch, arg) ) == NULL )
    {
      stc("They aren't here.\n\r",ch);
      return;
    }

    arg[0] = UPPER(arg[0]);    

    if ( ch->fighting == NULL )
    {
      stc("You must be fighting to use Fear.\n\r",ch);
      return;
    }

    if ( victim->fighting == NULL )
    {
      sprintf(buf, "%s is not fighting anyone.", arg);
      stc(buf, ch);
      return;
    }  

    WAIT_STATE( ch, 16 );

    if ( IS_NPC(victim) )
    {
      act("You bare your fangs and growl at $N.",ch,NULL,victim,TO_CHAR);
      act("$n bares $s fangs and growls at you.",ch,NULL,victim,TO_VICT);
      act("$n bares $s fangs and growls at $N, and $N flees in terror.",ch,NULL,victim,TO_NOTVICT);
      do_flee( victim, "" );
      return;
    }

    if ( !IS_NPC(victim) )
    {
      if ( ch->power[DISC_VAMP_OFFENSIVE] < 5 )
      {
        if ( number_range( 1, 4 ) != 2 )
        {
          act("You bare your fangs and growl at $N, but nothing happens.",ch,NULL,victim,TO_CHAR);
          act("$n bares $s fangs and growls at you.",ch,NULL,victim,TO_VICT);
          act("$n bares $s fangs and growls at $N, but nothing happens.",ch,NULL,victim,TO_NOTVICT);
	  return;
        }
      }

      act("You bare your fangs and growl at $N.",ch,NULL,victim,TO_CHAR);
      act("$n bares $s fangs and growls at you.",ch,NULL,victim,TO_VICT);
      act("$n bares $s fangs and growls at $N, and $N flees in terror.",ch,NULL,victim,TO_NOTVICT);
      do_flee( victim, "" );
      return;
    }

  return;

}

void do_gourge(CHAR_DATA *ch, char *argument  )
{
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    char buf[MAX_STRING_LENGTH];
   one_argument( argument,arg);
 
    if (IS_NPC(ch)) return;
    if (!IS_CLASS(ch,CLASS_VAMPIRE))
    {
    send_to_char("Huh?\n\r",ch);
    return;
    }
   if (ch->power[DISC_VAMP_BLOOD] < 6)
   {
   send_to_char("You need Blood level 6 to Gourge.\n\r",ch);
   return;
   }
    if ( arg[0] == '\0' )
    {
        send_to_char( "Who do you wish to gourge?\n\r", ch );
	return;
    }
    if ((victim = get_char_room( ch, arg)) == NULL)
    {
    send_to_char("They arent here.\n\r",ch);
    return;
    }
	if (IS_NPC(victim) && IS_SET(victim->act, ACT_NOAUTOKILL)) {
	send_to_char("You can't do that to them.\n\r",  ch);
	return;}

    if (!IS_NPC(victim))
    {
    send_to_char("You cannot gourge a person.\n\r",ch);
    return;
    }
    if (victim->level > 30)
    {
    send_to_char(
    "Only small creatures are defenceless enough to be gourged on.\n\r",ch);
    return;
    }
    sprintf(buf,
    "%s leaps toward %s baring his fangs.",ch->name,victim->name);
    act(buf,ch,NULL,NULL,TO_ROOM);
    sprintf(buf,
    "You leap toward %s baring your fangs.\n\r",victim->name);
    send_to_char(buf,ch);
    WAIT_STATE(ch, 15);
    
    send_to_char(
    "You rip their throat out and gourge on the blood.\n\r",ch);
    sprintf(buf,
    "%s rips %s's throat out, gourging on all of their blood."
    ,ch->name,victim->name);
    act(buf,ch,NULL,NULL,TO_ROOM);
    ch->pcdata->condition[COND_THIRST] += number_range(100,200);

    sprintf(buf,
    "%s body falls to the ground lifeless.",victim->name);
    send_to_char(buf,ch);
    act(buf,ch,NULL,NULL,TO_ROOM);
    raw_kill( victim );
    return;
}

void do_baseball (CHAR_DATA *ch, char *argument)                                 
{                                                                               
  OBJ_DATA *obj;                                                                
                                                                                
  if (IS_NPC(ch)) return;                                                       
  if (!IS_CLASS(ch, CLASS_VAMPIRE))                                        
  {                                                                             
    send_to_char("Huh?\n\r",ch);                                                
    return;                                                                     
  }
   if ( ch->power[DISC_VAMP_CONFUSION] < 3 )                                
   {                                                                            
     stc("You must obtain level 3 Confusion to change into a baseball bat.\n\r",ch);
     return;                                                                    
   }                                                                            
  if (IS_AFFECTED(ch,AFF_POLYMORPH))                                            
  {                                                                             
    send_to_char( "You must be in human form.\n\r", ch);                        
    return;                                                                     
  }                                                                             
  if (ch->fight_timer>0)                                                        
  {                                                                             
    send_to_char("Not with a fight timer.\n\r",ch);                             
    return;                                                                     
  }                   
   if ( ch->pcdata->condition[COND_THIRST] < 25 )                              
   {                                                                            
     stc("You have insufficient blood.\n\r",ch);                                
     return;                                                                    
   }                                                                            
  if ((obj = create_object(get_obj_index(17664),60)) == NULL)                   
  {                                                                             
    send_to_char( "Object bug, tell a Coder.\n\r", ch);                         
    return;                                                                     
  }                                                                             
  obj_to_room(obj,ch->in_room);                                                 
  act("$n transforms into $p and falls to the ground.",ch,obj,NULL,TO_ROOM);    
  act("You transform into $p and fall to the ground.",ch,obj,NULL,TO_CHAR);     
  ch->pcdata->obj_vnum = 17664;                                                 
  obj->chobj = ch;                                                              
  ch->pcdata->chobj = obj;                                                      
  SET_BIT(ch->affected_by, AFF_POLYMORPH);                                      
  SET_BIT(ch->extra, EXTRA_OSWITCH);                                            
  free_string(ch->morph);                                                       
  ch->morph = str_dup(obj->short_descr);                                        
  ch->pcdata->condition[COND_THIRST] -= 25;
  return;                                                                       
}                                                                               

void do_embrace(CHAR_DATA *ch, char *argument  )
{
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    char buf[MAX_STRING_LENGTH];
    int bloodpool;
    one_argument( argument, arg );

    
    if (ch->generation == 0) bloodpool = 5000;
    else bloodpool = (2000 / ch->generation);

 
    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch,CLASS_VAMPIRE))
    {
      send_to_char("Huh?\n\r",ch);
      return;
    }


    if ( arg[0] == '\0' )
    {
        send_to_char( "Who do you wish to embrace?\n\r", ch );
	return;
    }

    if ((victim = get_char_room( ch, arg)) == NULL)
    {
      send_to_char("They arent here.\n\r",ch);
      return;
    }

    if (IS_NPC(victim) && IS_SET(victim->act, ACT_NOAUTOKILL)) 
    {
	send_to_char("You can't do that to them.\n\r", ch);
	return;
    }

	/* Shaktis check for level */

	if (victim->level > 75 * ch->spl[RED_MAGIC]) 
	{
		send_to_char("They are too powerful to embrace!\n\r",ch);
		return;
	}

	
    if (!IS_NPC(victim))
    {
      send_to_char("You cannot embrace a person.\n\r",ch);
      return;
    }

    if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))
    {
	send_to_char("You cannot embrace them here.\n\r",ch);
	return;
    }
   if ( ch->power[DISC_VAMP_BLOOD] < 5 )                                    
   {                                                                            
     stc("You must obtain level 5 Blood to Embrace.\n\r",ch);
     return;                                                                    
   }                                                                            

    sprintf(buf,"%s leaps toward %s baring his fangs.\n\r",ch->name,victim->short_descr);
    act(buf,ch,NULL,NULL,TO_ROOM);
    sprintf(buf,"You leap toward %s baring your fangs.\n\r",victim->short_descr);
    send_to_char(buf,ch);
    WAIT_STATE(ch, 15);
    
    if (victim->position != POS_STUNNED && victim->position != POS_SLEEPING && victim->position != POS_DEAD)
    {
      send_to_char("They lunge away from you.\n\r",ch);
      sprintf(buf,"%s lunges away from %s.",victim->name,ch->short_descr);
      act(buf,ch,NULL,NULL,TO_ROOM);
      return;
    }

    send_to_char("You bury your fangs into their neck, and begins an orgy of blood-sucking!\n\r",ch);
    sprintf(buf,"%s buries his fangs into %s's neck, and begins an orgy of blood-sucking!\n\r",ch->name,victim->short_descr);
    act(buf,ch,NULL,NULL,TO_ROOM);
	
	/* New update send routine, allows for anything to get embraced.         */
	/* and sets a mobs blood to its level *8.Shakti	     					 */

	victim->embraced = ch;
    ch->embracing = victim;
	if (IS_NPC(victim))
	{
		(victim->practice = victim->level  );
		(victim->practice *= 8);
	}	

	return ;


}

void do_cleave (CHAR_DATA *ch,char *argument)
{
    CHAR_DATA *victim;
    OBJ_DATA *obj;
    char arg [MAX_INPUT_LENGTH];
    char buf [MAX_STRING_LENGTH];

    argument = one_argument (argument, arg);
        
    
    if (IS_NPC(ch)) return;
    if (!IS_CLASS(ch, CLASS_VAMPIRE))
    {
    send_to_char("Huh?\n\r",ch);
    return;
    }

    if (ch->power[DISC_VAMP_OFFENSIVE] < 3 )
    {
    send_to_char("You must obtain level 3 Offensive to use Cleave.\n\r",ch);
    return;
    }
    if ( arg[0] == '\0' )
    {
    send_to_char("Who do you want to rip limb from limb?\n\r",ch);
    return;
    }
    victim = get_char_room(ch, arg);
    if ( ( victim = get_char_room( ch, arg) ) == NULL )
    {
     send_to_char("They arent here.\n\r",ch);
     return;
    }

   if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))
   {
     send_to_char("You cannot attack them here.\n\r",ch);
     return;
   }

   if (is_safe(ch,victim) == TRUE) 
     return;
   if (!IS_SET(ch->pcdata->stats[UNI_AFF],DEM_MIGHT))
   {
	send_to_char("You are not strong enough to rip anyone limb from limb!\n\r",ch);
	return;
   }
   WAIT_STATE(ch,35);
    sprintf(buf,"A fierce look of rage blazes from %s's eyes.",ch->name);
    act(buf,ch,NULL,NULL,TO_ROOM);
    send_to_char("Your eyes blaze with rage!\n\r",ch);
    if (IS_ARM_R(victim,LOST_ARM) && IS_ARM_L(victim,LOST_ARM) &&
        IS_LEG_R(victim,LOST_LEG) && IS_LEG_L(victim,LOST_LEG))
        {
        send_to_char("All of their limbs are severed already!\n\r",ch);
        return;
        }
       if (number_percent ( ) < 15 )
       {
        if (!IS_ARM_R(victim,LOST_ARM))
        {
        SET_BIT(victim->loc_hp[3],LOST_ARM);
        if ((obj = get_eq_char( victim, WEAR_HOLD )) != NULL )
           take_item(victim,obj);
        if ((obj = get_eq_char( victim, WEAR_HANDS )) != NULL)
           take_item(victim,obj);
        if ((obj = get_eq_char( victim, WEAR_WRIST_R )) != NULL)
           take_item(victim,obj);
        if ((obj = get_eq_char( victim, WEAR_FINGER_R )) != NULL)
           take_item(victim,obj);
        make_part(victim,"arm");
	sprintf(buf, "%s rips %s's arm off!",ch->name, victim->name);
        act(buf,ch,NULL,NULL,TO_ROOM);
        send_to_char(buf,ch);
        return;
        }
        if (!IS_ARM_L(victim,LOST_ARM))
        {
        SET_BIT(victim->loc_hp[2],LOST_ARM);
        if ((obj = get_eq_char( victim, WEAR_HOLD )) != NULL )
           take_item(victim,obj);
        if ((obj = get_eq_char( victim, WEAR_HANDS )) != NULL)
           take_item(victim,obj);
        if ((obj = get_eq_char( victim, WEAR_WRIST_L )) != NULL)
           take_item(victim,obj);
        if ((obj = get_eq_char( victim, WEAR_FINGER_L )) != NULL)
           take_item(victim,obj);
        make_part(victim,"arm");
	sprintf(buf, "%s rips %s's arm off!",ch->name, victim->name);
        act(buf,ch,NULL,NULL,TO_ROOM);
        send_to_char(buf,ch);
        return;
        }
        if (!IS_LEG_R(victim,LOST_LEG))
        {
        SET_BIT(victim->loc_hp[5],LOST_LEG);
        if ((obj = get_eq_char( victim, WEAR_FEET )) != NULL )
           take_item(victim,obj);
        if ((obj = get_eq_char( victim, WEAR_LEGS )) != NULL)
           take_item(victim,obj);
        make_part(victim,"leg");
	sprintf(buf, "%s rips %s's leg off!",ch->name, victim->name);
        act(buf,ch,NULL,NULL,TO_ROOM);
        send_to_char(buf,ch);
        return;
        }
        if (!IS_LEG_L(victim,LOST_LEG))
        {
        SET_BIT(victim->loc_hp[4],LOST_LEG);
        if ((obj = get_eq_char( victim, WEAR_FEET )) != NULL )
           take_item(victim,obj);
        if ((obj = get_eq_char( victim, WEAR_LEGS )) != NULL)
           take_item(victim,obj);
        make_part(victim,"leg");
	sprintf(buf, "%s rips %s's leg off!",ch->name, victim->name);
        act(buf,ch,NULL,NULL,TO_ROOM);
        send_to_char(buf,ch);
        return;
        }
        }
send_to_char("You failed.\n\r",ch);
 
return;
}

void do_servant(CHAR_DATA *ch, char *argument )
{
 
    char buf [MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    AFFECT_DATA af;
    if (IS_NPC(ch)) return;
    if (!IS_CLASS(ch, CLASS_VAMPIRE))
     {
     send_to_char("Huh?\n\r",ch);
     return;
     }
    if (ch->power[DISC_VAMP_DOMI] < 1)
    {
    send_to_char("You require level 1 Domination to create a servant.\n\r",ch);
    return;
    }
 
    if (ch->pcdata->followers > 5)
    {
	send_to_char("Nothing happens.\n\r",ch);
	return;
    }
    ch->pcdata->followers++;
 
    victim=create_mobile( get_mob_index( MOB_VNUM_SERVANT ) );
    victim->level = 300;
    victim->hit = 30000;
    victim->max_hit = 30000;
    victim->hitroll = 100;
    victim->damroll = 100;
    victim->armor = 700;
 
    strcpy(buf,"Come forth, creature of darkness, and do my bidding!");
    do_say( ch, buf );
 
    send_to_char( "A demonic servant bursts from the ground and bows before you.\n\r",ch );
    act( "$N bursts from the ground and bows before $n.", ch, NULL, victim, TO_ROOM );
 
    char_to_room( victim, ch->in_room );
 
 
    add_follower( victim, ch );
    af.duration  = 666;
    af.location  = APPLY_NONE;
    af.modifier  = 0;
    af.bitvector = AFF_CHARM;
    affect_to_char( victim, &af );
    SET_BIT(victim->act, ACT_NOEXP); 
    return;
}

void do_beckon(CHAR_DATA *ch, char *argument  )
{
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    one_argument( argument,arg);
 
    if (IS_NPC(ch)) return;
    if (!IS_CLASS(ch,CLASS_VAMPIRE))
    {
    send_to_char("Huh?\n\r",ch);
    return;
    }
    if (ch->power[DISC_VAMP_DOMI] < 2)
    {
    send_to_char("You require level 2 Domination to beckon the wild.\n\r",ch);
    return;
    }
    if ( arg[0] == '\0' )
    {
        send_to_char( "You can beckon a frog, a raven, a cat or a dog.\n\r", ch );
	return;
    }
 
    if (ch->pcdata->followers > 4 )
    {
    send_to_char("Nothing happened.\n\r",ch);
    return;
    }
    
    if ( !str_cmp( argument, "frog" ) )
    {
	victim = create_mobile( get_mob_index( MOB_VNUM_FROG ) );
	if (victim == NULL)
        {send_to_char("Error - please inform Infidel.\n\r",ch); return;}
    }
    else if ( !str_cmp( argument, "raven" ) )
    {
	victim = create_mobile( get_mob_index( MOB_VNUM_RAVEN ) );
	if (victim == NULL)
        {send_to_char("Error - please inform Infidel.\n\r",ch); return;}
    }
    else if ( !str_cmp( argument, "cat" ) )
    {
	victim = create_mobile( get_mob_index( MOB_VNUM_CAT ) );
	if (victim == NULL)
        {send_to_char("Error - please inform Infidel.\n\r",ch); return;}
    }
    else if ( !str_cmp( argument, "dog" ) )
    {
	victim = create_mobile( get_mob_index( MOB_VNUM_DOG ) );
	if (victim == NULL)
        {send_to_char("Error - please inform Infidel.\n\r",ch); return;}
    }
    else 
    {
        send_to_char( "Your can beckon a frog, a raven, a cat or a dog.\n\r", ch );
	return;
    }
 
    act( "You whistle loudly and $N walks in.", ch, NULL, victim, TO_CHAR);
    act( "$n whistles loudly and $N walks in.", ch, NULL, victim, TO_ROOM);
    char_to_room( victim, ch->in_room );
    ch->pcdata->followers += 1;
    SET_BIT(victim->act, ACT_NOEXP);
    return;
}
void do_spit( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;

    char buf[MAX_STRING_LENGTH];
  
  int dam;
    if (IS_NPC(ch)) return;
    if (!IS_CLASS(ch,CLASS_VAMPIRE)) 
    {
    send_to_char("Huh?\n\r",ch);
    return;
    }
    if (ch->power[DISC_VAMP_OFFENSIVE] < 4)
    {
    send_to_char("You need level 4 Offensive to spit.\n\r",ch);
    return;
    }
    if ( ( victim = ch->fighting ) == NULL )
    {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
    }
    if (ch->pcdata->condition[COND_THIRST] < 5)
    {
    send_to_char("You dont have enough blood.\n\r",ch); 
    return; 
    }
    WAIT_STATE( ch, 12 );
    if (!IS_NPC(victim))
    {
    dam = ch->power[DISC_VAMP_BLOOD] * 50;
    } 
    else if (IS_NPC(victim))
    {
    dam = ch->power[DISC_VAMP_BLOOD] * 250;
    }
    ch->pcdata->condition[COND_THIRST] -= 5;
    if ( !IS_NPC(victim) && IS_CLASS(victim, CLASS_WEREWOLF) )
    {
	if (victim->power[DISC_WERE_BOAR] > 2 ) dam *= 0.5;
    }
 
    dam += number_range(1,30);
    if ( dam <= 0 )
       dam = 1;
sprintf(buf,"Your spit of blood hits and blinds $N incredibly hard! [%d]",dam);
act(buf,ch,NULL,victim,TO_CHAR);
sprintf(buf,"$n's spit of blood hits and blinds you incredibly hard! [%d]",dam);
act(buf,ch,NULL,victim,TO_VICT);
sprintf(buf,"$n's spit of blood hits and blinds $N incredibly hard! [%d]",dam);
act(buf,ch,NULL,victim,TO_NOTVICT);
    if (!IS_SET(victim->flag2,AFF2_TOTALBLIND)) 
    SET_BIT(victim->flag2,AFF2_TOTALBLIND);
    send_to_char("\n\r",ch);
    hurt_person(ch,victim,dam);
    set_fighting(ch,victim);
    return;
}

void do_awe ( CHAR_DATA *ch, char *argument )
{
        if (IS_NPC(ch)) return;
        if (!IS_CLASS(ch, CLASS_VAMPIRE))
        {
          send_to_char("Huh?\n\r", ch);
          return;
        }
        if (ch->power[DISC_VAMP_DEFENSIVE] < 3)
        {
          send_to_char("You must obtain at least level 3 in Defensive to use Awe.\n\r", ch);
          return;
        }
        if (IS_EXTRA(ch, EXTRA_AWE))
        {
          REMOVE_BIT(ch->extra, EXTRA_AWE);
          send_to_char("You are no longer Awe Inspiring.\n\r", ch);
          act("$n is no longer awe inspiring.", ch, NULL, NULL, TO_ROOM);
          return;
        }
        SET_BIT(ch->extra, EXTRA_AWE);
        send_to_char("You are now Awe Inspiring.\n\r", ch);
        act("$n is now awe inspiring", ch, NULL, NULL, TO_ROOM);
        return;


}

void do_plasma( CHAR_DATA *ch, char *argument )
{
    OBJ_DATA *obj;

     if ( IS_NPC(ch) )
        return;

    if (!IS_CLASS(ch, CLASS_VAMPIRE))
    {
        send_to_char("Huh?\n\r", ch);
        return;
    }

    if (ch->power[DISC_VAMP_CONFUSION] < 2)
    {
       send_to_char("You must obtain at least level 2 in Confusion to use Plasma Form.\n\r", ch);
       return;
    }

  if (IS_AFFECTED(ch,AFF_POLYMORPH))
  {
    send_to_char( "You must be in human form.\n\r", ch);
    return;
  }
  if (ch->fight_timer>0)
  {
    send_to_char("Not with a fighttimer.\n\r",ch);
    return;
  }
  if ((obj = create_object(get_obj_index(30007),60)) == NULL)
  {
    send_to_char( "Object bug, tell Jobo about it.\n\r", ch);
    return;
  }
  obj_to_room(obj,ch->in_room);
  act("$n transforms into $p and falls to the ground.",ch,obj,NULL,TO_ROOM);
  act("You transform into $p and fall to the ground.",ch,obj,NULL,TO_CHAR);
  ch->pcdata->obj_vnum = 30007;
  obj->chobj = ch;
  ch->pcdata->chobj = obj;
  SET_BIT(ch->affected_by, AFF_POLYMORPH);
  SET_BIT(ch->extra, EXTRA_OSWITCH);
  free_string(ch->morph);
  ch->morph = str_dup(obj->short_descr);
  return;
}

void do_taste( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char      buf [MAX_STRING_LENGTH];
    char      lin [MAX_STRING_LENGTH];
    char      arg [MAX_INPUT_LENGTH];

    argument = one_argument (argument, arg );

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_VAMPIRE))
    {
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if (ch->power[DISC_VAMP_BLOOD] < 3)
    {
        send_to_char("You must obtain at least level 3 in Blood to use Taste of Blood.\n\r",ch);
        return;
    }

       if ( ( victim = get_char_room( ch, arg ) ) == NULL )
    {
        send_to_char( "They aren't here.\n\r", ch );
        return;
    }

    if (!IS_CLASS(victim, CLASS_VAMPIRE))
    {
        send_to_char( "Only useful on vampire targets.\n\r",ch);
        return;
    }

    if (IS_NPC(victim))
    {
        send_to_char( "Only useful on vampire targets.\n\r",ch);
        return;
    }
	sprintf(buf,"You examine $N's blood carefully.\n\r");
	act(buf,ch,NULL,victim,TO_CHAR);
	sprintf(buf,"$n examines your blood carefully.\n\r");
	act(buf,ch,NULL,victim,TO_VICT);
	sprintf(buf,"$n examines $N's blood carefully.\n\r");
	act(buf,ch,NULL,victim,TO_NOTVICT);
	send_to_char("\n\r",ch);
	send_to_char("\n\r",victim);
	sprintf( lin,"---------------------------\n\r");
	send_to_char( lin,ch);
	send_to_char("Vampire Status\n\r",ch);
	send_to_char(lin,ch);
	sprintf(buf,"Generation:%d  Bloodpool:%d\n\r",
	victim->generation,victim->pcdata->condition[COND_THIRST]);
	send_to_char(buf,ch);
	send_to_char(lin,ch);
	return;
}


void do_theft( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char      arg [MAX_INPUT_LENGTH];
    char      buf [MAX_INPUT_LENGTH];
    int bloodpool;
        int blpr; /* Blood sucked storage variable. Shakti */

    argument = one_argument( argument, arg );

    if (ch->generation < 0)
        ch->generation = 4;

    {
    if (ch->generation == 0) bloodpool = 5000;
    else bloodpool = (2000 / ch->generation);
    }

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_VAMPIRE))
    {
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if (ch->power[DISC_VAMP_BLOOD] < 4)
    {
        send_to_char("You must obtain at least level 4 in Blood to use Theft of Vitae.\n\r",ch);
        return;
    }


    if ( arg[0] == '\0' )
    {
        send_to_char( "Steal blood from whom?\n\r", ch );
        return;
    }

    if (IS_AFFECTED(ch,AFF_POLYMORPH) && !IS_VAMPAFF(ch,VAM_DISGUISED))
    {
        send_to_char( "Not while polymorphed.\n\r", ch );
        return;
    }

    if ( ( victim = get_char_room( ch, arg ) ) == NULL )
    {
        send_to_char( "They aren't here.\n\r", ch );
        return;
    }
        if (IS_NPC(victim) && IS_SET(victim->act, ACT_NOAUTOKILL)) {
        send_to_char("You can't do that to them.\n\r", ch );
        return;}
/*
    if ( IS_NPC(victim) )
    {
        send_to_char( "Lower life forms are immune to Theft of Vitae.\n\r", ch);
        return;
    }
*/
    if (!IS_NPC(victim) && victim->pcdata->condition[COND_THIRST] <= 0)
    {
        send_to_char( "There isn't enough blood to steal.\n\r", ch);
        return;
    }
    if (!IS_NPC(victim) && IS_EMPLOYEE(victim) && victim != ch )
    {
        send_to_char( "You can only steal blood from Avatar's or lower.\n\r", ch );
        return;
    }
if (is_safe(ch,victim) == TRUE) return;

if (!IS_NPC(victim)) {
        sprintf(buf,"A stream of blood shoots from %s into your body.",victim->name);
        act(buf,ch,NULL,victim,TO_CHAR);
        sprintf(buf,"A stream of blood shoots from %s into %s.",victim->name,ch->name);
        act(buf,ch,NULL,victim,TO_ROOM);
        sprintf(buf,"A stream of blood shoots from your body into %s.",ch->name);
        act(buf,ch,NULL,victim,TO_VICT);
        } else {
        sprintf(buf,"A stream of blood shoots from %s into your body.",victim->short_descr);
        act(buf,ch,NULL,victim,TO_CHAR);
        sprintf(buf,"A stream of blood shoots from %s into %s.",victim->short_descr,ch->name);
        act(buf,ch,NULL,victim,TO_ROOM);
        sprintf(buf,"A stream of blood shoots from your body into %s.",ch->name);
        act(buf,ch,NULL,victim,TO_VICT);


        }
        ch->pcdata->condition[COND_THIRST] += number_range(10,15);


                if (IS_NPC(victim))
        {
/* Raw-killing it from one theft is stupid. Im going to use the primal        */
/* stat on the mobs for blood its quick, effective, and straightford, AND         */
/* no new fields have to be added to the mob.Shakti 09/07/98                              */
                        (blpr = number_range (30,40) );
                        (victim->practice -=blpr);
            (ch->pcdata->condition[COND_THIRST] += blpr);
                if (victim->practice < 0) {
                sprintf(buf,"%s falls over dead.",victim->short_descr);
                act(buf,ch,NULL,victim,TO_ROOM);
                act(buf,ch,NULL,victim,TO_CHAR);
                raw_kill(victim);}

        if (ch->fighting == NULL) set_fighting(ch,victim);

         return;
        }
        if (IS_SET(victim->act, PLR_ACID))
        {
        send_to_char("Their blood is a deadly acid!\n\r", ch);
        hurt_person(victim,ch,300);
        victim->pcdata->condition[COND_THIRST] -= 30;
        return;
        }

    if (!IS_NPC(victim))
    {
    victim->pcdata->condition[COND_THIRST] -=number_range(30,40);
    }

   if (victim->pcdata->condition[COND_THIRST] <= 0)
    {
       victim->pcdata->condition[COND_THIRST] = 0;
    }
        if (ch->fighting == NULL) set_fighting(ch,victim);

   return;
}

void do_zuloform( CHAR_DATA *ch, char *argument )
{
    char arg [MAX_INPUT_LENGTH];
    char buf [MAX_STRING_LENGTH];
    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;


    if (ch->power[DISC_VAMP_CONFUSION] < 4)
    {
        send_to_char("You must obtain at least level 4 in Confusion to use Zuloform.\n\r",ch);
        return;
    }

    if (IS_EXTRA(ch,EXTRA_DRAGON))
    {
    send_to_char("You cannot unzulo while a dragon.\n\r",ch);
    return;
    }
    if(IS_POLYAFF(ch, POLY_DRAGON))
    {
        stc( "You can't do that.\n\r",ch);
        return;
    }

    if (IS_POLYAFF(ch, POLY_ZULOFORM))
    {
        REMOVE_BIT(ch->polyaff, POLY_ZULOFORM);
        REMOVE_BIT(ch->affected_by, AFF_POLYMORPH);
        act( "You transform into human form.", ch, NULL, NULL, TO_CHAR );
        act( "$n's shrinks back into human form.", ch, NULL, NULL, TO_ROOM );
        if (ch->hit < 1) ch->hit = 1;
        ch->damroll = ch->damroll - 150;
        ch->hitroll = ch->hitroll - 150;
        free_string( ch->morph );
        ch->morph = str_dup( "" );
        return;
    }
    else if (IS_AFFECTED(ch,AFF_POLYMORPH))
    {
      send_to_char("You cant zulo when changed.\n\r",ch);
      return;
    }
    if ( ch->pcdata->condition[COND_THIRST] < 200 )
    {
      send_to_char("You have insufficient blood.\n\r",ch);
      return;
    }
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        ch->pcdata->condition[COND_THIRST] -= number_range(100,200);
        act( "You transform into large beast.", ch, NULL, NULL, TO_CHAR );
        act( "$n's body grows and distorts into a large beast.", ch, NULL, NULL, TO_ROOM );
        ch->pcdata->mod_str = 15;
        ch->pcdata->mod_dex = 15;
        SET_BIT(ch->polyaff, POLY_ZULOFORM);
        SET_BIT(ch->affected_by, AFF_POLYMORPH);
        sprintf(buf, "A big black monster");
        free_string( ch->morph );
        ch->morph = str_dup( buf );
        ch->damroll = ch->damroll + 150;
        ch->hitroll = ch->hitroll + 150;
        return;
}

void horn args((CHAR_DATA *ch));
void declaw(CHAR_DATA *ch)
{
    if (!IS_VAMPAFF(ch, VAM_CLAWS)) return;

    send_to_char("You retract your claws.\n\r",ch);
    act("$n retracts $s claws.",ch, NULL, NULL, TO_ROOM);
    REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_CLAWS);
}

void dehorn(CHAR_DATA *ch)
{
    if (!IS_VAMPAFF(ch, VAM_HORNS)) return;

    send_to_char("Your horns burrow back into your skull.\n\r",ch);
    act("$n's horns retract into $s skull.",ch, NULL, NULL, TO_ROOM);
    REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_HORNS);
}

void horn(CHAR_DATA *ch)
{
    OBJ_DATA *obj;

    if (IS_VAMPAFF(ch, VAM_HORNS)) return;

    /* Only certain demons may use their horns */
    if (ch->power[DISC_DAEM_ATTA] < 4) return;

    send_to_char("Sharp horns grow out of your skull.\n\r",ch);
    act("Sharp horns grow out of $n's skull.",ch, NULL, NULL, TO_ROOM);

    if ( (obj = get_eq_char(ch, WEAR_HEAD)) != NULL)
    {
        act("Your horns shred $p.", ch, obj, NULL, TO_CHAR);
        act("$n's horns shred $p.", ch, obj, NULL, TO_ROOM);
        extract_obj(obj);
    }

    SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_HORNS);
}

void defang(CHAR_DATA *ch)
{
    if (!IS_VAMPAFF(ch, VAM_FANGS)) return;

    send_to_char("Your fangs slide back into your gums.\n\r",ch);
    act("$n retracts $s fangs back into $s gums.",ch, NULL, NULL, TO_ROOM);
    REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_FANGS);
}

void do_claws(CHAR_DATA *ch, char *argument)
{
    if (ch->cur_form != 0 && !form_data[ch->cur_form].can_use_claws )
    {
        send_to_char("You cannot use your claws in this form.\n\r", ch);
        return;
    }
   if (IS_CLASS(ch, CLASS_WEREWOLF))
   {
        if (ch->power[DISC_WERE_WOLF] < 1)
      {
            stc("Huh?\n\r",ch);
            return;
        }
   }
   else if (IS_CLASS(ch, CLASS_DEMON) || IS_SET(ch->special, SPC_CHAMPION))
    {
        if (!IS_DEMPOWER( ch, DEM_CLAWS) && ch->power[DISC_DAEM_ATTA] < 1)
        {
            send_to_char("You haven't been granted the gift of claws or attack is below level 1.\n\r",ch);
            return;
        }
    }
   else if (IS_CLASS(ch, CLASS_VAMPIRE))
   {
        if (ch->power[DISC_VAMP_OFFENSIVE] < 2)
        {
            stc("Huh?\n\r",ch);
            return;
        }
   }
   else if (IS_CLASS(ch, CLASS_TANARRI))
   {
   if (!IS_SET(ch->pcdata->powers[TANARRI_POWER], TANARRI_CLAWS))
     {
       send_to_char("Huh?\n\r",ch);
       return;
     }
  }
   else
   {
        stc("Huh?\n\r",ch);
        return;
   }

   if (IS_VAMPAFF(ch, VAM_CLAWS))
   {
     if (IS_CLASS(ch, CLASS_VAMPIRE) || IS_CLASS(ch, CLASS_DEMON))
     {
        if (ch->rage >0)
        {
            send_to_char("You cannot retract your claws while the beast is within you.\n\r", ch);
            return;
        }
     }
        send_to_char("You retract your claws.\n\r",ch);
        act("$n retracts $s claws.",ch, NULL, NULL, TO_ROOM);
        REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_CLAWS);
   }
   else
   {
        send_to_char("Wicked claws extend from your fingers.\n\r",ch);
        act("Long sharp claws extend from $n's fingers.",ch, NULL, NULL, TO_ROOM);
        remove_obj( ch, WEAR_WIELD, TRUE );
        remove_obj( ch, WEAR_HOLD, TRUE );
        remove_obj( ch, WEAR_THIRD, TRUE );
        remove_obj( ch, WEAR_FOURTH, TRUE );
        SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_CLAWS);
   }
}

void do_fangs(CHAR_DATA *ch, char *argument)
{
    if (ch->cur_form != 0 && !form_data[ch->cur_form].can_use_claws )
    {
        send_to_char("You cannot use your fangs in this form.\n\r", ch);
        return;
    }

   if (IS_CLASS(ch, CLASS_WEREWOLF))
   {
        if (ch->power[DISC_WERE_WOLF] < 2)
        {
            stc("Huh?\n\r",ch);
            return;
        }
   }

        else if (IS_CLASS(ch, CLASS_DEMON) || IS_SET(ch->special, SPC_CHAMPION))
    {
        if (!IS_DEMPOWER( ch, DEM_FANGS) && ch->power[DISC_DAEM_ATTA] < 2)
        {
            send_to_char("You haven't been granted the gift of fangs.\n\r",ch);
            return;
        }
    }

   else if (!IS_CLASS(ch, CLASS_VAMPIRE))
   {
        stc("Huh?\n\r",ch);
        return;
   }

   if (IS_VAMPAFF(ch, VAM_FANGS))
   {
     if (IS_CLASS(ch, CLASS_VAMPIRE) || IS_CLASS(ch, CLASS_DEMON))
     {
        if (ch->rage >0)
        {
            send_to_char("You cannot retract your fangs while the beast is within you.\n\r", ch);
            return;
        }
     }
        send_to_char("Your fangs slide back into your gums.\n\r",ch);
        act("$n retracts $s fangs back into $s gums.",ch, NULL, NULL, TO_ROOM);
        REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_FANGS);
   }
   else
   {
        send_to_char("Sharp fangs slide out of your gums.\n\r",ch);
        act("Sharp fangs slide out of $n's gums.",ch, NULL, NULL, TO_ROOM);
        SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_FANGS);
   }
}


void do_inconnu( CHAR_DATA *ch, char *argument )
{
    char      arg [MAX_INPUT_LENGTH];
    char      buf [MAX_INPUT_LENGTH];

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_VAMPIRE) )
    {
        send_to_char("Huh?\n\r",ch);
        return;
    }


    if (ch->pcdata->rank < AGE_ELDER)
    {
        send_to_char("You must be at least an Elder to become an Inconnu.\n\r",ch);
        return;
    }

    if (IS_SET(ch->special, SPC_INCONNU))
    {
        send_to_char("But you are already an Inconnu!\n\r",ch);
        return;
    }

    if (ch->exp < 1000000)
    {
        send_to_char("It costs 1000000 exp to become an Inconnu.\n\r",ch);
        return;
    }

    if (IS_SET(ch->special, SPC_ANARCH)) REMOVE_BIT(ch->special, SPC_ANARCH);
    ch->exp -= 1000000;
    send_to_char("You are now an Inconnu.\n\r",ch);
    sprintf(buf,"%s is now an Inconnu!",ch->name);
    do_info(ch,buf);
    SET_BIT(ch->special, SPC_INCONNU);
    return;
}

void do_shadowsight( CHAR_DATA *ch, char *argument )  {
    char      arg [MAX_INPUT_LENGTH];

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

    if (IS_CLASS(ch, CLASS_WEREWOLF) && ch->power[DISC_WERE_HAWK] < 2)
    {
        stc("Huh?\n\r",ch);
        return;
    }

    if ( IS_CLASS(ch, CLASS_VAMPIRE) && ch->power[DISC_VAMP_CONCEALMENT] < 2)
        {
            send_to_char("Huh?\n\r",ch);
            return;
        }
    if (IS_AFFECTED(ch, AFF_SHADOWSIGHT));
    {
        send_to_char("You can no longer see between planes.\n\r",ch);
        REMOVE_BIT(ch->affected_by, AFF_SHADOWSIGHT);
        return;
    }
    if (IS_CLASS(ch, CLASS_VAMPIRE) && ch->pcdata->condition[COND_THIRST] < 10)
    {
        send_to_char("You have insufficient blood.\n\r",ch);
        return;
    }
    if (IS_CLASS(ch, CLASS_VAMPIRE))
        ch->pcdata->condition[COND_THIRST] -= number_range(5,10);
    send_to_char("You can now see between planes.\n\r",ch);
    SET_BIT(ch->affected_by, AFF_SHADOWSIGHT);
    return;
}

void do_mutate( CHAR_DATA *ch, char *argument )
{
    char arg [MAX_INPUT_LENGTH];
    char buf [MAX_STRING_LENGTH];
    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_VAMPIRE))
    {
        send_to_char("Huh?\n\r",ch);
        return;
    }

    if (ch->power[DISC_VAMP_CONFUSION] < 1  )
    {
        send_to_char("You must obtain at least level 1 in Confusion to use Mutate.\n\r",ch);
        return;
    }

    if ( arg[0] == '\0' )
    {
        send_to_char( "You can mutate between 'human', 'bat', 'wolf' and 'mist' forms.\n\r", ch );
        return;
    }


    if ( !str_cmp(arg,"bat") )
    {
        if (IS_AFFECTED(ch, AFF_POLYMORPH))
        {
            send_to_char( "You can only mutate from human form.\n\r", ch );
            return;
        }
        if ( ch->pcdata->condition[COND_THIRST] < 50 )
        {
            send_to_char("You have insufficient blood.\n\r",ch);
            return;
        }
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        ch->pcdata->condition[COND_THIRST] -= number_range(40,50);
        clear_stats(ch);
        act( "You transform into bat form.", ch, NULL, NULL, TO_CHAR );
        act( "$n transforms into a bat.", ch, NULL, NULL, TO_ROOM );
        SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_FLYING);
        SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_SONIC);
/*      SET_BIT(ch->pcdata->powers[WOLF_POLYAFF], POLY_BAT);*/
        SET_BIT(ch->polyaff, POLY_BAT);
        SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_CHANGED);
        SET_BIT(ch->affected_by, AFF_POLYMORPH);
        sprintf(buf, "%s the vampire bat", ch->name);
        free_string( ch->morph );
        ch->morph = str_dup( buf );
        return;
    }
    else if ( !str_cmp(arg,"wolf") )
    {
        if (IS_AFFECTED(ch, AFF_POLYMORPH))
        {
            send_to_char( "You can only polymorph from human form.\n\r", ch );
            return;
        }
        if ( ch->pcdata->condition[COND_THIRST] < 50 )
        {
            send_to_char("You have insufficient blood.\n\r",ch);
            return;
        }
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        ch->pcdata->condition[COND_THIRST] -= number_range(40,50);
        act( "You transform into wolf form.", ch, NULL, NULL, TO_CHAR );
        act( "$n transforms into a dire wolf.", ch, NULL, NULL, TO_ROOM );
        clear_stats(ch);
        if (ch->wpn[0] > 0) 
        {
            ch->hitroll += (ch->wpn[0]);
            ch->damroll += (ch->wpn[0]);
            ch->armor   -= (ch->wpn[0] * 3);
        }
        ch->pcdata->mod_str = 10;
/*      SET_BIT(ch->pcdata->powers[WOLF_POLYAFF], POLY_WOLF);*/
        SET_BIT(ch->polyaff, POLY_WOLF);
        SET_BIT(ch->affected_by, AFF_POLYMORPH);
        SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_CHANGED);
        sprintf(buf, "%s the dire wolf", ch->name);
        free_string( ch->morph );
        ch->morph = str_dup( buf );
        return;
    }
    else if ( !str_cmp(arg,"mist") )
    {
        if (IS_AFFECTED(ch, AFF_POLYMORPH))
        {
            send_to_char( "You can only polymorph from human form.\n\r", ch );
            return;
        }

        if (has_timer(ch)) return;

        if ( ch->pcdata->condition[COND_THIRST] < 50 )
        {
            send_to_char("You have insufficient blood.\n\r",ch);
            return;
        }

        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        ch->pcdata->condition[COND_THIRST] -= number_range(40,50);
        act( "You transform into mist form.", ch, NULL, NULL, TO_CHAR );
        act( "$n transforms into a white mist.", ch, NULL, NULL, TO_ROOM );
        if (IS_EXTRA(ch, TIED_UP))
        {
            act("The ropes binding you fall through your ethereal form.",ch,NULL,NULL,TO_CHAR);
            act("The ropes binding $n fall through $s ethereal form.",ch,NULL,NULL,TO_ROOM);
            REMOVE_BIT(ch->extra, TIED_UP);
            REMOVE_BIT(ch->extra, GAGGED);
            REMOVE_BIT(ch->extra, BLINDFOLDED);
        }
        if (is_affected(ch, gsn_web))
        {
            act("The webbing entrapping $n falls through $s ethereal form.",ch,NULL,NULL,TO_ROOM);
            send_to_char("The webbing entrapping you falls through your ethereal form.\n\r",ch);
            affect_strip(ch, gsn_web);
        }
    clear_stats(ch);
/*      SET_BIT(ch->pcdata->powers[WOLF_POLYAFF], POLY_MIST);*/
        SET_BIT(ch->polyaff, POLY_MIST);
        SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_CHANGED);
        SET_BIT(ch->affected_by, AFF_POLYMORPH);
        SET_BIT(ch->affected_by, AFF_ETHEREAL);
        sprintf(buf, "%s the white mist", ch->name);
        free_string( ch->morph );
        ch->morph = str_dup( buf );
        return;
    }
    else if ( !str_cmp(arg,"human") )
    {
       if (!IS_AFFECTED(ch, AFF_POLYMORPH))
        {
            send_to_char( "You are already in human form.\n\r", ch );
            return;
        }
        if (IS_VAMPAFF(ch, VAM_CHANGED) && IS_POLYAFF(ch, POLY_BAT))
        {
            REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_FLYING);
            REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_SONIC);
            REMOVE_BIT(ch->polyaff, POLY_BAT);
/*          REMOVE_BIT(ch->pcdata->powers[WOLF_POLYAFF], POLY_BAT);*/
        }
        else if (IS_VAMPAFF(ch, VAM_CHANGED) && IS_POLYAFF(ch, POLY_WOLF))
        {
/*          REMOVE_BIT(ch->pcdata->powers[WOLF_POLYAFF], POLY_WOLF);*/
            REMOVE_BIT(ch->polyaff, POLY_WOLF);
            if (ch->hit < 1) ch->hit = 1;
        }
        else if (IS_VAMPAFF(ch, VAM_CHANGED) && IS_POLYAFF(ch, POLY_MIST))
        {
/*          REMOVE_BIT(ch->pcdata->powers[WOLF_POLYAFF], POLY_MIST);*/
            REMOVE_BIT(ch->polyaff, POLY_MIST);
            REMOVE_BIT(ch->affected_by, AFF_ETHEREAL);
        }
        else
        {
            /* In case they try to change to human from a non-vamp form */
            send_to_char( "You seem to be stuck in this form.\n\r", ch );
            return;
        }
        act( "You transform into human form.", ch, NULL, NULL, TO_CHAR );
        act( "$n transforms into human form.", ch, NULL, NULL, TO_ROOM );
        REMOVE_BIT(ch->affected_by, AFF_POLYMORPH);
        REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_CHANGED);
    clear_stats(ch);
        free_string( ch->morph );
        ch->morph = str_dup( "" );
        return;
    }
    else
        send_to_char( "You can change between 'human', 'bat', 'wolf' and 'mist' forms.\n\r", ch );
    return;
}

void do_clandisc( CHAR_DATA *ch, char *argument )
{
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];
    char buf[MAX_STRING_LENGTH];

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_VAMPIRE))
    {
        send_to_char("Huh?\n\r",ch);
        return;
    }

    if (arg1[0] == '\0' && arg2[0] == '\0')
    {
        do_stat(ch,"");
        return;
    }
    if (arg2[0] == '\0')
    {
        if (!str_cmp(arg1,"confusion"))
        {
            send_to_char("Confusion: The discipline of distorting reality.\n\r",ch);
            if (ch->power[DISC_VAMP_CONFUSION] < 1)
                send_to_char("You have none of the Confusion discipline powers.\n\r",ch);
            return;
        }
        else if (!str_cmp(arg1,"concealment"))
        {
            send_to_char("Concealment: The discipline of concealing one's self.\n\r",ch);
            if (ch->power[DISC_VAMP_CONCEALMENT] < 1)
                send_to_char("You have none of the Concealment discipline powers.\n\r",ch);
            return;
        }
        else if (!str_cmp(arg1,"offensive"))
        {
            send_to_char("Offensive: The disciplines of offense.\n\r",ch);
            if (ch->power[DISC_VAMP_OFFENSIVE] < 1)
                send_to_char("You have none of the Offensive discipline powers.\n\r",ch);
            return;
        }
        else if (!str_cmp(arg1,"blood"))
        {
            send_to_char("Blood: The discipline of blood.\n\r",ch);
            if (ch->power[DISC_VAMP_BLOOD] < 1)
                send_to_char("You have none of the Blood discipline powers.\n\r",ch);
           return;
        }
        else if (!str_cmp(arg1,"defensive"))
        {
            send_to_char("Defensive: The disciplines of defense.\n\r",ch);
            if (ch->power[DISC_VAMP_DEFENSIVE] < 1)
                send_to_char("You have none of the defensive discipline powers.\n\r",ch);
            return;
        }
        do_stat(ch,"");
        return;

    }
    if (!str_cmp(arg2,"improve"))
    {
        int improve;
        int cost;
        int max;
        int maxlevel;

        stc("Please use the new commands, Disciplines and research.\n\r",ch);
        return;

          maxlevel=10;
        if (!str_cmp(arg1,"confusion"  )) {improve = DISC_VAMP_CONFUSION;          max=maxlevel;}
        else if (!str_cmp(arg1,"domination"   )) {improve =DISC_VAMP_DOMI;        max=maxlevel;}
        else if (!str_cmp(arg1,"concealment")) {improve =DISC_VAMP_CONCEALMENT;  max=maxlevel;}
        else if (!str_cmp(arg1,"offensive"    )) {improve =DISC_VAMP_OFFENSIVE;         max=maxlevel;}
        else if (!str_cmp(arg1,"blood"      )) {improve =DISC_VAMP_BLOOD; max=maxlevel;}
        else if (!str_cmp(arg1,"defensive"  )) {improve =DISC_VAMP_DEFENSIVE;       max=maxlevel;}
        else
        {
            send_to_char("You can improve: Confusion, Domination, Concealment,\n\r",ch);
	    send_to_char("Offensive, Blood, or Defensive.\n\r",ch);
            return;
        }
        cost = (ch->power[improve]+1) * 10;
        arg1[0] = UPPER(arg1[0]);
        if ( ch->power[improve] >= max && ch->pcdata->rank ==AGE_METHUSELAH)
        {
            sprintf(buf,"You have already gained all the powers of the %s discipline.\n\r", arg1);
            send_to_char(buf,ch);
            return;
        }
        if (ch->power[improve] >= max)
        {
           sprintf(buf,"You have already maxed %s.\n\r",arg1);
           send_to_char(buf,ch);
           return;
        }
        if ( cost > ch->practice )
        {
            sprintf(buf,"It costs you %d primal to improve your %s discipline.\n\r", cost, arg1);
            send_to_char(buf,ch);
            return;
        }
        ch->power[improve] += 1;
        ch->practice -= cost;
        sprintf(buf,"You improve your ability in the %s discipline.\n\r", arg1);
        send_to_char(buf,ch);
    }
    else send_to_char("To improve a discipline, type: Clandisc <discipline type> improve.\n\r",ch);
    return;
}

void do_darkheart( CHAR_DATA *ch, char *argument )
{
    char      arg [MAX_INPUT_LENGTH];

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_VAMPIRE) )
    {
        send_to_char("Huh?\n\r",ch);
        return;
    }
    if (ch->power[DISC_VAMP_DEFENSIVE] < 1  )
    {
        send_to_char("You must obtain at least level 1 in Defensive to use Darkheart.\n\r",ch);
        return;
    }
    if (IS_IMMUNE(ch,IMM_STAKE) )
    {
        send_to_char("But you've already torn your heart out!\n\r",ch);
        return;
    }
    if ( ch->pcdata->condition[COND_THIRST] < 1000 / (10 - ch->generation) )
    {
        send_to_char("You have insufficient blood.\n\r",ch);
        return;
    }
    else if (ch->generation == 0 && ch->pcdata->condition[COND_THIRST] < 1000)
    {
      stc("You have insufficient blood.\n\r",ch);
      return;
    }
    ch->pcdata->condition[COND_THIRST] -= 100;
    send_to_char("You rip your heart from your body and toss it to the ground.\n\r",ch);
    act("$n rips $s heart out and tosses it to the ground.", ch, NULL, NULL, TO_ROOM);
    make_part( ch, "heart" );
    ch->hit = ch->hit - number_range(10,20);
    update_pos(ch);
    if (ch->position == POS_DEAD && !IS_HERO(ch))
    {
        send_to_char( "You have been KILLED!!\n\r\n\r", ch );
        raw_kill(ch);
        return;
    }
    SET_BIT(ch->immune, IMM_STAKE);
    return;
}

void do_mortal( CHAR_DATA *ch, char *argument )
{
    char      arg [MAX_INPUT_LENGTH];
    int       blood;

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;
    if (!IS_CLASS(ch, CLASS_VAMPIRE) && !IS_VAMPAFF(ch, VAM_MORTAL))
    {
        send_to_char("Huh?\n\r",ch);
        return;
    }
    if (ch->power[DISC_VAMP_CONFUSION] < 5)
    {
        send_to_char("You must obtain at least level 5 in Confusion to use Mortal Facade.\n\r",ch);
        return;
    }
    if (IS_CLASS(ch,CLASS_VAMPIRE) )
    {
        if ( ch->pcdata->condition[COND_THIRST] < 1000 / (10 - ch->generation) )
        {
            send_to_char("You must be at full blood to use this power.\n\r",ch);
            return;
        }
        /* Have to make sure they have enough blood to change back */
        blood = ch->pcdata->condition[COND_THIRST];
        ch->pcdata->condition[COND_THIRST] = 666;

        /* Remove physical vampire attributes when you take mortal form */
        if (IS_IMMUNE(ch,IMM_SHIELDED) ) do_shield(ch,"");
        if (IS_VAMPAFF(ch,VAM_FANGS) ) do_fangs(ch,"");
        if (IS_VAMPAFF(ch,VAM_CLAWS) ) do_claws(ch,"");
        if (IS_AFFECTED(ch,AFF_SHADOWSIGHT) ) do_shadowsight(ch,"");
        if (IS_VAMPAFF(ch,VAM_CHANGED) ) do_mutate(ch,"human");
        ch->rage = 0;
        ch->pcdata->condition[COND_THIRST] = blood;

        send_to_char("Colour returns to your skin and you warm up a little.\n\r",ch);
        act("Colour returns to $n's skin.", ch, NULL, NULL, TO_ROOM);

        REMOVE_BIT(ch->class, CLASS_VAMPIRE);
        SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_MORTAL);
        return;
    }
    send_to_char("You skin pales and cools.\n\r",ch);
    act("$n's skin pales slightly.", ch, NULL, NULL, TO_ROOM);
    SET_BIT(ch->class, CLASS_VAMPIRE);
    REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_MORTAL);
    return;
}

void do_mortalvamp( CHAR_DATA *ch, char *argument )
{
    char      arg [MAX_INPUT_LENGTH];
    int       blood;

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;
    if (IS_CLASS(ch,CLASS_VAMPIRE) )
    {
        /* Have to make sure they have enough blood to change back */
        blood = ch->pcdata->condition[COND_THIRST];
        ch->pcdata->condition[COND_THIRST] = 666;

        /* Remove physical vampire attributes when you take mortal form */
        if (IS_IMMUNE(ch,IMM_SHIELDED) ) do_shield(ch,"");
        if (IS_VAMPAFF(ch,VAM_FANGS) ) do_fangs(ch,""); 
        if (IS_VAMPAFF(ch,VAM_CLAWS) ) do_claws(ch,"");
        if (IS_AFFECTED(ch,AFF_SHADOWSIGHT) ) do_shadowsight(ch,"");
        if (IS_VAMPAFF(ch,VAM_CHANGED) ) do_mutate(ch,"human");
        ch->rage = 0;
        ch->pcdata->condition[COND_THIRST] = blood;

        send_to_char("You loose your vampire powers.\n\r",ch);

/*      REMOVE_BIT(ch->class, CLASS_VAMPIRE);
        SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_MORTAL);*/
        return;
    }
    send_to_char("You regain your vampire powers.\n\r",ch);
/*    SET_BIT(ch->class, CLASS_VAMPIRE);
    REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_MORTAL);*/
    return;
}

void do_bloodrod( CHAR_DATA *ch, char *argument )
{
    OBJ_DATA *obj;

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_VAMPIRE))
    {
        send_to_char("Huh?\n\r",ch);
        return;
    }

    if (ch->power[DISC_VAMP_BLOOD] < 7)
    {
        send_to_char("You need to obtain level 7 Blood to create a Blood Rod.\n\r",ch);
        return;
    }

    if ( 10 > ch->practice)
    {
        send_to_char("It costs 10 points of primal to create a Blood Rod.\n\r",ch);
        return;
    }
        ch->practice   -= 10;
        obj = create_object(get_obj_index(OBJ_VNUM_BROD)  ,0 );
        obj_to_char(obj, ch);
        act("A Rod of Blood appears in your hands.",ch,NULL,NULL,TO_CHAR);
        act("A Rod of blood appears in $n's hands.",ch,NULL,NULL,TO_ROOM);
        return;
}

void do_shroud( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) )
	return;

    if( !IS_CLASS(ch, CLASS_VAMPIRE) )
    {
	stc( "Huh?\n\r", ch);
	return;
    }

    if (ch->power[DISC_VAMP_CONCEALMENT] < 1)
     {
	  send_to_char("You need level 1 Concealment to use this power.\n\r",ch);
	  return;
     }

    if (ch->fight_timer > 0) {
      send_to_char("Not with a fighttimer.\n\r",ch);
      return;
    }

    if ( IS_SET(ch->act, AFF_HIDE) )
    {
	REMOVE_BIT(ch->act, AFF_HIDE);
	send_to_char( "You step out from the shadows.\n\r", ch );
	act("$n emerges from the shadows.",ch,NULL,NULL,TO_ROOM);
    }
    else
    {
	send_to_char( "You slowly blend with the shadows.\n\r", ch );
	act("$n blends in with the shadows and disappears.",ch,NULL,NULL,TO_ROOM);
	SET_BIT(ch->act, AFF_HIDE);
    }
    return;
}

void do_drain( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char arg [MAX_INPUT_LENGTH];
    int dam;

    argument = one_argument( argument, arg );

    if ( IS_NPC(ch) )
	return;

    if (!IS_CLASS(ch, CLASS_VAMPIRE))
     {
	  send_to_char("Huh?\n\r",ch);
	  return;
     }

    if (ch->power[DISC_VAMP_BLOOD] < 7 )
     {
	send_to_char("You must obtain level 7 Blood to use Drain Life.\n\r",ch);
	return;
     }
     
  
   if ( ( victim = get_char_room( ch, arg ) ) == NULL && (ch->fighting) == NULL)
    {
	send_to_char( "They aren't here.\n\r", ch );
	return;
    }
   if ((ch->fighting) != NULL)
   {
   victim = ch->fighting;
   }
    
   if ( arg[0] == '\0' && (ch->fighting) == NULL)
    {
	send_to_char( "Whose life do you wish to drain?\n\r", ch );
	return;
    }

    if (victim->hit < 500)
	{
	   send_to_char("They are far to hurt to do that!\n\r",ch);
	   return;
	}

	 if (is_safe(ch, victim))
	 {
       send_to_char("Not while in a safe room!\n\r", ch);
       return;
    }

    if (IS_NPC(victim))
	{
	  dam = ch->power[DISC_VAMP_BLOOD] * 10;
        victim->hit = (victim->hit - dam);
        if (dam > 500) dam = number_range( 450, 550 );
        ch->hit = (ch->hit + dam);
	if (ch->hit > ch->max_hit + 1000)
	ch->hit = ch->max_hit + 1000;
        act("You drain the lifeforce out of $N.", ch, NULL, victim, TO_CHAR);
        act("$n drains the lifeforce out of $N.", ch, NULL, victim, TO_NOTVICT);
        act("You feel $n draining your lifeforce.", ch, NULL, victim, TO_VICT);
        WAIT_STATE(ch,12);
	  return;
      }

    if (!IS_NPC(victim))
	{
	  dam = ch->power[DISC_VAMP_BLOOD] * 50;
        victim->hit = (victim->hit - dam);
        if (dam > 400) dam = number_range( 350, 450 );
        ch->hit = (ch->hit + dam);
        if (ch->hit > ch->max_hit + 1000)
        ch->hit = ch->max_hit + 1000;      
        act("You drain the lifeforce out of $N.", ch, NULL, victim, TO_CHAR);
        act("$n drains the lifeforce out of $N.", ch, NULL, victim, TO_NOTVICT);
        act("You feel $n draining your lifeforce.", ch, NULL, victim, TO_VICT);
        WAIT_STATE(ch,12);
	return;
      }
}

void do_belfry (CHAR_DATA *ch, char *argument)                               
{                                                                               
        CHAR_DATA *victim;                                                      
        char arg[MAX_STRING_LENGTH];                                            
        ROOM_INDEX_DATA *location;                                              
                                                                                
        one_argument (argument, arg);                                           
                                                                                
        if (IS_NPC(ch)) return;                                                 
        if (!IS_CLASS(ch, CLASS_VAMPIRE))                                         
        {                                                                       
                send_to_char("Huh?\n\r",ch);                                    
                return;                                                         
        }                                                                       
        if (ch->hit < 1 )                          
        {                                                                       
                send_to_char("Dead bats can't fly!\n\r",ch);
                return;                                                         
        }                                                                       
        if (ch->position == POS_SLEEPING)          
        {                                                                       
                send_to_char("Wake up, batboy... you cant fly while SLEEPING!!\n\r",ch);
                return;                                                         
        }                                                                       
        if (ch->position == POS_RESTING)           
        {                                                                       
                send_to_char("You really are batty, aren't you? STAND UP!!\n\r",ch);   
                return;                                                         
        } 
        if ((victim = get_char_world(ch, arg)) == NULL)                         
        {                                                                       
                send_to_char("Who are you gonna fly to?\n\r", ch );              
                return;                                                         
        }                                                                       
        if (ch->fight_timer > 0)                                                    
        {                                                                           
        stc( "No unscheduled flights with a FIGHT TIMER!!.\n\r",ch);                    
        return;                                                                   
        }
        if ( ch->pcdata->condition[COND_THIRST] < 66 )                              
        {                                                                           
        stc("You do not have enough blood.\n\r",ch);                              
        return;                                                                   
        }
	if ((time_info.hour > 9) || (time_info.hour < 17)) 
	{
	stc("You can't fly like a bat during the day!\n\r",ch);                   
        return;
	}
        location = victim->in_room;                                             
        act("You change into a bat and fly away!\n\r", ch, NULL, NULL,TO_CHAR); 
        act("$n changes into a bat and flies away!\n\r",ch,NULL,NULL,TO_ROOM);
        char_from_room(ch);                                                     
        char_to_room(ch, location);                                             
        do_look(ch, "auto");                                                    
        act("You fly to $N, land, and change back into a normal form.",ch,NULL, victim, TO_CHAR);
        act("A bat flies into the room, lands, and changes into $n!", ch,NULL,NULL, TO_ROOM);
        ch->pcdata->condition[COND_THIRST] -= 65;
        WAIT_STATE(ch, 2);                                                      
        return;                                                                 
}                                                                               

void do_bloodmight( CHAR_DATA *ch, char *argument )                                   
{                                                                               
        char      arg [MAX_INPUT_LENGTH];                                       
        argument = one_argument( argument, arg );                               
                                                                                
        if (IS_NPC(ch)) return;                                                 
                                                                                
        if ( !IS_CLASS(ch, CLASS_VAMPIRE))                                        
        {                                                                       
                stc("Huh?\n\r",ch);                                             
                return;                                                         
        }                                                                       
        if (ch->power[DISC_VAMP_BLOOD] < 2)
        {                                                                       
                send_to_char("You need blood 2 for bloodmight.\n\r",ch);      
                return;                                                         
        }                                                                       
   	if ( ch->pcdata->condition[COND_THIRST] < 100 )                               
   	{                                                                            
     	stc("You have insufficient blood.\n\r",ch);                                
     	return;                                                                    
   	}                                                                            
        if (IS_SET(ch->pcdata->stats[UNI_AFF],DEM_MIGHT) )                      
        {                                                                       
                send_to_char("Your blood pumps out of your muscles.\n\r",ch); 
                act("$n no longer looks buff.", ch, NULL, NULL, TO_ROOM);
                REMOVE_BIT(ch->pcdata->stats[UNI_AFF], DEM_MIGHT);              
		ch->pcdata->condition[COND_THIRST] += 100;
                return;                                                         
        }                                                                       
        if (!IS_SET(ch->pcdata->stats[UNI_AFF],DEM_MIGHT))                      
        {                                                                       
        send_to_char("Your blood pumps into your muscles.\n\r",ch);            
        act("$n looks very buff.", ch, NULL, NULL,TO_ROOM);
        SET_BIT(ch->pcdata->stats[UNI_AFF], DEM_MIGHT);
	ch->pcdata->condition[COND_THIRST] -= 100;
        return;                                                                 
}                                                                               
}                                                                               

