/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

#if defined(macintosh)
#include<types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "merc.h"


char *	const	where_name	[] =
{
    "#R[#CLight#R         ]#n ",
    "#R[#COn Finger     #R]#n ",
    "#R[#COn Finger     #R]#n ",
    "#R[#CAround Neck   #R]#n ",
    "#R[#CAround Neck   #R]#n ",
    "#R[#COn Body       #R]#n ",
    "#R[#COn Head       #R]#n ",
    "#R[#COn Legs       #R]#n ",
    "#R[#COn Feet       #R]#n ",
    "#R[#COn Hands      #R]#n ",
    "#R[#COn Arms       #R]#n ",
    "#R[#CShield        #R]#n ",
    "#R[#CAround Body   #R]#n ",
    "#R[#CAround Waist  #R]#n ",
    "#R[#CAround Wrist  #R]#n ",
    "#R[#CAround Wrist  #R]#n ",
    "#R[#CRight Hand    #R]#n ",
    "#R[#CLeft Hand     #R]#n ",
    "#R[#CThird Hand    #R]#n ",
    "#R[#CFourth Hand   #R]#n ",
    "#R[#COn Face       #R]#n ",
    "#R[#CMastery       #R]#n ",
    "#R[#CLeft Ear      #R]#n ",
    "#R[#CRight Ear     #R]#n ",
    "#R[#COver Eyes     #R]#n ",
    "#R[#CPath	       #R]#n ",
};

const char * exitname [6] =
{
	"North",
	"East",
	"South",
	"West",
	"Up",
	"Down"
};

const char * exitname2 [6] =
{
	"to the north",
	"to the east",
	"to the south",
	"to the west",
	"above you",
	"below you"
};


/*
 * Local functions.
 */
char *	format_obj_to_char	args( ( OBJ_DATA *obj, CHAR_DATA *ch,
				    bool fShort ) );
void	show_char_to_char_0	args( ( CHAR_DATA *victim, CHAR_DATA *ch ) );
void	show_char_to_char_1	args( ( CHAR_DATA *victim, CHAR_DATA *ch ) );
void	show_char_to_char	args( ( CHAR_DATA *list, CHAR_DATA *ch ) );
bool	check_blind		args( ( CHAR_DATA *ch ) );

void	evil_eye		args( ( CHAR_DATA *victim, CHAR_DATA *ch ) );
void 	check_left_arm		args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void 	check_right_arm		args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void 	check_left_leg		args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void 	check_right_leg		args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void 	look_sky 		args( ( CHAR_DATA *ch) );
void    look_window             args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
void	obj_score		args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );


char *format_obj_to_char( OBJ_DATA *obj, CHAR_DATA *ch, bool fShort )
{
    static char buf[MAX_STRING_LENGTH];

    buf[0] = '\0';
    if ( IS_SET(obj->quest, QUEST_ARTIFACT)) strcat(buf,"#y(#7Artifact#y)#n " ); 
    else if ( IS_SET(obj->quest, QUEST_RELIC)) strcat(buf,"#3(#7Relic#3)#n " );
    else if ( IS_SET(obj->quest, QUEST_MASTERY)) strcat(buf,"#g(#cM#oa#rs#7t#ge#yr#7y#g)#n ");
    else if ( IS_SET(obj->quest, QUEST_PATH)) strcat(buf,"#R(#LP#la#Lt#lh#R)#n ");
    else if ( obj->points < 750 && obj->points != 0) strcat(buf,"#3(Legendary)#n " );
    else if ( obj->points < 1250 && obj->points != 0 ) strcat(buf, "#7(#2Mythical#7)#n " );
    else if ( obj->points != 0) strcat(buf, "#6(#3Priceless#6)#n " );	
    if (IS_OBJ_STAT(obj, ITEM_GLOW)) strcat(buf,"#y(#rGlow#y)#n ");
    if (IS_OBJ_STAT(obj, ITEM_HUM))  strcat(buf,"#y(#rHum#y)#n ");
    if ( IS_OBJ_STAT(obj, ITEM_INVIS)     )   strcat( buf, "#6(Invis)#n " );
    if (IS_SET(obj->spectype, SITEM_ADAMANTITE)) strcat(buf,"#o(#7A#nd#7a#nm#7a#nn#7t#ni#7t#ne#o)#n "); 
    if (IS_SET(obj->spectype, SITEM_PLATINUM)) strcat(buf,"#o(#GP#7l#na#gti#nn#7u#Gm#o)#n ");
    if (IS_SET(obj->spectype, SITEM_URANIUM)) strcat(buf,"#g(#nU#7r#Ga#gn#Gi#7u#nm#g)#n"); 
    if (IS_SET(obj->spectype, SITEM_PLUTONIUM)) strcat(buf,"#g(#yP#7l#nu#oton#ni#7u#om#g)#n "); 
    if ( IS_OBJ_STAT(obj, ITEM_SHADOWPLANE) &&
	 obj->in_room != NULL &&
	!IS_AFFECTED(ch,AFF_SHADOWPLANE) )  strcat( buf, "#o(#gShadowplane#o)#n " ); 
    if (!IS_OBJ_STAT(obj, ITEM_SHADOWPLANE) &&
	 obj->in_room != NULL &&
	 IS_AFFECTED(ch,AFF_SHADOWPLANE) )    strcat( buf, "#7(Normal plane)#n " );

    if ( fShort )
    {
	if ( obj->short_descr != NULL )
	    strcat( buf, obj->short_descr );
	if ( obj->condition < 100) strcat(buf, " #1(Damaged)#n");
    }
    else
    {
	if ( obj->description != NULL )
	    strcat( buf, obj->description );
    }

    return buf;
}

int char_damroll(CHAR_DATA *ch)
{
  int value = 0;

  value += ch->damroll;

  if (!IS_NPC(ch)) 
  {
    value += str_app[get_curr_str(ch)].todam;
    value += ch->xdamroll;
  }
  if( ch-> level < LEVEL_ADVOCATE ) return value;
  if (IS_CLASS(ch, CLASS_VAMPIRE) && ch->rage > 0) 
    value += ch->rage;
  if( IS_CLASS(ch, CLASS_MONK) && IS_ITEMAFF(ch, ITEMA_CHAOSHANDS ) )
  	value += 200;
	if (IS_CLASS(ch, CLASS_NINJA) && ch->rage > 0)
  	value += ch->rage;
  if (IS_SET(ch->special,SPC_WOLFMAN) && ch->rage > 99)
    value += ch->rage;
  if (IS_CLASS(ch, CLASS_DEMON) && ch->rage > 0)
    value += ch->rage;

        if (IS_CLASS( ch,CLASS_DEMON) && ch->pcdata->stats[DEMON_POWER] > 0)
	value += (( ch->pcdata->stats[DEMON_POWER]) * ch->pcdata->stats[DEMON_POWER]);
	else if (IS_SET(ch->special,SPC_CHAMPION) && ch->pcdata->stats[DEMON_POWER] > 0)
	value += (( ch->pcdata->stats[DEMON_POWER]) * ch->pcdata->stats[DEMON_POWER]);
	else if (IS_CLASS(ch, CLASS_DROW) && ch->pcdata->stats[DEMON_POWER] > 0)
	value += (( ch->pcdata->stats[DEMON_POWER]) * ch->pcdata->stats[DEMON_POWER]);

	if (!IS_NPC(ch))
	if (IS_CLASS(ch, CLASS_NINJA) && ch->pcdata->powers[NPOWER_CHIKYU] >= 6
	&& ch->pcdata->powers[HARA_KIRI] > 0)
	value += 50;

    if (IS_CLASS(ch, CLASS_HIGHLANDER) && (get_eq_char(ch, WEAR_WIELD) != NULL))
    {
	int wpn = ch->wpn[1]; 
	int total = ch->wpn[0] + ch->wpn[2] + ch->wpn[3] + ch->wpn[4] + ch->wpn[5] +
		    ch->wpn[6] + ch->wpn[7] + ch->wpn[8] + ch->wpn[9] + ch->wpn[10] +
		    ch->wpn[11] + ch->wpn[12] + ch->wpn[13];
	
	  if (wpn >= 500)
		value += 500;
	  else
		value += wpn/2; 
	total = total / 13;
	value += total;
    }
    return value;
}

int char_hitroll(CHAR_DATA *ch)
{
    int value = 0;

    value += ch->hitroll;

    if (!IS_NPC(ch))
        value += str_app[get_curr_str(ch)].tohit;

    if( ch-> level < LEVEL_ADVOCATE ) return value;

    /* Vampire Rage */
    if (IS_CLASS(ch, CLASS_VAMPIRE) && ch->rage > 0)
	  value += ch->rage;

    if( IS_CLASS(ch, CLASS_MONK) && IS_ITEMAFF(ch, ITEMA_CHAOSHANDS ) )
	value += 200;


	if (IS_CLASS(ch, CLASS_NINJA) && ch->rage > 0)
	value += ch->rage;

	if (!IS_NPC(ch))
	if (IS_CLASS(ch, CLASS_NINJA) && ch->pcdata->powers[NPOWER_CHIKYU] >= 6
	&& ch->pcdata->powers[HARA_KIRI] > 0)
	value += 100;

    /* Werewolf Rage */
    if (IS_SET(ch->special,SPC_WOLFMAN) && ch->rage > 99)
	  value += ch->rage;

    if (IS_CLASS(ch, CLASS_DEMON) && ch->rage > 0)
	  value += ch->rage;
    if (IS_CLASS( ch,CLASS_DEMON) && ch->pcdata->stats[DEMON_POWER] > 0)
       value += (( ch->pcdata->stats[DEMON_POWER]) * ch->pcdata->stats[DEMON_POWER]);
        else if (IS_SET(ch->special,SPC_CHAMPION) && ch->pcdata->stats[DEMON_POWER] > 0)
        value += (( ch->pcdata->stats[DEMON_POWER]) * ch->pcdata->stats[DEMON_POWER]);
        else if (IS_CLASS(ch, CLASS_DROW) && ch->pcdata->stats[DEMON_POWER] > 0)
        value += (( ch->pcdata->stats[DEMON_POWER]) * ch->pcdata->stats[DEMON_POWER]);

    /* Highlander */
    if (IS_CLASS(ch, CLASS_HIGHLANDER) && (get_eq_char(ch, WEAR_WIELD) != NULL))
    {
	int wpn = ch->wpn[1];
	int total = ch->wpn[0] + ch->wpn[2] + ch->wpn[3] + ch->wpn[4] + ch->wpn[5] +
		    ch->wpn[6] + ch->wpn[7] + ch->wpn[8] + ch->wpn[9] + ch->wpn[10] +
		    ch->wpn[11] + ch->wpn[12] + ch->wpn[13];
	
   if (wpn >= 500)
		value += 500;
	  else
		value += wpn/2;
	total = total / 13;
	value += total;
    }
    if( value > 7000 ) value = 7000;
    return value;
}

int char_ac(CHAR_DATA *ch)
{
    int value = 0;

    value = GET_AC(ch);

    if (IS_AWAKE(ch))
   	value += dex_app[get_curr_dex(ch)].defensive;

    /* Highlander */
    if (IS_CLASS(ch, CLASS_HIGHLANDER) && (get_eq_char(ch, WEAR_WIELD) != NULL))
    {
	int wpn = ch->wpn[1];
	value -= wpn;
    }

    if( value > 7000 ) value = 7000;
    return value;
}



/*
 * Show a list to a character.
 * Can coalesce duplicated items.
 */
void show_list_to_char( OBJ_DATA *list, CHAR_DATA *ch, bool fShort, bool fShowNothing )
{
    char buf[MAX_STRING_LENGTH];
    char **prgpstrShow;
    int *prgnShow;
    char *pstrShow;
    OBJ_DATA *obj;
    int nShow;
    int iShow;
    int count;
    bool fCombine;

    if ( ch->desc == NULL )
	return;

    /*
     * Alloc space for output lines.
     */
    count = 0;
    for ( obj = list; obj != NULL; obj = obj->next_content )
	count++;
    prgpstrShow	= alloc_mem( count * sizeof(char *) );
    prgnShow    = alloc_mem( count * sizeof(int)    );
    nShow	= 0;

    /*
     * Format the list of objects.
     */
    for ( obj = list; obj != NULL; obj = obj->next_content )
    { 
	if (!IS_NPC(ch) && ch->pcdata->chobj != NULL && obj->chobj != NULL && obj->chobj == ch)
	    continue;
	if ( obj->wear_loc == WEAR_NONE && can_see_obj( ch, obj ) )
	{
	    pstrShow = format_obj_to_char( obj, ch, fShort );
	    fCombine = FALSE;

	    if ( IS_NPC(ch) || IS_SET(ch->act, PLR_COMBINE) )
	    {
		/*
		 * Look for duplicates, case sensitive.
		 * Matches tend to be near end so run loop backwords.
		 */
		for ( iShow = nShow - 1; iShow >= 0; iShow-- )
		{
		    if ( !strcmp( prgpstrShow[iShow], pstrShow ) )
		    {
			prgnShow[iShow]++;
			fCombine = TRUE;
			break;
		    }
		}
	    }

	    /*
	     * Couldn't combine, or didn't want to.
	     */
	    if ( !fCombine )
	    {
		prgpstrShow [nShow] = str_dup( pstrShow );
		prgnShow    [nShow] = 1;
		nShow++;
	    }
	}
    }

    /*
     * Output the formatted list.
     */
    for ( iShow = 0; iShow < nShow; iShow++ )
    {
	if ( IS_NPC(ch) || IS_SET(ch->act, PLR_COMBINE) )
	{
	    if ( prgnShow[iShow] != 1 )
	    {
		sprintf( buf, "(%2d) ", prgnShow[iShow] );
		send_to_char( buf, ch );
	    }
	    else
	    {
		send_to_char( "     ", ch );
	    }
	}
	send_to_char( prgpstrShow[iShow], ch );
	send_to_char( "\n\r", ch );
	free_string( prgpstrShow[iShow] );
    }

    if ( fShowNothing && nShow == 0 )
    {
	if ( IS_NPC(ch) || IS_SET(ch->act, PLR_COMBINE) )
	    send_to_char( "     ", ch );
	send_to_char( "Nothing.\n\r", ch );
    }

    /*
     * Clean up.
     */
    free_mem( prgpstrShow, count * sizeof(char *) );
    free_mem( prgnShow,    count * sizeof(int)    );

    return;
}



void show_char_to_char_0( CHAR_DATA *victim, CHAR_DATA *ch )
{
    char buf[MAX_STRING_LENGTH];
    char buf2[MAX_STRING_LENGTH];
    char buf3[MAX_STRING_LENGTH];
    char buf4[MAX_STRING_LENGTH];
    char buf5[MAX_STRING_LENGTH];
    char buf6[MAX_STRING_LENGTH]; 
    char buf7[MAX_STRING_LENGTH];
    char buf30[MAX_STRING_LENGTH];   
    char mount2[MAX_STRING_LENGTH];
    CHAR_DATA *mount;

    buf[0] = '\0';
    buf2[0] = '\0';
    buf3[0] = '\0';
    buf4[0] = '\0';
    buf5[0] = '\0';
    buf6[0] = '\0';
    buf7[0] = '\0';
    buf30[0] = '\0'; 

    if (!IS_NPC(victim) && victim->pcdata->chobj != NULL )
	return;

    if ((mount = victim->mount) != NULL && IS_SET(victim->mounted, IS_MOUNT))
	return;

    if ( !IS_NPC(victim) && IS_SET(victim->flag2, VAMP_OBJMASK) )
    {
	sprintf(buf, "     %s\n\r",victim->objdesc);
	stc(buf,ch);
	return;
    }


     if (victim->cur_form != 0)
    {
    buf[0] = '\0';
   
    if ( IS_HEAD(victim, LOST_HEAD) && IS_AFFECTED(victim, AFF_POLYMORPH))
	strcat( buf, "     " );
 else { 
	if (!IS_NPC(victim) && victim->desc==NULL ) strcat( buf,"#r(Link-Dead)#n ");
    	if ( IS_AFFECTED(victim, AFF_INVISIBLE)  ) strcat( buf, "#o(#gI#Gn#nv#pi#7s#ci#nb#Gl#ge#o)#n "  ); 
    	if ( IS_AFFECTED(victim, AFF_HIDE)        ) strcat( buf, "#y(Hide)#n " );
    	if ( IS_AFFECTED(victim, AFF_CHARM)       ) strcat( buf, "#R(Charmed)#n " );
    	if (IS_AFFECTED(victim,AFF_PASS_DOOR)) strcat(buf,"#C(#GVapor#C)#n ");
	if (!IS_NPC(victim) && IS_CLASS(victim, CLASS_VAMPIRE) &&
	   (IS_AFFECTED(victim, AFF_ETHEREAL))) strcat(buf,"#7(#yMist#7)#n");
	if (!IS_NPC(victim) && !IS_CLASS(victim, CLASS_VAMPIRE) &&
	   (IS_AFFECTED(victim, AFF_ETHEREAL)))
		strcat(buf,"#o(#7Gh#nos#7t#o)#n ");
    	if ( IS_AFFECTED(victim, AFF_FAERIE_FIRE) ) strcat( buf,"#p(#PPink Aura#p)#n "  ); 
	if ( IS_AFFECTED(victim, AFF_RADIOACTIVE) ) strcat(buf,"#g(#RR#oa#rd#yi#Ro#oa#rc#yt#Ri#ov#re#g)#n "  );
    	if ( IS_AFFECTED(victim, AFF_SANCTUARY)   ) strcat( buf, "#7(#cS#Ca#on#7c#nt#7u#oa#Cr#cy#7)#n " );
	if ( IS_AFFECTED(victim, AFF_SWIM)) strcat(buf, "#G(Gilled)#n ");
	if ( IS_AFFECTED(victim, AFF3_VINED)) strcat(buf,"#y(#GVined#y)#n");
	}
    if ( IS_AFFECTED(ch, AFF_SHADOWPLANE) 
     && !IS_AFFECTED(victim, AFF_SHADOWPLANE))    strcat( buf, "#7(#nNormal Plane#7)#n ");
    else if ( !IS_AFFECTED(ch, AFF_SHADOWPLANE) 
        && IS_AFFECTED(victim, AFF_SHADOWPLANE))  strcat( buf, "#o(#LShadowplane#o)#n "  ); 

    
    if (ch->class > 0)
    {
       if (IS_CLASS(victim, CLASS_MECHA)) 
                strcat(buf, "#r(#yMechaWarrior#r)#n ");
       if (IS_CLASS(victim, CLASS_VAMPIRE)) 
                strcat(buf, "#c(#RVampire#c)#n ");
       if (IS_CLASS(victim, CLASS_WEREWOLF))
		strcat(buf, "#y(#LWerewolf#y)#n ");
       if (IS_CLASS(victim, CLASS_MONK))
	        strcat(buf, "#o(#lMonk#o)#n ");
       if (IS_CLASS(victim, CLASS_DEMON))
	        strcat(buf, "#R(#oDemon#R)#n ");
       if (IS_CLASS(victim, CLASS_CYBORG))
	        strcat(buf, "#0(#7Cyborg#0)#n ");
       if (IS_CLASS(victim, CLASS_DROW))
	        strcat(buf, "#P(#lDrow#P)#n ");
       if (IS_CLASS(victim, CLASS_MAGE)) 
                strcat(buf, "#R(Warlock)#n ");
       if (IS_CLASS(victim, CLASS_ELEMENT))
		strcat(buf, "#l(#gElemental#l)#n ");
       if (IS_CLASS(victim, CLASS_JEDI))
		strcat(buf, "#g(#CJedi#g)#n ");
       if (IS_CLASS(victim, CLASS_XOMBI))
		strcat(buf, "#l(#7Xombi#l)#n ");  
       if (IS_CLASS(victim, CLASS_DRAGON))
                strcat(buf, "#G(#RD#rragon#G)#n ");
    }

    if (victim->cur_form != 0)
    {
	if (victim->position == POS_STANDING)
	{
	    char buf2[MAX_STRING_LENGTH];
	    form_in_room_desc(victim, buf2);
	    strcat(buf, buf2);
	}
	else
	{
	    if (is_vowel(form_data[victim->cur_form].lookname[0]))
	        strcat(buf, "An ");
	    else strcat(buf, "A ");
	    strcat(buf, form_data[victim->cur_form].lookname);
	}
    }
    
    if( !IS_SET(victim->affected_by, AFF_SEVERED) )
    {
    switch ( victim->position )
    {
    case POS_DEAD:     strcat( buf, " is lying dead on the floor." ); break;
    case POS_MORTAL:   strcat( buf, " is lying here, #Rmortally wounded#n." ); break;
    case POS_INCAP:    strcat( buf, " is lying here #rincapacitated#n." ); break;
    case POS_STUNNED:  strcat( buf, " is lying here #ostunned#n." ); break; 
    case POS_SLEEPING: strcat(buf," is sleeping here."); break;
    case POS_RESTING:  strcat( buf, " is resting here." ); break;
    case POS_SITTING:  strcat(buf, " is sitting here."); break;
    case POS_FIGHTING:
	strcat( buf, " is here, fighting " );
	if ( victim->fighting == NULL )
	    strcat( buf, "thin air??" ); 
	else if ( victim->fighting == ch )
	    strcat( buf, "YOU!" );
	else if ( victim->in_room == victim->fighting->in_room )
	{
	    strcat( buf, PERS( victim->fighting, ch ) );
	    strcat( buf, "." );
	}
	else
	    strcat( buf, "someone who left??" );
	break;
    }
    }
    else
    {
        strcat( buf, "'s upper torso is here, twitching."); 
    } 
    strcat( buf, "\n\r" );
    buf[0] = UPPER(buf[0]);
    send_to_char( buf, ch );
    return;
    }	


    if ( IS_HEAD(victim, LOST_HEAD) && IS_AFFECTED(victim, AFF_POLYMORPH))
	strcat( buf, "     " );
    else { 
	if (!IS_NPC(victim) && victim->desc==NULL ) strcat( buf,"#y(Link-Dead)#n ");
    	if ( IS_AFFECTED(victim, AFF_INVISIBLE)   ) strcat( buf, "#L(Invis)#n "   );
    	if ( IS_AFFECTED(victim, AFF_HIDE)  ) strcat( buf, "#c(#lHide#c)#n "  ); 
    	if ( IS_AFFECTED(victim, AFF_CHARM)       ) strcat( buf, "#R(Charmed)#n " );
	if (IS_AFFECTED(victim,AFF_PASS_DOOR)) strcat(buf,"#C(#GVapor#C)#n ");  
        if (!IS_NPC(victim) && IS_CLASS(victim, CLASS_VAMPIRE) &&               
           (IS_AFFECTED(victim,AFF_ETHEREAL))) strcat(buf,"#7(#yMist#7)#n");   
        if (!IS_NPC(victim) && !IS_CLASS(victim, CLASS_VAMPIRE) &&              
           (IS_AFFECTED(victim, AFF_ETHEREAL)))                                 
                strcat(buf,"#o(#7Gh#nos#7t#o)#n ");                             
    	if ( IS_AFFECTED(victim, AFF_FAERIE_FIRE) ) strcat( buf, "#P(Pink Aura)#n "  );
	if ( IS_AFFECTED(victim, AFF_RADIOACTIVE) ) strcat(buf,"#g(#RR#oa#rd#yi#Ro#oa#rc#yt#Ri#ov#re#g)#n "  ); 
    	if ( IS_AFFECTED(victim, AFF_SANCTUARY)   ) strcat( buf, "#7(#cS#Ca#cn#Cc#ct#Cu#ca#Cr#cy#7)#n " );
	if (IS_AFFECTED(victim, AFF_SWIM)) strcat(buf,"#G(Gilled)#n ");
	if (IS_AFFECTED(victim, AFF3_VINED)) strcat(buf,"#y(#GVined#y)#n ");
    }
    if ( IS_AFFECTED(ch, AFF_SHADOWPLANE) && !IS_AFFECTED(victim, AFF_SHADOWPLANE))
	strcat( buf, "#l(#CNormal plane#l)#n "     );
    else if ( !IS_AFFECTED(ch, AFF_SHADOWPLANE) && IS_AFFECTED(victim, AFF_SHADOWPLANE))
	strcat( buf, "#C(#7Shadowplane#C)#n "     );
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim,CLASS_WEREWOLF) && IS_HERO(victim) && IS_HERO(ch))
	strcat( buf, "#y(#LWerewolf#y)#n " );
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_MECHA) && IS_HERO(victim) && IS_HERO(ch))
        strcat( buf, "#r(#yMechaWarrior#r)#n ");
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_DEMON) && IS_HERO(victim) && IS_HERO(ch)) 
        strcat( buf, "#R(#rDemon#R)#n " ); 
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_NINJA) && IS_HERO(victim) && IS_HERO(ch))     
        strcat( buf, "#R(#yNinja#R)#n " );
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_MONK) && IS_HERO(victim) && IS_HERO(ch))     
        strcat( buf, "#C(#nMonk#C)#n " );
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_CYBORG) && IS_HERO(victim) && IS_HERO(ch))
        strcat( buf, "#o(#7Cyborg#o)#n " );
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_ANGEL) && IS_HERO(victim) && IS_HERO(ch))
        strcat( buf, "#c(#7Angel#c)#n " ); 
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_TANARRI) && IS_HERO(victim) && IS_HERO(ch))
        strcat( buf, "#o(#RTanar'ri#o)#n " );
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_UNDEAD_KNIGHT) && IS_HERO(victim) && IS_HERO(ch))
        strcat( buf, "#y(#0Undead Knight#y)#n " );
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_HIGHLANDER) && IS_HERO(victim) && IS_HERO(ch))
 	strcat( buf,"#C(#ySamu#Rrai#C)#n " );
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_MAGE) && IS_HERO(victim) && IS_HERO(ch)) 
	strcat( buf,"{{#CBattlemage#n}} " );
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_DROW) && IS_HERO(victim) && IS_HERO(ch)) 
	strcat(buf, "#P(#gDrow#P)#n "); 
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_ELEMENT) && IS_HERO(victim) && IS_HERO(ch))
	strcat(buf, "#l(#gElemental#l)#n ");
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_JEDI) && IS_HERO(victim) && IS_HERO(ch))
	strcat(buf, "#o(#LJedi#o)#n ");
    if ( !IS_NPC(victim) && !IS_NPC(ch) && IS_CLASS(victim, CLASS_SHAPESHIFTER) && IS_HERO(victim) && IS_HERO(ch))
	strcat(buf, "#P(#RShapeshifter#P)#n ");
    if ( !IS_NPC(ch) && IS_VAMPAFF(ch,VAM_CONFUSION) && !IS_NPC(victim) && IS_CLASS(victim, CLASS_VAMPIRE) && IS_VAMPAFF(victim, VAM_DISGUISED) )
    {
	strcat( buf, "(");
	strcat( buf, victim->name);
	strcat( buf, ") ");
    }
if (victim->embracing!= NULL)
{
sprintf(buf7,"\n\r...%s is holding %s in a stern embrace!",victim->name,victim->embracing->name);
}
else if (victim->embraced!=NULL)
{
sprintf(buf7,"\n\r...%s is being embraced by %s!",victim->name,victim->embraced->name);
}
    if ( IS_EXTRA(victim, EXTRA_ROT))
     {
        if (IS_NPC(victim)) 
          sprintf(buf6,"\n\r#0...#R%s#0 is coated with a layer of #or#go#ot#gt#oe#gn#0 skin!#n",victim->short_descr); 
        else if (!IS_NPC(victim) && IS_AFFECTED(victim,AFF_POLYMORPH))
           sprintf(buf6,"\n\r#0...#R%s#0 is coated with a layer of#o r#go#ot#gt#oe#gn#0 skin!#n",victim->morph);
        else 
           sprintf(buf6,"\n\r#0...#R%s#0 is coated with a layer of#o r#go#ot#gt#oe#gn#0 skin!#n",victim->name);
       }


    if ( IS_AFFECTED(victim, AFF_FLAMING) ) 
    {
	if (IS_NPC(victim))
	    sprintf( buf2, "\n\r...#R%s#n is engulfed in blazing#R f#yl#Ra#ym#Re#ys#o!#n", victim->short_descr ); 
	else if (!IS_NPC(victim) && IS_AFFECTED(victim,AFF_POLYMORPH))
	    sprintf( buf2, "\n\r...#R%s#n is engulfed in blazing#R f#yl#Ra#ym#Re#ys#o!#n", victim->morph );
	else
	    sprintf( buf2, "\n\r...#R%s#n is engulfed in blazing#R f#yl#Ra#ym#Re#ys#o!#n", victim->name );
    }

    if ( !IS_NPC(victim) && IS_HEAD(victim, LOST_HEAD) && IS_AFFECTED(victim, AFF_POLYMORPH)) 
    {
	if (IS_EXTRA(victim,GAGGED) && IS_EXTRA(victim,BLINDFOLDED))
	    sprintf( buf3, "...%s is gagged and blindfolded, kinky!", victim->morph );
	else if (IS_EXTRA(victim,GAGGED))
	    sprintf( buf3, "...%s is gagged!", victim->morph );
	else if (IS_EXTRA(victim,BLINDFOLDED))
	    sprintf( buf3, "...%s is blindfolded!", victim->morph );
    }
    if ( IS_HEAD(victim, LOST_HEAD) && IS_AFFECTED(victim, AFF_POLYMORPH))
    {
	strcat( buf, victim->morph );
	strcat( buf, " is lying here." );
    	strcat( buf, buf2 );
    	strcat( buf, buf3 );
    	strcat( buf, buf6 );
        strcat(buf,buf7);   
     strcat( buf, "\n\r" );
    	buf[5] = UPPER(buf[5]);
    	send_to_char( buf, ch );
	return;
    }
    
    if ( IS_EXTRA(victim, TIED_UP) || IS_SET(victim->elkor,ELK_BOLA) ) 
    {
	if (IS_NPC(victim))
	    sprintf( buf3, "\n\r...%s is tied up", victim->short_descr );
	else if (!IS_NPC(victim) && IS_AFFECTED(victim,AFF_POLYMORPH))
	{
	    sprintf( buf3, "\n\r...%s is tied up", victim->morph );
	if (!IS_NPC(victim) && IS_SET(victim->elkor,ELK_BOLA))
	sprintf(buf3,"\n\r...%s is tied up with ninja bolas",victim->morph);
	}
	else
	    sprintf( buf3, "\n\r...%s is tied up", victim->name );
	if (!IS_NPC(victim) && IS_SET(victim->elkor,ELK_BOLA))
	sprintf(buf3,"\n\r...%s is tied up with ninja bolas",victim->name);
	if (IS_EXTRA(victim,GAGGED) && IS_EXTRA(victim,BLINDFOLDED))
	    strcat( buf3, ", gagged and blindfolded!" );
	else if (IS_EXTRA(victim,GAGGED))
	    strcat( buf3, " and gagged!" );
	else if (IS_EXTRA(victim,BLINDFOLDED))
	    strcat( buf3, " and blindfolded!" );
	else
	    strcat( buf3, "!" );
    }

    if ( IS_AFFECTED(victim, AFF_WEBBED) ) 
    {
	if (IS_NPC(victim))
	    sprintf( buf4, "\n\r...%s is coated in a sticky web.", victim->short_descr );
	else if (!IS_NPC(victim) && IS_AFFECTED(victim,AFF_POLYMORPH))
	    sprintf( buf4, "\n\r...%s is coated in a sticky web.", victim->morph );
	else
	    sprintf( buf4, "\n\r...%s is coated in a sticky web.", victim->name );
	strcat( buf3, buf4 );
    }
    if ( !IS_NPC(victim) && IS_AFFECTED(victim, AFF_POLYMORPH) ) 
	strcat( buf, victim->morph );
    else if ( victim->position == POS_STANDING && victim->long_descr[0] != '\0' && (mount = victim->mount) == NULL )
    {
	strcat( buf, victim->long_descr );
	send_to_char( buf, ch );
	if ( IS_NPC(ch) || !IS_SET(ch->act, PLR_BRIEF) )
	{
	    if ( IS_ITEMAFF(victim, ITEMA_SHOCKSHIELD) ) 
		act( "#ylightning#n.", ch,NULL,victim,TO_CHAR );
	    if ( IS_ITEMAFF(victim, ITEMA_FIRESHIELD) ) 
		act( "#Rf#yi#Rr#ye#n.", ch,NULL,victim,TO_CHAR );
	    if ( IS_ITEMAFF(victim, ITEMA_ICESHIELD) ) 
		act( "#Cice#n.", ch,NULL,victim,TO_CHAR );
	    if ( IS_ITEMAFF(victim, ITEMA_ACIDSHIELD) ) 
		act( "#La#Rc#Li#Rd#n.", ch,NULL,victim,TO_CHAR );
	    if ( IS_ITEMAFF(victim, ITEMA_CHAOSSHIELD) ) 
		act( "#oc#Rh#oa#Ro#os#n.", ch,NULL,victim,TO_CHAR );
	    if ( IS_ITEMAFF(victim, ITEMA_REFLECT) ) 
		act( "#Ldarkness#n.", ch,NULL,victim,TO_CHAR );
	}
	return;
    }
    else
    	strcat( buf, PERS( victim, ch ) );

    if ((mount = victim->mount) != NULL && victim->mounted == IS_RIDING)
    {
	if (IS_NPC(mount))
	    sprintf( mount2, " is here riding %s", mount->short_descr );
	else
	    sprintf( mount2, " is here riding %s", mount->name );
	strcat( buf, mount2 );
	if (victim->position == POS_FIGHTING)
	{
	    strcat( buf, ", fighting " );
	    if ( victim->fighting == NULL )
	        strcat( buf, "thin air??" ); 
	    else if ( victim->fighting == ch )
	    strcat( buf, "YOU!" );
	    else if ( victim->in_room == victim->fighting->in_room )
	    {
	        strcat( buf, PERS( victim->fighting, ch ) );
	        strcat( buf, "." );
	    }
	    else
	        strcat( buf, "somone who left??" );
	}
	else strcat( buf, "." );
    }
    else if ( victim->position == POS_STANDING && IS_AFFECTED(victim, AFF_FLYING) )
	strcat( buf, " is hovering here" );
    else if ( victim->position == POS_STANDING && (!IS_NPC(victim) && (IS_VAMPAFF(victim, VAM_FLYING))) )
	strcat( buf, " is hovering here" );
    else if (victim->position == POS_STANDING && (!IS_NPC(victim) && IS_CLASS(victim, CLASS_DROW) && IS_SET(victim->pcdata->powers[1], DPOWER_LEVITATION)))
	strcat(buf, " is hovering here" );
    else
    {
    	switch ( victim->position )
    	{
    	case POS_DEAD:     strcat( buf, " is DEAD!!" );              break;
        case POS_MORTAL:   strcat( buf, " is #Rmortally wounded#n." );   break; 
    	case POS_INCAP:    strcat( buf, " is #rincapacitated#n." );      break;
    	case POS_STUNNED:  strcat( buf, " is lying here #Cstunned#n." ); break;
    	case POS_SLEEPING: strcat( buf, " is sleeping here." );      break;
    	case POS_RESTING:  strcat( buf, " is resting here." );       break;
    	case POS_MEDITATING: strcat( buf, " is meditating here." );  break;
    	case POS_SITTING:  strcat( buf, " is sitting here." );       break;
    	case POS_STANDING:
	    if      (!IS_NPC(victim) && victim->stance[0] == STANCE_NORMAL)
		strcat( buf, " is here, crouched in a fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_VIPER)
		strcat( buf, " is here, crouched in a viper fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_CRANE)
		strcat( buf, " is here, crouched in a crane fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_CRAB)
		strcat( buf, " is here, crouched in a crab fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_MONGOOSE)
		strcat( buf, " is here, crouched in a mongoose fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_BULL)
		strcat( buf, " is here, crouched in a bull fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_MANTIS)
		strcat( buf, " is here, crouched in a mantis fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_DRAGON)
		strcat( buf, " is here, crouched in a dragon fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_TIGER)
		strcat( buf, " is here, crouched in a tiger fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_MONKEY)
		strcat( buf, " is here, crouched in a monkey fighting stance." );
	    else if (!IS_NPC(victim) && victim->stance[0] == STANCE_SWALLOW)
		strcat( buf, " is here, crouched in a swallow fighting stance." );
	    else
		strcat( buf, " is here." );
	    break;
    	case POS_FIGHTING:
	    strcat( buf, " is here, fighting " );
	    if ( victim->fighting == NULL )
	        strcat( buf, "thin air??" ); 
	    else if ( victim->fighting == ch )
	    strcat( buf, "YOU!" );
	    else if ( victim->in_room == victim->fighting->in_room )
	    {
	        strcat( buf, PERS( victim->fighting, ch ) );
	        strcat( buf, "." );
	    }
	    else
	        strcat( buf, "somone who left??" );
	    break;
	}
    }

    strcat( buf, buf2 );
    strcat( buf, buf3 );
    strcat( buf, "\n\r" );
    buf[0] = UPPER(buf[0]);
    send_to_char( buf, ch );

    if ( !IS_NPC(ch) && IS_SET(ch->act, PLR_BRIEF) ) return;

    if ( IS_ITEMAFF(victim, ITEMA_SHOCKSHIELD) ) 
	act("#yS#oh#yo#oc#yk#os#yh#oi#ye#ol#yd#n",ch,NULL,victim,TO_CHAR);
    if ( IS_ITEMAFF(victim, ITEMA_FIRESHIELD) ) 
	act( "#RF#ri#Rr#re#Rs#rh#Ri#re#Rl#rd#n", ch,NULL,victim,TO_CHAR );
    if ( IS_ITEMAFF(victim, ITEMA_ICESHIELD) ) 
	act( "#CI#cc#Ce#cs#Ch#ci#Ce#cl#Cd#n", ch,NULL,victim,TO_CHAR );
    if ( IS_ITEMAFF(victim, ITEMA_ACIDSHIELD) ) 
	act( "#GA#gc#Gi#gd#Gs#gh#Gi#ge#Gl#gd#n", ch,NULL,victim,TO_CHAR );
    if ( IS_ITEMAFF(victim, ITEMA_CHAOSSHIELD) ) 
	act( "#RC#Gh#ya#Co#Ls#rs#gh#li#ce#pl#od#n", ch,NULL,victim,TO_CHAR);
    if ( IS_ITEMAFF(victim, ITEMA_REFLECT) ) 
	act( "#LD#la#Lr#lk#Ls#lh#Li#le#Ll#ld#n", ch,NULL,victim,TO_CHAR );
    if (IS_NPC(victim) &&ch->questmob > 0 && victim->pIndexData->vnum == ch->questmob)
        strcat( buf, "[TARGET] ");
    return;

}



void evil_eye( CHAR_DATA *victim, CHAR_DATA *ch )
{
    char buf [MAX_STRING_LENGTH];
    int tabletype;

    if (IS_NPC(victim)) return;
    if (victim == ch) return;
    if (ch->level < 3 || victim->level < 3) return;
    if (victim->power[DISC_DAEM_DISC] < 2) return;
    if (victim->power[DISC_DAEM_DISC] < dice(1, 10)) return;
    if (!str_suffix(victim->poweraction,"gi") ||
	!str_suffix(victim->poweraction,"qui"))
	return;
    if (is_safe(ch, victim) ) return;
    if (victim->powertype != NULL && strlen(victim->powertype) > 1)
    {
	sprintf(buf,"\n\r%s\n\r",victim->powertype);
	send_to_char(buf,ch);
    }
    if (IS_SET(victim->spectype,EYE_SELFACTION) && victim->poweraction != NULL)
	interpret(victim,victim->poweraction);
    if (IS_SET(victim->spectype,EYE_ACTION) && victim->poweraction != NULL)
	interpret(ch,victim->poweraction);
    if (IS_SET(victim->spectype,EYE_SPELL) && victim->specpower > 0)
    {
	tabletype = skill_table[victim->specpower].target;
	(*skill_table[victim->specpower].spell_fun) (victim->specpower,victim->spl[tabletype],victim,ch);
    }
    return;
}


void show_char_to_char_1( CHAR_DATA *victim, CHAR_DATA *ch )
{
    char buf[MAX_STRING_LENGTH];
    OBJ_DATA *obj;
    int iWear;
    int percent;
    bool found;

    if ( can_see( victim, ch ) )
    {
	act( "$n looks at you.", ch, NULL, victim, TO_VICT    );
	act( "$n looks at $N.",  ch, NULL, victim, TO_NOTVICT );
    }

    if (!IS_NPC(ch) && IS_HEAD(victim,LOST_HEAD))
    {
	act( "$N is lying here.", ch, NULL, victim, TO_CHAR );
	return;
    }
    if ( victim->description[0] != '\0' )
    {
	send_to_char( victim->description, ch );
    }
    else
    {
	act( "You see nothing special about $M.", ch, NULL, victim, TO_CHAR );
    }

    if ( victim->max_hit > 0 )
	percent = ( 100 * victim->hit ) / victim->max_hit;
    else
	percent = -1;

    strcpy( buf, PERS(victim, ch) );

         if ( percent >= 100 ) strcat( buf, " is in perfect health.\n\r"  );
    else if ( percent >=  90 ) strcat( buf, " is slightly scratched.\n\r" );
    else if ( percent >=  80 ) strcat( buf, " has a few bruises.\n\r"     );
    else if ( percent >=  70 ) strcat( buf, " has some cuts.\n\r"         );
    else if ( percent >=  60 ) strcat( buf, " has several wounds.\n\r"    );
    else if ( percent >=  50 ) strcat( buf, " has many nasty wounds.\n\r" );
    else if ( percent >=  40 ) strcat( buf, " is bleeding freely.\n\r"    );
    else if ( percent >=  30 ) strcat( buf, " is covered in blood.\n\r"   );
    else if ( percent >=  20 ) strcat( buf, " is leaking guts.\n\r"       );
    else if ( percent >=  10 ) strcat( buf, " is almost dead.\n\r"        );
    else                       strcat( buf, " is DYING.\n\r"              );

    buf[0] = UPPER(buf[0]);
    send_to_char( buf, ch );
 
    if (!IS_NPC( victim ))
    {
    	if (IS_AFFECTED(victim, AFF_INFRARED)) act("$N's eyes are glowing bright red.",ch,NULL,victim,TO_CHAR);
    	if (IS_AFFECTED(victim, AFF_FLYING)) act("$N is hovering in the air.",ch,NULL,victim,TO_CHAR); 
		if (!IS_NPC(victim) && IS_CLASS(victim, CLASS_DROW) && IS_SET(victim->pcdata->powers[1], DPOWER_LEVITATION))
			act("$N is hovering in the air.", ch,NULL,victim,TO_CHAR); 
		if (!IS_NPC(victim) && IS_CLASS(victim, CLASS_DROW) && IS_SET(victim->pcdata->powers[1], DPOWER_ARMS))
			act("$N has 6 extra spidery arms protruding from $S body.",ch,NULL,victim,TO_CHAR);
                if (!IS_NPC(victim) && IS_CLASS(victim, CLASS_JEDI) && (victim->pcdata->powers[JPOWER_MIND] >= 1))
			act("$N is hovering in the air.", ch,NULL,victim,TO_CHAR); 
	    if (IS_VAMPAFF(victim, VAM_FANGS)) act("$N has a pair of long, pointed fangs.",ch,NULL,victim,TO_CHAR); 
	    if (!IS_NPC(victim) && IS_CLASS(victim, CLASS_VAMPIRE) && IS_VAMPAFF(victim, VAM_CLAWS))
			act("$N has razor sharp claws protruding from under $S finger nails.",ch,NULL,victim,TO_CHAR);
		else if (IS_CLASS(victim, CLASS_NINJA) && IS_VAMPAFF(victim, VAM_CLAWS))
			act("$N has IronClaws protruding from $S wrists.",ch,NULL,victim,TO_CHAR);
	    else if (!IS_NPC(victim) && IS_VAMPAFF(victim, VAM_CLAWS))
			act("$N has razor sharp talons extending from $S fingers.",ch,NULL,victim,TO_CHAR);
	    if (!IS_NPC(victim))
	    {
			if (!IS_CLASS(victim, CLASS_VAMPIRE) && IS_SET(victim->newbits, NEW_SKIN)) act("$N has scales all over $S body.",ch,NULL,victim,TO_CHAR);
			if (IS_VAMPAFF(victim, VAM_HORNS)) act("$N has a pair of pointed horns extending from $S head.",ch,NULL,victim,TO_CHAR);
			if (IS_VAMPAFF(victim, VAM_WINGS))
			{
	    		if (IS_DEMAFF(victim, DEM_UNFOLDED))
					act("$N has a pair of batlike wings spread out from behind $S back.",ch,NULL,victim,TO_CHAR);
	    		else
			 		act("$N has a pair of batlike wings folded behind $S back.",ch,NULL,victim,TO_CHAR);
			}
			if (IS_VAMPAFF(victim, VAM_HEAD))
			 {
			   act("$N's head resembles that of a fierce lion.",ch,NULL,victim,TO_CHAR);
			 }
		   if (IS_VAMPAFF(victim, VAM_TAIL))
				act("$N has a sharp tail extending from $S spine.",ch,NULL,victim,TO_CHAR); 
		   if (IS_VAMPAFF(victim, VAM_EXOSKELETON))
				act("$N's skin is covered by a hard exoskeleton.",ch,NULL,victim,TO_CHAR);
 
	  	}
	}
	found = FALSE;
    for ( iWear = 0; iWear < MAX_WEAR; iWear++ )
    {
	if ( ( obj = get_eq_char( victim, iWear ) ) != NULL
	&&   can_see_obj( ch, obj ) )
	{
	    if ( !found )
	    {
		send_to_char( "\n\r", ch );
		act( "$N is using:", ch, NULL, victim, TO_CHAR );
		found = TRUE;
	    }
	    send_to_char( where_name[iWear], ch );
	    if (IS_NPC(ch) || ch->pcdata->chobj == NULL || ch->pcdata->chobj != obj)
	    {
	    	send_to_char( format_obj_to_char( obj, ch, TRUE ), ch );
	    	send_to_char( "\n\r", ch );
	    }
	    else
		send_to_char( "you\n\r", ch);
	}
    }

    if ( victim != ch
    &&   !IS_NPC(ch)
    &&   !IS_HEAD(victim, LOST_HEAD)
    &&   number_percent( ) < ch->pcdata->learned[gsn_peek] )
    {
	send_to_char( "\n\rYou peek at the inventory:\n\r", ch );
	show_list_to_char( victim->carrying, ch, TRUE, TRUE );
    }

    return;
}



void show_char_to_char( CHAR_DATA *list, CHAR_DATA *ch )
{
    CHAR_DATA *rch;

    for ( rch = list; rch != NULL; rch = rch->next_in_room )
    {
	if ( rch == ch )
	    continue;

	if ( IS_EMPLOYEE(ch) || IS_EMPLOYEE(rch) )
	{
	    if ( !IS_NPC(rch)
	    &&   IS_SET(rch->act, PLR_WIZINVIS)
	    &&   get_trust( ch ) < get_trust( rch ) )
		continue;
	}
	else
	{
	    if ( !IS_NPC(rch)
	    && ( IS_SET(rch->act, PLR_WIZINVIS)
	    ||   IS_ITEMAFF(rch, ITEMA_VANISH) )
	    &&   !IS_SET(ch->act, PLR_HOLYLIGHT)
	    &&   !IS_ITEMAFF(ch, ITEMA_VISION) )
		continue;
	}

	if ( !IS_NPC(rch) && IS_HEAD(rch,LOST_HEAD))
	    continue;

	if ( !IS_NPC(rch) && IS_EXTRA(rch,EXTRA_OSWITCH))
	    continue;

	if ( can_see( ch, rch ) )
	    show_char_to_char_0( rch, ch );
	else if ( room_is_dark( ch->in_room )
	&&      ( IS_AFFECTED(rch, AFF_INFRARED)||(!IS_NPC(rch))))
	{
	    send_to_char( "You see glowing #Rred#n eyes watching YOU!\n\r", ch );
	}
    }

    return;
} 



bool check_blind( CHAR_DATA *ch )
{

    if ( IS_EXTRA(ch, BLINDFOLDED) )
    {
        send_to_char( "You can't see a thing through the blindfold!\n\r", ch );
        return FALSE;
    }     

    if ( !IS_NPC(ch) && IS_SET(ch->act, PLR_HOLYLIGHT) )
	return TRUE;

    if ( IS_ITEMAFF(ch, ITEMA_VISION) )
	return TRUE;

    if ( IS_HEAD(ch, LOST_EYE_L) && IS_HEAD(ch, LOST_EYE_R) )
    {
	send_to_char( "You have no eyes!\n\r", ch );
	return FALSE;
    }

    if ( IS_AFFECTED(ch, AFF_BLIND) && !IS_AFFECTED(ch, AFF_SHADOWSIGHT))
    {
	send_to_char( "You can't see a thing!\n\r", ch );
	return FALSE;
    }

    return TRUE;
}



void do_look( CHAR_DATA *ch, char *argument )  {
    char buf  [MAX_STRING_LENGTH];
    char arg1 [MAX_INPUT_LENGTH];
    char arg2 [MAX_INPUT_LENGTH];
    EXIT_DATA *pexit;
    CHAR_DATA *victim;
    CHAR_DATA *vch;
    CHAR_DATA *vch_next;
    CHAR_DATA *wizard;
    OBJ_DATA *obj;
    OBJ_DATA *portal;
    OBJ_DATA *portal_next;
    ROOM_INDEX_DATA *pRoomIndex;
    ROOM_INDEX_DATA *location;
    char *pdesc;
    int door;
    bool found;
    bool partial;
    bool frozen;

    if ( ch->desc == NULL && (wizard = ch->wizard) == NULL) return; 

    if (ch->in_room == NULL) return;

    if ( ch->position < POS_SLEEPING )
    {
	send_to_char( "You can't see anything but stars!\n\r", ch );
	return;
    }

    if ( ch->position == POS_SLEEPING )
    {
	send_to_char( "You can't see anything, you're sleeping!\n\r", ch );
	return;
    }

    if ( IS_SET(ch->flag2,AFF2_TOTALBLIND))
    {
    send_to_char("You can't see anything because you're blinded!\n\r",ch);
    return;
    }

    if ( !check_blind( ch ) )
	return;

    if ( !IS_NPC(ch) &&
	  IS_SET(ch->in_room->room_flags, ROOM_TOTAL_DARKNESS) &&
	 !IS_ITEMAFF(ch, ITEMA_VISION) &&
	 !IS_EMPLOYEE(ch) &&
	 !(IS_CLASS(ch, CLASS_DROW)))
    {
	send_to_char( "It is pitch black ... \n\r", ch );
	return;
    }

    if ( !IS_NPC(ch)
    &&   !IS_SET(ch->act, PLR_HOLYLIGHT)
    &&   !IS_ITEMAFF(ch, ITEMA_VISION)
    &&   !IS_AFFECTED(ch, AFF_SHADOWPLANE)
    &&   !(ch->in_room != NULL && ch->in_room->vnum == ROOM_VNUM_IN_OBJECT
    &&   !IS_NPC(ch) && ch->pcdata->chobj != NULL
    &&   ch->pcdata->chobj->in_obj != NULL)
    &&   room_is_dark( ch->in_room ) )
    {
	send_to_char( "It is pitch black ... \n\r", ch );
	show_char_to_char( ch->in_room->people, ch );
	return;
    }

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );

    if ( arg1[0] == '\0' || !str_cmp( arg1, "auto" ) )
    {
	/* 'look' or 'look auto' */
	if (ch->in_room != NULL && ch->in_room->vnum == ROOM_VNUM_IN_OBJECT
	&& !IS_NPC(ch) && ch->pcdata->chobj != NULL && ch->pcdata->chobj->in_obj != NULL)
	    act( "$p",ch,ch->pcdata->chobj->in_obj,NULL,TO_CHAR);
    	else if ( IS_AFFECTED(ch, AFF_SHADOWPLANE) )
	    send_to_char( "The shadow plane\n\r", ch );
        else if (!IS_SET(ch->act, PLR_MAP))
	{
	  if (!IS_NPC(ch) && ch->level > 6)
	  {
	   sprintf(buf, "%s #0[#7%d#0]#n\n\r", ch->in_room->name, ch->in_room->vnum);
	   send_to_char(buf, ch);
	  }
	else
	{
	    sprintf(buf, "%s\n\r", ch->in_room->name);
	    send_to_char( buf, ch );
	}
	}
	if ( !IS_NPC(ch) && IS_SET(ch->act, PLR_AUTOEXIT) && !IS_SET(ch->act,PLR_MAP))
	    do_exits( ch, "auto" ); 

	if (ch->in_room != NULL && ch->in_room->vnum == ROOM_VNUM_IN_OBJECT
	&& !IS_NPC(ch) && ch->pcdata->chobj != NULL && ch->pcdata->chobj->in_obj != NULL)
	{
	    act( "You are inside $p.",ch,ch->pcdata->chobj->in_obj,NULL,TO_CHAR);
	    show_list_to_char( ch->pcdata->chobj->in_obj->contains, ch, FALSE, FALSE );
	}
	else if ( (arg1[0] == '\0' || !str_cmp( arg1, "auto" ) ) && IS_AFFECTED(ch, AFF_SHADOWPLANE) )
	    send_to_char( "You are standing in complete darkness.\n\r", ch );
	else if ( ( !IS_NPC(ch) && !IS_SET(ch->act, PLR_BRIEF) ) &&
		( arg1[0] == '\0' || !str_cmp( arg1, "auto" ) ) )
	{
      	    if (IS_SET(ch->act, PLR_MAP))
             draw_map(ch, ch->in_room->description);
      	    else
	    send_to_char( ch->in_room->description, ch ); 
	    if (ch->in_room->blood == 1000)
		sprintf(buf,"You notice that the room is completely drenched in blood.\n\r");
	    else if (ch->in_room->blood > 750)
		sprintf(buf,"You notice that there is a very large amount of blood around the room.\n\r");
	    else if (ch->in_room->blood > 500)
		sprintf(buf,"You notice that there is a large quantity of blood around the room.\n\r");
	    else if (ch->in_room->blood > 250)
		sprintf(buf,"You notice a fair amount of blood on the floor.\n\r");
	    else if (ch->in_room->blood > 100)
		sprintf(buf,"You notice several blood stains on the floor.\n\r");
	    else if (ch->in_room->blood > 50)
		sprintf(buf,"You notice a few blood stains on the floor.\n\r");
	    else if (ch->in_room->blood > 25)
		sprintf(buf,"You notice a couple of blood stains on the floor.\n\r");
	    else if (ch->in_room->blood > 0)
		sprintf(buf,"You notice a few drops of blood on the floor.\n\r");
	    else sprintf(buf,"You notice nothing special in the room.\n\r");
	    ADD_COLOUR(ch, buf, L_RED);
	    if (ch->in_room->blood > 0) send_to_char(buf,ch);
	}
            if (IS_SET(ch->in_room->room_flags, ROOM_FLAMING))
            send_to_char("..This room is engulfed in flames!\n\r",ch);

	show_list_to_char( ch->in_room->contents, ch, FALSE, FALSE );

        for (door=0 ; door < 6 ; door++)
	{	
	    if (ch->in_room == NULL) continue;
	    if (ch->in_room->exit[door] == NULL) continue;

	    if (IS_SET(ch->in_room->exit[door]->exit_info,EX_PRISMATIC_WALL)) 
	    {
		sprintf(buf, "     There is a reinforced exit to the %s.\n\r", exitname2[door]);
	        send_to_char(buf, ch);
	    }
	    else if (IS_SET(ch->in_room->exit[door]->exit_info, EX_ICE_WALL))
	    {
		sprintf(buf, "     You see a glacier of ice %s.\n\r", exitname2[door]);
	        send_to_char(buf, ch);
	    }
	    else if (IS_SET(ch->in_room->exit[door]->exit_info,EX_CALTROP_WALL))
	    {
		sprintf(buf, "     You see a wall of caltrops %s.\n\r", exitname2[door]);
	        send_to_char(buf, ch);
	    }
	    else if (IS_SET(ch->in_room->exit[door]->exit_info,EX_FIRE_WALL))
	    {
		sprintf(buf, "     You see a blazing wall of fire %s.\n\r", exitname2[door]);
	        send_to_char(buf, ch);
	    }
	    else if (IS_SET(ch->in_room->exit[door]->exit_info,EX_SWORD_WALL))
	    {
		sprintf(buf, "     You see a spinning wall of swords %s.\n\r", exitname2[door]);
	        send_to_char(buf, ch);
	    }
	    else if (IS_SET(ch->in_room->exit[door]->exit_info,EX_MUSHROOM_WALL))
	    {
		sprintf(buf, "     You see a vibrating mound of mushrooms %s.\n\r", exitname2[door]);
	        send_to_char(buf, ch);
	    }
	    else if (IS_SET(ch->in_room->exit[door]->exit_info, EX_IRON_WALL))
	    {
		sprintf(buf, "    You see a solid wall of iron %s.\n\r", exitname2[door]);
	        send_to_char(buf, ch);
	    }
	    else if (IS_SET(ch->in_room->exit[door]->exit_info, EX_ASH_WALL))
	    {
		sprintf(buf, "    You see a deadly wall of ash %s.\n\r", exitname2[door]);
	        send_to_char(buf, ch);
	    }
	}
	show_char_to_char( ch->in_room->people,   ch );
	return;
    }

    if ( !str_cmp( arg1, "i" ) || !str_cmp( arg1, "in" ) )
    {
	/* 'look in' */
	if ( arg2[0] == '\0' )
	{
	    send_to_char( "Look in what?\n\r", ch );
	    return;
	}

	if ( ( obj = get_obj_here( ch, arg2 ) ) == NULL )
	{
	    send_to_char( "You do not see that here.\n\r", ch );
	    return;
	}

	switch ( obj->item_type )
	{
	default:
	    send_to_char( "That is not a container.\n\r", ch );
	    break;

	case ITEM_PORTAL: 
	    pRoomIndex = get_room_index(obj->value[0]);
	    location = ch->in_room;
	    if ( pRoomIndex == NULL )
	    {
		send_to_char( "It doesn't seem to lead anywhere.\n\r", ch );
		return;
	    }
	    if (obj->value[2] == 1 || obj->value[2] == 3)
	    {
		send_to_char( "It seems to be closed.\n\r", ch );
		return;
	    }
	    char_from_room(ch);
	    char_to_room(ch,pRoomIndex);

	    found = FALSE;
	    for ( portal = ch->in_room->contents; portal != NULL; portal = portal_next )
	    {
		portal_next = portal->next_content;
		if ( ( obj->value[0] == portal->value[3]  )
		    && (obj->value[3] == portal->value[0]) )
		{
		    found = TRUE;
		    if (IS_AFFECTED(ch, AFF_SHADOWPLANE) &&
			!IS_SET(portal->extra_flags, ITEM_SHADOWPLANE) )
		    {
			REMOVE_BIT(ch->affected_by, AFF_SHADOWPLANE);
	    		do_look(ch,"auto");
			SET_BIT(ch->affected_by, AFF_SHADOWPLANE);
			break;
		    }
		    else if (!IS_AFFECTED(ch, AFF_SHADOWPLANE) &&
			IS_SET(portal->extra_flags, ITEM_SHADOWPLANE) )
		    {
			SET_BIT(ch->affected_by, AFF_SHADOWPLANE);
	    		do_look(ch,"auto");
			REMOVE_BIT(ch->affected_by, AFF_SHADOWPLANE);
			break;
		    }
		    else
		    {
	    		do_look(ch,"auto");
			break;
		    }
	    	}
	    }
	    char_from_room(ch);
	    char_to_room(ch,location);
	    break;

	case ITEM_DRINK_CON:
	    if ( obj->value[1] <= 0 )
	    {
		send_to_char( "It is empty.\n\r", ch );
		break;
	    }

	    if (obj->value[1] < obj->value[0] / 5)
	    	sprintf( buf, "There is a little %s liquid left in it.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] < obj->value[0] / 4)
	    	sprintf( buf, "It contains a small about of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] < obj->value[0] / 3)
	    	sprintf( buf, "It's about a third full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] < obj->value[0] / 2)
	    	sprintf( buf, "It's about half full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] < obj->value[0])
	    	sprintf( buf, "It is almost full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] == obj->value[0])
	    	sprintf( buf, "It's completely full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else
	    	sprintf( buf, "Somehow it is MORE than full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    send_to_char( buf, ch );
	    break;
        case ITEM_SLOT_MACHINE:
          if(obj->value[3] == 1)
            partial = TRUE;
          else
            partial = FALSE;
          if(obj->value[4] == 1)
            frozen = TRUE;
          else
            frozen = FALSE;
          sprintf(buf,"This is a %d bar slot machine costing %d gold with a jackpot of %d gold coins.\n\rThe jackpot is %sfrozen with %spartial winnings.", obj->value[2], obj->value[0], obj->value[1], frozen ? "" : "not ", partial ? "" : "no ");
          send_to_char(buf, ch);
          break;
	case ITEM_CONTAINER: 
	case ITEM_CORPSE_NPC:
	case ITEM_CORPSE_PC:
	    if ( IS_SET(obj->value[1], CONT_CLOSED) )
	    {
		send_to_char( "It is closed.\n\r", ch );
		break;
	    }

	    act( "$p contains:", ch, obj, NULL, TO_CHAR );
	    show_list_to_char( obj->contains, ch, TRUE, TRUE );
	    break;
	}
	return;
    }

    if ( ( victim = get_char_room( ch, arg1 ) ) != NULL )
    {
	show_char_to_char_1( victim, ch );
	evil_eye(victim,ch);
	return;
    }

    for ( vch = char_list; vch != NULL; vch = vch_next )
    {
	vch_next	= vch->next;
	if ( vch->in_room == NULL )
	    continue;
	if ( vch->in_room == ch->in_room )
	{
	    if (!IS_NPC(vch) && !str_cmp(arg1,vch->morph))
	    {
		show_char_to_char_1( vch, ch );
		evil_eye(vch,ch);
		return;
	    }
	    continue;
	}
    }

    if (!IS_NPC(ch) && ch->pcdata->chobj != NULL && ch->pcdata->chobj->in_obj != NULL)
    {
	obj = get_obj_in_obj(ch,arg1);
	if (obj != NULL)
	{
	    send_to_char( obj->description, ch );
	    send_to_char( "\n\r", ch );
	    return;
	}
    }

    for ( obj = ch->carrying; obj != NULL; obj = obj->next_content )
    {
	if (!IS_NPC(ch) && ch->pcdata->chobj != NULL && obj->chobj != NULL && obj->chobj == ch)
	    continue;
	if ( can_see_obj( ch, obj ) )
	{
	    pdesc = get_extra_descr( arg1, obj->extra_descr );
	    if ( pdesc != NULL )
	    {
		send_to_char( pdesc, ch );
		return;
	    }

	    pdesc = get_extra_descr( arg1, obj->pIndexData->extra_descr );
	    if ( pdesc != NULL )
	    {
		send_to_char( pdesc, ch );
		return;
	    }
	}

	if ( is_name( arg1, obj->name ) )
	{
	    send_to_char( obj->description, ch );
	    send_to_char( "\n\r", ch );
	    return;
	}
    }

    for ( obj = ch->in_room->contents; obj != NULL; obj = obj->next_content )
    {
	if (!IS_NPC(ch) && ch->pcdata->chobj != NULL && obj->chobj != NULL && obj->chobj == ch)
	    continue;
	if ( can_see_obj( ch, obj ) )
	{
	if (obj->item_type == ITEM_WINDOW)
	{
	look_window(ch, obj);
	return;
	}
	    pdesc = get_extra_descr( arg1, obj->extra_descr );
	    if ( pdesc != NULL )
	    {
		send_to_char( pdesc, ch );
		return;
	    }

	    pdesc = get_extra_descr( arg1, obj->pIndexData->extra_descr );
	    if ( pdesc != NULL )
	    {
		send_to_char( pdesc, ch );
		return;
	    }
	}

	if ( is_name( arg1, obj->name ) )
	{
	    send_to_char( obj->description, ch );
	    send_to_char( "\n\r", ch );
	    return;
	}
    }

    pdesc = get_extra_descr( arg1, ch->in_room->extra_descr );
    if ( pdesc != NULL )
    {
	send_to_char( pdesc, ch );
	return;
    }
	if ( !str_cmp( arg1, "sky" ) )                                                  
	{                                                                               
  	if ( !IS_OUTSIDE(ch) )                                                        
  	{                                                                             
    	send_to_char( "You can't see the sky indoors.\n\r", ch );                   
    	return;                                                                     
  	}                                                                             
  	else                                                                          
  	{                                                                             
    	look_sky(ch);                                                               
    	return;                                                                     
  	}                                                                             
	}
         if ( !str_cmp( arg1, "n" ) || !str_cmp( arg1, "north" ) ) door = 0;
    else if ( !str_cmp( arg1, "e" ) || !str_cmp( arg1, "east"  ) ) door = 1;
    else if ( !str_cmp( arg1, "s" ) || !str_cmp( arg1, "south" ) ) door = 2;
    else if ( !str_cmp( arg1, "w" ) || !str_cmp( arg1, "west"  ) ) door = 3;
    else if ( !str_cmp( arg1, "u" ) || !str_cmp( arg1, "up"    ) ) door = 4;
    else if ( !str_cmp( arg1, "d" ) || !str_cmp( arg1, "down"  ) ) door = 5;
    else
    {
	send_to_char( "You do not see that here.\n\r", ch );
	return;
    }

    /* 'look direction' */
    if ( ( pexit = ch->in_room->exit[door] ) == NULL )
    {
	send_to_char( "Nothing special there.\n\r", ch );
	return;
    }
/*
    if ( pexit->description != NULL && pexit->description[0] != '\0' )
	send_to_char( pexit->description, ch );
    else
	send_to_char( "Nothing special there.\n\r", ch );
*/

    if ( pexit->keyword    != NULL
    &&   pexit->keyword[0] != '\0'
    &&   pexit->keyword[0] != ' ' )
    {
	if ( IS_SET(pexit->exit_info, EX_CLOSED) )
	{
	    act( "The $d is closed.", ch, NULL, pexit->keyword, TO_CHAR );
	}
	else if ( IS_SET(pexit->exit_info, EX_ISDOOR) )
	{
	    act( "The $d is open.",   ch, NULL, pexit->keyword, TO_CHAR );
	    if ((pexit = ch->in_room->exit[door]) == NULL) return;
	    if ((pRoomIndex = pexit->to_room) == NULL) return;
	    location = ch->in_room;
	    char_from_room(ch);
	    char_to_room(ch,pRoomIndex);
	    do_look(ch,"auto");
	    char_from_room(ch);
	    char_to_room(ch,location);
	}
	else
	{
	    if ((pexit = ch->in_room->exit[door]) == NULL) return;
	    if ((pRoomIndex = pexit->to_room) == NULL) return;
	    location = ch->in_room;
	    char_from_room(ch);
	    char_to_room(ch,pRoomIndex);
	    do_look(ch,"auto");
	    char_from_room(ch);
	    char_to_room(ch,location);
	}
    }
    else
    {
	if ((pexit = ch->in_room->exit[door]) == NULL) return;
	if ((pRoomIndex = pexit->to_room) == NULL) return;
	location = ch->in_room;
	char_from_room(ch);
	char_to_room(ch,pRoomIndex);
	do_look(ch,"auto");
	char_from_room(ch);
	char_to_room(ch,location);
    }

    return;
}



void do_examine( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    OBJ_DATA *obj;
    bool partial;
    bool frozen;

    one_argument( argument, arg ); 

    if ( arg[0] == '\0' )
    {
	send_to_char( "Examine what?\n\r", ch );
	return;
    }

    do_look( ch, arg );

    if ( ( obj = get_obj_here( ch, arg ) ) != NULL )
    {
	     if (obj->condition >= 100) 
	    sprintf( buf, "You notice that %s is in perfect condition.\n\r",obj->short_descr );
	else if (obj->condition >= 75 )
	    sprintf( buf, "You notice that %s is in good condition.\n\r",obj->short_descr );
	else if (obj->condition >= 50 )
	    sprintf( buf, "You notice that %s is in average condition.\n\r",obj->short_descr );
	else if (obj->condition >= 25 )
	    sprintf( buf, "You notice that %s is in poor condition.\n\r",obj->short_descr );
	else
	    sprintf( buf, "You notice that %s is in awful condition.\n\r",obj->short_descr );
	send_to_char(buf,ch);
	switch ( obj->item_type )
	{
	default:
	    break;
        case ITEM_SLOT_MACHINE:
          if(obj->value[3] == 1)
            partial = TRUE;
         else
            partial = FALSE;
          if(obj->value[4] == 1)
            frozen = TRUE;
          else
            frozen = FALSE;
          sprintf(buf,"This is a %d bar slot machine costing %d gold with a jackpot of %d gold coins.\n\rThe jackpot is %sfrozen with %spartial winnings.", obj->value[2], obj->value[0], obj->value[1], frozen ? "" : "not ", partial ? "" : "no ");
          send_to_char(buf, ch);
          break;
	case ITEM_DRINK_CON: 
	case ITEM_CONTAINER:
	case ITEM_CORPSE_NPC:
	case ITEM_CORPSE_PC:
	    send_to_char( "When you look inside, you see:\n\r", ch );
	    sprintf( buf, "in %s", arg );
	    do_look( ch, buf );
	}
    }

    return;
}



/*
 * Thanks to Zrin for auto-exit part.
 */
void do_exits( CHAR_DATA *ch, char *argument )  {
    extern char * const dir_name[];
    char buf[MAX_STRING_LENGTH];
    EXIT_DATA *pexit;
    bool found;
    bool fAuto;
    int door;

    buf[0] = '\0';
    fAuto  = !str_cmp( argument, "auto" );

    if ( !check_blind( ch ) )
	return;

    strcpy( buf, fAuto ? "#o[#nE#7x#ni#7t#ns#R:#C" : "#GO#gbvious#G E#gxits#o:\n\r" );

    found = FALSE;
    for ( door = 0; door <= 5; door++ )
    {
	if ( ( pexit = ch->in_room->exit[door] ) != NULL
	&&   pexit->to_room != NULL
	&&   !IS_SET(pexit->exit_info, EX_CLOSED) )
	{
	    found = TRUE;
	    if ( fAuto )
	    {
		strcat( buf, " " );
		strcat( buf, dir_name[door] );
	    }
	    else
	    {
		sprintf( buf + strlen(buf), "%-5s - %s\n\r",
		    capitalize( dir_name[door] ),
		    room_is_dark( pexit->to_room )
			?  "Too dark to tell"
			: pexit->to_room->name
		    );
	    }
	}
    }

    if ( !found )
	strcat( buf, fAuto ? " none" : "None.\n\r" );

    if ( fAuto )
	strcat( buf, "#o]\n\r" );

    send_to_char( buf, ch );
    return;
}
 

void do_stat( CHAR_DATA *ch, char *argument )
{
    char buf   [MAX_STRING_LENGTH];
    char lin   [MAX_STRING_LENGTH];
    int blood;
    int bloodpool;

    if (ch->generation <= 0)
	ch->generation = 4;

    {
    bloodpool = (2000 / ch->generation);
    if (ch->generation == 0) bloodpool = 5000;
    }

    blood = ch->pcdata->condition[COND_THIRST];
    if (IS_NPC(ch)) return;
    if (!IS_CLASS(ch, CLASS_VAMPIRE)) return; 
    sprintf( lin,
"---------------------------------------------------------------------------\n\r");
    send_to_char( lin,ch);
    send_to_char(
"                              Vampire Status\n\r",ch);
send_to_char(lin,ch);
sprintf(buf,"Generation:%d  Bloodpool:%d  Blood:%d\n\r",ch->generation,bloodpool,blood);
send_to_char(buf,ch);
send_to_char(lin,ch);
send_to_char(
"                              Disciplines\n\r",ch);
send_to_char(lin,ch);
sprintf(buf,
"Concealment:[%d]             Defensive:   [%d]              Blood:   [%d]\n\r",
ch->power[DISC_VAMP_CONCEALMENT],ch->power[DISC_VAMP_DEFENSIVE],
ch->power[DISC_VAMP_BLOOD]);
send_to_char(buf,ch);
sprintf(buf,
"Confusion:     [%d]             Dominate:  [%d]             Offensive:   [%d]\n\r",
ch->power[DISC_VAMP_CONFUSION],ch->power[DISC_VAMP_DOMI],
ch->power[DISC_VAMP_OFFENSIVE]);
send_to_char(buf,ch);
send_to_char(lin,ch);
 
return;
}

void do_racestats( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    
    extra_to_char("S T A T I S T I C S",ch);
    
    if (ch->class == 0)
       sprintf(buf,"You have yet to be transformed.");
    else if (ch->class == CLASS_DEMON)
       sprintf(buf,"You have been transformed into a Demon.");
    else if (ch->class == CLASS_VAMPIRE)
       sprintf(buf,"You have been transformed into a Vampire.");
    else if (ch->class == CLASS_WEREWOLF)
       sprintf(buf,"You have been transformed into a Werewolf.");
    else if (ch->class == CLASS_MAGE) 
       sprintf(buf,"You have been trained in the ways of Magic.");
    else if (ch->class == CLASS_DROW) 
       sprintf(buf,"You have become a legion of Lloth's Army.");
    else if (ch->class == CLASS_ELEMENT)
       sprintf(buf,"You have become a master of the elements.");
    else if (ch->class == CLASS_JEDI)
	sprintf(buf,"You have learned to tune the force to your will.");
    else if (ch->class == CLASS_MONK)
       sprintf(buf,"You have been guided by the ways of the Almighty.");
    else
       sprintf(buf,"You have been transformed.");

    cent_to_char( buf, ch );

    if (ch->class == CLASS_VAMPIRE)
    {
	sprintf(buf, "You are of generation %d.", ch->generation);
	cent_to_char(buf, ch);
    }

    if (ch->class == 0)
    {
	sprintf(buf, "You are %d%% of the way to being powerful enough for transformation,",
		ch->explevel * 100 / 20);
	cent_to_char(buf, ch);
	if (ch->max_hit < 1500 && ch->max_move >= 1500)
	    sprintf(buf, "and you need %d more hit points.", 1500 - ch->max_hit);
	else if (ch->max_hit < 1500 && ch->max_move < 1500)
	    sprintf(buf, "and you need %d more hit points and %d more vitality.",
		1500 - ch->max_hit, 1500 - ch->max_move);
	else if (ch->max_move < 1500)
	    sprintf(buf, "and you need %d more vitality.", 1500 - ch->max_move);
	else sprintf(buf, "and you have the required hit points and vitality.");
	cent_to_char(buf, ch);
    }

    if (ch->cur_form != 0)
    {
	sprintf(buf, "You are currently in the form of a %s.",
	    form_data[ch->cur_form].lookname);
	cent_to_char(buf, ch);
    }

    ch->size = get_size(ch);

    if (ch->size == SIZE_TINY)
	cent_to_char("You are of tiny size.", ch);
    else if (ch->size == SIZE_SMALL)
	cent_to_char("You are of small size.", ch);
    else if (ch->size == SIZE_MEDIUM)
	cent_to_char("You are of medium size.", ch);
    else if (ch->size == SIZE_LARGE)
	cent_to_char("You are of large size.", ch);
    else if (ch->size == SIZE_HUGE)
	cent_to_char("You are of huge size.", ch);
    else if (ch->size == SIZE_GIANT)
	cent_to_char("You are absolutely gigantic.", ch);
    else
	cent_to_char("You are of medium size.", ch);

    if (IS_SET(ch->act, PLR_WIZINVIS) && IS_EMPLOYEE(ch))
    {
	sprintf( buf, "You are invisible.");
	cent_to_char(buf,ch);
    }

    divide5_to_char(ch);

    if (IS_SET(ch->newbits, THIRD_HAND) && !IS_SET(ch->newbits, FOURTH_HAND))
	  cent_to_char("You have grown an extra arm.",ch);
    if (!IS_SET(ch->newbits, THIRD_HAND) && IS_SET(ch->newbits, FOURTH_HAND))
        cent_to_char("You have grown an extra arm.",ch);
    if (IS_SET(ch->newbits, THIRD_HAND) && IS_SET(ch->newbits, FOURTH_HAND))
        cent_to_char("You have grown two extra arms.",ch);

    if (ch->class == CLASS_VAMPIRE
	&& ch->pcdata->stats[COND_THIRST] < 20)
    	cent_to_char("You are dangerously low on blood.", ch);

    if (!IS_NPC(ch) && str_cmp(ch->name, ch->pcdata->switchname)
	&& !IS_BASE_FORM(ch))
    {
	sprintf(buf,"You are currently masked as %s.", ch->name);
	cent_to_char(buf, ch);
    }

    if (ch->class == CLASS_DEMON
	&& !IS_NPC(ch)
	&& ch->generation != 13)
    {
	sprintf(buf,"You have collected %d souls, which you keep hidden in a little jar.", ch->pcdata->souls);
	cent_to_char(buf, ch);
    }
   
    if (ch->class == 0)
    {
	if (IS_SET(ch->immune, IMM_VAMPIRE))
		cent_to_char("You may be classed by someone who is already classed.",ch);
    }

   divide5_to_char(ch);

    if (!IS_NPC(ch) )
    {
	  sprintf(buf,"Your maximum damage is currently %d.",ch->damcap[0]);
        cent_to_char(buf, ch);
	sprintf(buf, "You have killed %d enemy mobs, and been killed by %d.", ch->mkill, ch->mdeath);
	cent_to_char(buf, ch);
    }

    if (ch->power[DISC_DAEM_GELU] > 1 && ch->played/18000 > 0)
    {
	sprintf(buf,"Your icy strength is improving your damage by %d.", ch->played/18000);
	cent_to_char(buf, ch);
    }

   if (IS_VAMPAFF(ch, VAM_FANGS)
	|| IS_VAMPAFF(ch, VAM_CLAWS)
	|| IS_VAMPAFF(ch, VAM_WINGS)
	|| IS_VAMPAFF(ch, VAM_HORNS)
	|| IS_VAMPAFF(ch, VAM_TAIL))
   {
	bool comma = FALSE;
	strcpy(buf, "You have extra ");
	if (IS_VAMPAFF(ch, VAM_FANGS))
	{
	    comma = TRUE;
	    strcat(buf, "bite");
        }
	if (IS_VAMPAFF(ch, VAM_CLAWS))
	{
	    if (comma)
	    {
		if (!IS_VAMPAFF(ch, VAM_WINGS) && IS_VAMPAFF(ch,VAM_TAIL))
		    strcat(buf, " and ");
		else strcat(buf, ", ");
	    }
	    comma = TRUE;
	    strcat(buf, "claw");
        }
	if (IS_VAMPAFF(ch, VAM_WINGS))
	{
	    if (comma)
	    {
		if (!IS_VAMPAFF(ch, VAM_TAIL))
		    strcat(buf, " and ");
		else strcat(buf,", ");
	    }
	    comma = TRUE;
	    strcat(buf,"wing");
        }
	if (IS_VAMPAFF(ch, VAM_HORNS))
	{
	    if (comma)
	    {
		if (!IS_VAMPAFF(ch, VAM_TAIL))
		    strcat(buf, " and ");
		else strcat(buf,", ");
	    }
	    comma = TRUE;
	    strcat(buf,"horn");
        }
	if (IS_VAMPAFF(ch, VAM_TAIL))
	{
	    if (comma) strcat(buf," and ");
	    strcat(buf,"tail");
        }

	strcat(buf," attacks.");
	cent_to_char(buf,ch);
    }

    divide4_to_char(ch);
}

char *	const	day_name	[] =
{
    "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
};

char *	const	month_name	[] =
{
    "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
};

void do_time( CHAR_DATA *ch, char *argument )  {
    extern char str_boot_time[];
    char buf[MAX_STRING_LENGTH];
    char *suf;
    int day;

    day     = time_info.day + 1;

         if ( day > 4 && day <  20 ) suf = "th";
    else if ( day % 10 ==  1       ) suf = "st";
    else if ( day % 10 ==  2       ) suf = "nd";
    else if ( day % 10 ==  3       ) suf = "rd";
    else                             suf = "th";

    sprintf( buf,
	"It is %d%s on %s, %s %d%s.\n\rPrometheus Unbound started up at %s\n\r#oSystem time:#c %s#n\n\r",

	(time_info.hour % 12 == 0) ? 12 : time_info.hour % 12,
	time_info.hour >= 12 ? "pm" : "am",
	day_name[day % 7],
	month_name[time_info.month],
	day, suf,
	str_boot_time,
	(char *) ctime( &current_time)
	 ); 

    send_to_char( buf, ch );
    return;
}


void do_who( CHAR_DATA *ch, char *argument )  {
    char cls[MAX_STRING_LENGTH];
    char buf[MAX_STRING_LENGTH];
    char buf2[MAX_STRING_LENGTH];
    char buf3[MAX_STRING_LENGTH];
    char buf4[MAX_STRING_LENGTH];
    char buf5[MAX_STRING_LENGTH];
    char buf6[MAX_STRING_LENGTH];
    char buf7[MAX_STRING_LENGTH];
    char buf8[MAX_STRING_LENGTH];
    char buf9[MAX_STRING_LENGTH];
    char buf10[MAX_STRING_LENGTH];
    char buf11[MAX_STRING_LENGTH];
    char buf12[MAX_STRING_LENGTH];
    char buf13[MAX_STRING_LENGTH];
    char buf14[MAX_STRING_LENGTH];
    char buf15[MAX_STRING_LENGTH];
    char buf16[MAX_STRING_LENGTH];
    char buf17[MAX_STRING_LENGTH];
    char buf18[MAX_STRING_LENGTH];
    char buf19[MAX_STRING_LENGTH];
    char buf20[MAX_STRING_LENGTH];
    char kav[MAX_STRING_LENGTH];
    char king[MAX_STRING_LENGTH]; 
    char clan[MAX_STRING_LENGTH];
    char openb[15];
    char closeb[15];
    DESCRIPTOR_DATA *d;
    CHAR_DATA *wch;
    int iLevelLower; 
    int iLevelUpper;
    int nNumber;
    int nMatch;
    bool fClassRestrict;
    bool fImmortalOnly;
    bool immortal = FALSE, avatar = FALSE, mortal = FALSE, mains = FALSE; 
    bool imm = FALSE, ava = FALSE, mor = FALSE;
    bool a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16;

    if (IS_NPC(ch)) return; 

    /*
     * Set default arguments.
     */
    iLevelLower    = 0;
    iLevelUpper    = MAX_LEVEL;
    fClassRestrict = FALSE;
    fImmortalOnly  = FALSE;

    /*
     * Parse arguments.
     */
    nNumber = 0;
    for ( ;; )
    {
	char arg[MAX_STRING_LENGTH];

	argument = one_argument( argument, arg );
	if ( arg[0] == '\0' )
	    break;

	if ( is_number( arg ) )
	{
	    send_to_char("Enter 'Avatar' for level 3's, or 'Wiz' for levels 7-12.\n\r",ch);
	    return;
	}
	else
	{
	    /*
	     * Look for classes to turn on.
	     */
	    arg[3]    = '\0';
	    if (   !str_cmp( arg, "imm" ) || !str_cmp( arg, "immortal" )
		|| !str_cmp( arg, "ava" ) || !str_cmp( arg, "avatar"   ) )
	    {
		fClassRestrict = TRUE;
	    }
	    else if ( !str_cmp( arg, "imp" ) || !str_cmp( arg, "wiz" ) )
	    {
		fImmortalOnly = TRUE;
 	    }
	    else
	    {
		send_to_char("Enter 'Avatar' for level 3's, or 'Wiz' for levels 7 - 12.\n\r",ch);
		return;
	    }
	}
    }

    /*
     * Now show matching chars.
     */
    nMatch = 0;
    buf[0] = '\0';
    buf3[0] = '\0';
    buf4[0] = '\0';
    buf5[0] = '\0';
    buf6[0] = '\0';
    buf7[0] = '\0';
    buf8[0] = '\0';
    buf9[0] = '\0';
    buf10[0] = '\0';
    buf11[0] = '\0';
    buf12[0] = '\0';
    buf13[0] = '\0';
    buf14[0] = '\0';
    buf15[0] = '\0';
    buf16[0] = '\0';
    buf17[0] = '\0';
    buf18[0] = '\0';
    buf19[0] = '\0';
    buf20[0] = '\0';

    for ( d = descriptor_list; d != NULL; d = d->next ) 
    {
	char const *class;

	/*
	 * Check for match against restrictions.
	 * Don't use trust as that exposes trusted mortals.
	 */

	if ( (d->connected != CON_PLAYING && d->connected != CON_EDITING) 
	   || (!can_see(ch, d->character )))
	    continue;

	wch   = ( d->original != NULL ) ? d->original : d->character;
	if ( wch->level < iLevelLower
	||   wch->level > iLevelUpper
	|| ( fImmortalOnly  && wch->level <  LEVEL_EMPLOYEE )
	|| ( fClassRestrict && wch->level != LEVEL_ADVOCATE     ) )
	    continue;

	nMatch++;

	/*
	 * Figure out what to print for class.
	 */
	class = " ";

        if ((IS_HEAD(wch,LOST_HEAD) || IS_EXTRA(wch,EXTRA_OSWITCH)) && wch->pcdata->chobj != NULL)
	{
	    if (wch->pcdata->chobj->pIndexData->vnum == 12)
	    	class = "#y[#7A Head#n#y    ]";
	    else if (wch->pcdata->chobj->pIndexData->vnum == 30005)
	    	class = "#y[#oA Brain#n#y   ]";
	    else
	    	class = "#y[#1An Object#n#y ]";
	} else
	switch ( wch->level )
	{
	default: break;
	case MAX_LEVEL -  0:
		     if ( IS_EXTRA(wch, EXTRA_AFK) )
			class = "#1     AFK#n    ";
	        else if (wch->prefix != NULL)
			class = wch->prefix; 
     else if (!str_cmp(wch->pcdata->switchname,"Frankenstein"))
                             class = "#y[#CPresident       #y]";
     else
			     class = "#y[#CPresident       #y]"; break;
	case MAX_LEVEL -  1: class = "#y[#CVice President  #y]"; break;
	case MAX_LEVEL -  2: class = "#y[#CCEO             #y]"; break;
	case MAX_LEVEL -  3: class = "#y[#CChairperson     #y]"; break;
	case MAX_LEVEL -  4: class = "#y[#CAdministrator   #y]"; break;
	case MAX_LEVEL -  5: class = "#y[#CManager         #y]"; break;
	case MAX_LEVEL -  6: class = "#y[#CEmployee        #y]"; break;
	case MAX_LEVEL -  7: 
	             if (wch->prefix != NULL) class = wch->prefix;
	else if (wch->race <= 0 ) class = "#y[#1Sane            #y]";
	else if (wch->race <= 3 ) class = "#y[#2Bent            #y]";
	else if (wch->race <= 6 ) class = "#y[#3Hellbent      	#y]";
	else if (wch->race <= 9 ) class = "#y[#4Psychotic     	#y]";
	else if (wch->race <= 12) class = "#y[#5Sociopath     	#y]";
	else if (wch->race <= 15) class = "#y[#6Murderer      	#y]";
	else if (wch->race <= 18) class = "#y[#7Slayer        	#y]";
	else if (wch->race <= 21) class = "#y[#1Killer          #y]";
	else if (wch->race <= 24) class = "#y[#2Butcher 	#y]";
	else if (wch->race <= 27) class = "#y[#3Serial Killer   #y]";
	else if (wch->race <= 30) class = "#y[#5Looney          #y]"; 
	else if (wch->race <= 33) class = "#y[#1Raving Lunatic  #y]";
	else if (wch->race <= 36) class = "#y[#PSomewhat Insane #y]";
	else if (wch->race <= 39) class = "#y[#RPartially Insane#y]";
	else if (wch->race <= 42) class = "#y[#CMostly Insane   #y]";
	else if (wch->race <= 45) class = "#y[#GHighly Insane   #y]";
	else if (wch->race <= 50) class = "#y[#LTOTALLY INSANE  #y]";
	break;

	case MAX_LEVEL - 8: class = "#y[#1Consumer#y    ]"; break;
	case MAX_LEVEL - 9: class = "#y[#6Future Consumer#y]"; break;
	case MAX_LEVEL - 10: class = "#y[#7Undefined#y ]"; break;
	}
	/*
	 * Format it up.
	 */
  if (IS_CLASS(wch, CLASS_TANARRI))
    {strcpy(openb, "#y{#n");strcpy(closeb, "#y}#n");}
  else if (IS_CLASS(wch, CLASS_MECHA)) 
        {strcpy( openb, "#rx#Rx#rx#o->#n" ); strcpy( closeb, "#o<-#rx#Rx#rx#n" );}
  else if (IS_CLASS(wch, CLASS_ANGEL)) 
        {strcpy( openb, "#y.#7x#y[#n" ); strcpy( closeb, "#y]#7x#y.#n" );}
  else if (IS_CLASS(wch, CLASS_UNDEAD_KNIGHT))
        {strcpy( openb, "#o|[#n" ); strcpy( closeb, "#o]|#n" );}
  else if (IS_CLASS(wch, CLASS_SHAPESHIFTER))
        {strcpy( openb, "#r[#P*#r]#n" ); strcpy( closeb, "#r[#P*#r]#n" );}
  else if (IS_CLASS(wch, CLASS_VAMPIRE))
  	{strcpy( openb, "#R<<#n" ); strcpy( closeb, "#R>>#n" );}
  else if ( IS_CLASS(wch, CLASS_WEREWOLF))
    {strcpy( openb, "#y((#n" ); strcpy( closeb, "#y))#n" );}
  else if (IS_CLASS(wch,CLASS_MAGE)) 
    {strcpy( openb, "{{" ); strcpy( closeb, "}}" );}
  else if (IS_CLASS(wch,CLASS_CYBORG)) 
    {strcpy( openb, "#7}#C=#0{#n");strcpy( closeb, "#0}#C=#7{#n");}
  else if ( IS_CLASS(wch, CLASS_HIGHLANDER))
    {strcpy( openb, "#C-=#n" ); strcpy( closeb, "#C=-#n" );}
  else if ( IS_CLASS(wch, CLASS_DROW))
    {strcpy( openb, "#P.o0"); strcpy(closeb, "#P0o.#n" );}
  else if ( IS_CLASS(wch, CLASS_NINJA))
    {strcpy( openb, "#C***#n"); strcpy(closeb, "#C***#n" );}
  else if (IS_CLASS(wch, CLASS_MONK))
    {strcpy(openb, "#c.#gx#y[#n"); strcpy(closeb, "#y]#gx#c.#n");}
  else if (IS_CLASS(wch, CLASS_ELEMENT))
    {strcpy(openb, "#R)#y=#P(#n"); strcpy(closeb, "#P)#y=#R(#n");}
  else if (IS_CLASS(wch, CLASS_JEDI))
    {strcpy(openb, "#L+#l=#L+#n"); strcpy(closeb, "#L+#l=#L+#n");}
  else if (IS_CLASS(wch, CLASS_XOMBI))
    {strcpy(openb, "#7(#n@#7@#n="); strcpy(closeb, "#n=#7@#n@#7)#n");}
  else if (IS_CLASS(wch, CLASS_MUMMY))
    {strcpy(openb, "#R=#r=#0"); strcpy(closeb, "#r=#R=#n");}
  else if (IS_CLASS(wch, CLASS_DRAGON)) 
    {strcpy(openb, "#o)#G-#n"); strcpy(closeb, "#G-#o(#n");}
  else
    {strcpy( openb, "#C[#n" ); strcpy( closeb, "#C]#n" );}

  if ( wch->class > 0)
  {
  if (IS_CLASS(wch, CLASS_MAGE) ) 
  {
    if (wch->generation == 0)
      sprintf(kav, "%s#CGod of Magic#n%s            ", openb, closeb);
    else if (wch->generation == 1)
      sprintf(kav, "%s#CArchmagus#n%s               ", openb, closeb);
    else if(wch->generation == 2)
      sprintf(kav, "%s#CArchmage#n%s                ", openb, closeb);
    else if(wch->generation == 3)
      sprintf(kav, "%s#CLord of Spells#n%s          ", openb, closeb);
    else if(wch->generation == 4)
      sprintf(kav, "%s#CHigh Invoker#n%s            ", openb, closeb);
    else if(wch->generation == 5)
      sprintf(kav, "%s#CWizard of War#n%s           ", openb, closeb);
    else if(wch->generation == 6)
      sprintf(kav, "%s#CBattlemage#n%s              ", openb, closeb);
    else if(wch->generation == 7)
      sprintf(kav, "%s#CApprentice#n%s              ", openb, closeb);
    else
      sprintf(kav, "%s#CMagician#n%s                ", openb, closeb);
  }
  else if (IS_CLASS(wch, CLASS_CYBORG))
  {
    if (wch->generation == 0)
      sprintf(kav,"%s#nT#7h#ne#7 B#nr#7a#ni#7n#n%s             ", openb, closeb);
    else if (wch->generation == 1)
      sprintf(kav,"%s#nC#7ybernetic#n M#7aster#n%s     ",openb,closeb);
    else if (wch->generation == 2)
      sprintf(kav,"%s#7Cyborg A#n%s              ",openb,closeb);
    else if (wch->generation == 3)
      sprintf(kav,"%s#7Cyborg B#n%s              ",openb,closeb);
    else if (wch->generation == 4)
      sprintf(kav,"%s#7Cyborg C#n%s              ",openb,closeb);
    else if (wch->generation == 5)
      sprintf(kav,"%s#7Cyborg D#n%s              ",openb,closeb);
    else if (wch->generation == 6)
      sprintf(kav,"%s#7Cyborg E#n%s              ",openb,closeb);
  	else
      sprintf(kav,"%s#CCyborg Drone#n%s          ",openb,closeb);
  }
  else if( IS_CLASS(wch, CLASS_XOMBI))
  {
    if (wch->generation == 0)
      sprintf(kav,"%s#7X#lo#7m#lb#7i #lL#7o#lr#7d#n%s          ", openb, closeb );
    else if(wch->generation == 1)
      sprintf(kav,"%s#lB#7r#la#7i#ln #7E#la#7t#le#7r#n%s         ", openb, closeb );
    else if(wch->generation == 2)
      sprintf(kav,"%s#LF#ll#Le#ls#Lh #lE#La#lt#Le#lr#n%s         ", openb, closeb );
    else
      sprintf(kav,"%s#7L#ni#7v#ni#7n#ng #7D#ne#7a#nd%s         ", openb, closeb );
  }
  else if( IS_CLASS(wch, CLASS_SHAPESHIFTER) ) 
  {
    if (wch->generation == 0)
      sprintf( kav, "%s#RM#ralau#Rg#n%s                ", openb, closeb );
    else if (wch->generation == 1) 
      sprintf( kav, "%s#RSpawn of Malaug#n%s       ", openb, closeb );
    else if (wch->generation == 2)
      sprintf( kav, "%s#RShadowmaster#n%s          ", openb, closeb );
    else if (wch->generation == 3)
      sprintf( kav, "%s#RMalaugrym Elder#n%s       ", openb, closeb );
    else if (wch->generation == 4)
      sprintf( kav, "%s#RMalaugrym#n%s             ", openb, closeb );
    else if (wch->generation == 5)
      sprintf( kav, "%s#RShapeshifter#n%s          ", openb, closeb );
    else if (wch->generation == 6)
      sprintf( kav, "%s#RDoppleganger#n%s          ", openb, closeb );
    else if (wch->generation == 7)
      sprintf( kav, "%s#RUnshapen Blob#n%s         ", openb, closeb );
    else
      sprintf( kav, "%s#RPlay-Doh#n%s              ", openb, closeb );
  }
  else if( IS_CLASS(wch, CLASS_ANGEL) )
  {
    if (wch->generation == 0)
      sprintf( kav, "%s#7God's Chosen One#n%s      ", openb, closeb );
    else if (wch->generation == 1)
      sprintf( kav, "%s#7Arch Angel#n%s            ", openb, closeb );
    else if (wch->generation == 2)
      sprintf( kav, "%s#7Cherubim#n%s              ", openb, closeb );
    else if (wch->generation == 3)
      sprintf( kav, "%s#7Seraphim#n%s              ", openb, closeb );
    else if (wch->generation == 4)
      sprintf( kav, "%s#7Guardian Angel#n%s        ", openb, closeb );
    else if (wch->generation == 5)
      sprintf( kav, "%s#7Angel#n%s                 ", openb, closeb );
    else
      sprintf( kav, "%s#7Nephalim#n%s              ", openb, closeb );
  }
  else if( IS_CLASS(wch, CLASS_UNDEAD_KNIGHT) )
  {
    if (wch->generation == 0)
      sprintf( kav, "%s#LHades#n%s                   ", openb, closeb );
    else if (wch->generation == 1)
      sprintf( kav, "%s#LUndead Master#n%s           ", openb, closeb );
    else if (wch->generation == 2)
      sprintf( kav, "%s#LUndead Lord#n%s             ", openb, closeb ); 
    else if (wch->generation == 3)
      sprintf( kav, "%s#LUndead Baron#n%s            ", openb, closeb );
    else if (wch->generation == 4)
      sprintf( kav, "%s#LUndead Knight#n%s           ", openb, closeb );
    else if (wch->generation == 5)
      sprintf( kav, "%s#LUndead Squire#n%s           ", openb, closeb );
    else if (wch->generation == 6)
      sprintf( kav, "%s#LUndead Page#n%s             ", openb, closeb );
    else if (wch->generation == 7)
      sprintf( kav, "%s#LUndead Apprentice#n%s       ", openb, closeb );
    else
      sprintf( kav, "%s#LRotting Corpse#n%s          ", openb, closeb );
  }
  else if ( IS_CLASS(wch, CLASS_WEREWOLF))
  {
    if (wch->generation == 0)
      sprintf( kav, "%s#oGaia's Avenger#n%s          ", openb, closeb );
    else if (wch->generation == 1)
      sprintf( kav, "%s#oGaia's Protector#n%s        ", openb, closeb );
    else if (wch->generation == 2)
      sprintf( kav, "%s#oChieftan#n%s                ", openb, closeb );
    else if (wch->generation == 3)
      sprintf( kav, "%s#oShaman#n%s                  ", openb, closeb );
    else if (wch->generation == 4)
      sprintf( kav, "%s#oNight Wolf#n%s              ", openb, closeb );
    else if (wch->generation == 5)
      sprintf( kav, "%s#oStalker#n%s                 ", openb, closeb );
    else if (wch->generation == 6)
      sprintf( kav, "%s#oHunter#n%s                  ", openb, closeb );
    else if (wch->generation == 7)
      sprintf( kav, "%s#oPup of Gaia#n%s             ", openb, closeb );
    else
      sprintf( kav, "%s#oWerewolf#n%s                ", openb, closeb );
  }
  else if ( IS_CLASS(wch, CLASS_MONK))
  {
    if (wch->generation == 0)
      sprintf(kav,"%s#7Visionary of God#n%s      ", openb, closeb);
    else if (wch->generation == 1)
      sprintf(kav,"%s#7Abbot#n%s                 ", openb, closeb);
    else if (wch->generation == 2)
      sprintf(kav,"%s#7High Priest#n%s           ", openb, closeb);
    else if (wch->generation == 3)
      sprintf(kav,"%s#7Priest#n%s                ", openb, closeb);
    else if (wch->generation == 4)
      sprintf(kav,"%s#7Father#n%s                ", openb, closeb);
    else if (wch->generation == 5)
      sprintf(kav,"%s#7Acolyte#n%s               ", openb, closeb);
    else if (wch->generation == 6)
      sprintf(kav,"%s#7Brother#n%s               ", openb, closeb);
    else if (wch->generation == 7)
      sprintf(kav,"%s#7Monk#n%s                  ", openb, closeb);
    else
      sprintf(kav,"%s#7Fanatic#n%s               ", openb, closeb);
  }
  else if ( IS_CLASS(wch, CLASS_DROW) && (wch->sex == SEX_FEMALE))
  {
    if (wch->generation == 0)
      sprintf( kav, "%s#pLloth#n%s                 ", openb, closeb );
    else if (wch->generation == 1)
      sprintf( kav, "%s#pDrow Queen#n%s            ", openb, closeb );
    else if (wch->generation == 2)
      sprintf( kav, "%s#pDrow Princess#n%s         ", openb, closeb );
    else if (wch->generation == 3)
      sprintf( kav, "%s#pDrow Baroness#n%s         ", openb, closeb );
    else if (wch->generation == 4)
      sprintf( kav, "%s#pMatron Mother#n%s         ", openb, closeb );
    else if (wch->generation == 5)
      sprintf( kav, "%s#pDrow Priestess#n%s        ", openb, closeb );
    else if (wch->generation == 6)
      sprintf( kav, "%s#pBlack Widow#n%s           ", openb, closeb );
    else
      sprintf( kav, "%s#pDrow Trainee#n%s          ", openb, closeb );
  }
  else if ( IS_CLASS(wch, CLASS_DROW) && (wch->sex == SEX_MALE))
  {
    if (wch->generation == 0)
      sprintf ( kav, "%s#pLloth's Guardian#n%s      ", openb, closeb );
    else if (wch->generation == 1)
      sprintf ( kav, "%s#pDrow King#n%s             ", openb, closeb );
    else if (wch->generation == 2)
      sprintf ( kav, "%s#pDrow Prince#n%s           ", openb, closeb );
    else if (wch->generation == 3)
      sprintf ( kav, "%s#pDrow Baron#n%s            ", openb, closeb );
    else if (wch->generation == 4)
      sprintf ( kav, "%s#pMatron Father#n%s         ", openb, closeb );
    else if (wch->generation == 5)
      sprintf ( kav, "%s#pDrow Priest#n%s           ", openb, closeb );
    else if (wch->generation == 6)
      sprintf ( kav, "%s#pBrown Recluse#n%s         ", openb, closeb );
    else
      sprintf ( kav, "%s#pDrow Novice#n%s           ", openb, closeb );
  }
else if ( IS_CLASS(wch, CLASS_MUMMY))
{
sprintf( kav, "%sMummy%s ",openb, closeb);
}
  else if ( IS_CLASS(wch, CLASS_VAMPIRE))
  {
      if (wch->generation == 1)
        sprintf( kav, "%s#oVampire#n%s ", openb, closeb);
      else
        sprintf( kav, "%s#oBloodsucker#n%s ", openb, closeb);

  }
  else if ( IS_CLASS(wch, CLASS_TANARRI))
  {
    if (wch->generation == 0)
      sprintf( kav, "%s#RTanar'ri Balor#n%s            ", openb, closeb );
    else if (wch->generation == 1)
      sprintf( kav, "%s#RTanar'ri Lord#n%s             ", openb, closeb );
    else if (wch->generation == 2)
      sprintf( kav, "%s#RTanar'ri Baron#n%s            ", openb, closeb );
    else if (wch->generation == 3)
      sprintf( kav, "%s#RTanar'ri Warmonger#n%s        ", openb, closeb );
    else if (wch->generation == 4)
      sprintf( kav, "%s#RTanar'ri Destroyer#n%s        ", openb, closeb );
    else if (wch->generation == 5)
      sprintf( kav, "%s#RTanar'ri#n%s                  ", openb, closeb );
    else if (wch->generation == 6)
      sprintf( kav, "%s#RTanar'ri Novice#n%s           ", openb, closeb );
    else
      sprintf( kav, "%s#RTanar'ri Child#n%s            ", openb, closeb );
  }
  else if ( IS_CLASS(wch, CLASS_MECHA))
  {
    if (wch->generation == 0)
      sprintf(kav,  "%s#lMetal Master#n%s    ", openb, closeb); 
    else if (wch->generation == 1) 
      sprintf( kav, "%s#lMetal Expert#n%s        ", openb, closeb );
    else if (wch->generation == 2)
      sprintf( kav, "%s#lMetal Adept#n%s          ", openb, closeb );
    else if (wch->generation == 3)
      sprintf( kav, "%s#lMetal Combatant#n%s       ", openb, closeb );
    else if (wch->generation == 4)
      sprintf( kav, "%s#lMetal Fighter#n%s      ", openb, closeb );
    else if (wch->generation == 5)
      sprintf( kav, "%s#lMetal Contender#n%s       ", openb, closeb );
    else if (wch->generation == 6)
      sprintf( kav, "%s#lMetal Warrior#n%s        ", openb, closeb );
    else
      sprintf( kav, "%s#lShrapnel#n%s        ", openb, closeb ); 
  } 
  else if ( IS_CLASS(wch, CLASS_ELEMENT))
  {
	 if (wch->generation == 0)
      sprintf( kav, "%s#cSpirit Guardian#n%s       ", openb, closeb);
    else if (wch->generation == 1) 
      sprintf( kav, "%s#gEarth Saint#n%s           ", openb, closeb);
    else if (wch->generation == 2)
      sprintf( kav, "%s#oWind Ruler#n%s            ", openb, closeb);
    else if (wch->generation == 3)
      sprintf( kav, "%s#lWater Lord#n%s            ", openb, closeb);
    else if (wch->generation == 4)
      sprintf( kav, "%s#rFire General#n%s          ", openb, closeb);
    else
      sprintf(kav, "%s#pElemental Warrior#n%s      ", openb,closeb); 
  }
  else if ( IS_CLASS(wch, CLASS_JEDI))
  {
    if (wch->generation == 0)
      sprintf( kav, "%s#CForce God#n%s             ", openb, closeb ); 
    else if (wch->generation == 1) 
      sprintf( kav, "%s#CJedi Master#n%s           ", openb, closeb );
    else if (wch->generation == 2)
      sprintf( kav, "%s#CJedi Lord#n%s             ", openb, closeb ); 
    else if (wch->generation == 3)
      sprintf( kav, "%s#CJedi Knight#n%s           ", openb, closeb );
    else if (wch->generation == 4)
      sprintf (kav, "%s#CJedi#n%s                  ", openb, closeb );
    else if (wch->generation == 5)
      sprintf( kav, "%s#CJedi Novice#n%s           ", openb, closeb );
    else if (wch->generation == 6)
      sprintf( kav, "%s#CJedi Apprentice#n%s       ", openb, closeb );
    else
      sprintf( kav, "%s#CBeginner Jedi#n%s         ", openb, closeb );
  }
  else if ( IS_CLASS(wch, CLASS_HIGHLANDER) )
    sprintf(kav, "%s#RSamu#yrai#n%s                 ", openb, closeb);
  else if ( IS_CLASS(wch, CLASS_NINJA) )
    {
      if (wch->generation == 0)
        sprintf( kav, "%s#yDeath's Vengeance#n%s   ", openb, closeb);
      else if (wch->generation == 1)
        sprintf( kav, "%s#yMaster Assassin#n%s     ", openb, closeb);
      else if (wch->generation == 2)
        sprintf( kav, "%s#yExpert Assassin#n%s     ", openb, closeb);
      else if (wch->generation == 3)
        sprintf( kav, "%s#yShadowlord#n%s          ", openb, closeb);
      else if (wch->generation == 4)
        sprintf( kav, "%s#yShadow Warrior#n%s      ", openb, closeb);
      else if (wch->generation == 5)
        sprintf( kav, "%s#yShadow#n%s              ", openb, closeb);
      else if (wch->generation == 6)
        sprintf( kav, "%s#yNinja#n%s               ", openb, closeb);
      else if (wch->generation == 7)
        sprintf( kav, "%s#yNinja Apprentice#n%s    ", openb, closeb);
      else
        sprintf( kav, "%s#yThug#n%s                ", openb, closeb);
    }
    else if ( IS_CLASS(wch, CLASS_DEMON) )
    {
      if (wch->generation == 0)
        sprintf( kav, "%s#RMephistopheles#n%s            ", openb, closeb);
      else if (wch->generation == 1)
        sprintf( kav, "%s#RPit Lord#n%s                  ", openb, closeb);
      else if (wch->generation == 2)
        sprintf( kav, "%s#RPit Fiend#n%s                 ", openb, closeb);
      else if (wch->generation == 3)
        sprintf( kav, "%s#RDemon Prince#n%s              ", openb, closeb);
      else if (wch->generation == 4)
        sprintf( kav, "%s#RImp Lord#n%s                  ", openb, closeb);
      else if (wch->generation == 5)
        sprintf( kav, "%s#RHell Spawn#n%s                ", openb, closeb);
      else if (wch->generation == 6)
        sprintf( kav, "%s#RDemon#n%s                     ", openb, closeb);
      else if (wch->generation == 7)
        sprintf( kav, "%s#RSpawnling#n%s                 ", openb, closeb);
      else  
        sprintf( kav, "%s#RImp#n%s                       ", openb, closeb);
    }
    else if ( IS_CLASS(wch, CLASS_DRAGON) )
    {
      if (wch->generation == 0)
        sprintf( kav, "%s#RB#rahamut#n%s                 ", openb, closeb);
      else
        sprintf( kav, "%s#RD#rragon#n%s                  ", openb, closeb);
    }
    else
     sprintf( kav, "#nNone#n                        " );}
	else
	sprintf( kav, "#nNone#n                        " );

            if (IS_CLASS(wch,CLASS_VAMPIRE))       sprintf(cls,"#RVampire#n");
      else  if (IS_CLASS(wch,CLASS_WEREWOLF)) sprintf(cls,"#LWerewolf#n");
      else if (IS_CLASS(wch,CLASS_MECHA)) sprintf(cls,"#lM#Le#lc#Lh#la#LW#la#Lr#lr#Li#lo#Lr#n"); 
      else if (IS_CLASS(wch,CLASS_DEMON)) sprintf(cls,"#RDemon#n"); 
      else  if (IS_CLASS(wch,CLASS_DROW))          sprintf(cls,"#pDrow#n");
      else  if (IS_CLASS(wch,CLASS_MAGE))          sprintf(cls,"#cMage#n");
      else if (IS_CLASS(wch,CLASS_JEDI))  sprintf(cls,"#CJedi#n"); 
      else  if (IS_CLASS(wch,CLASS_CYBORG))	   sprintf(cls,"#CCyborg#n");
      else  if (IS_CLASS(wch,CLASS_UNDEAD_KNIGHT)) sprintf(cls,"#LUndead Knight#n");
      else  if (IS_CLASS(wch,CLASS_HIGHLANDER))	   sprintf(cls,"#RSamu#yrai#n");
      else  if (IS_CLASS(wch,CLASS_NINJA))	   sprintf(cls,"#yNinja#n");
      else  if (IS_CLASS(wch,CLASS_TANARRI))	   sprintf(cls,"#RTanar'ri#n");
      else  if (IS_CLASS(wch,CLASS_SHAPESHIFTER))  sprintf(cls,"#RShapeshifter#n");
      else  if (IS_CLASS(wch,CLASS_ANGEL))	   sprintf(cls,"#7Angel#n");
      else if (IS_CLASS(wch,CLASS_DRAGON))  sprintf(cls,"#RD#rragon#n"); 
      else  if (IS_CLASS(wch,CLASS_XOMBI))         sprintf(cls,"#7X#no#7m#nb#7i#n");
      else  if (IS_CLASS(wch,CLASS_ELEMENT))       sprintf(cls,"#gElemental#n");
      else sprintf(cls,"None "); 
      sprintf( clan, " " );

      sprintf( king, "%s", king_table[wch->pcdata->kingdom].who_name);
      if ( IS_SET(wch->special, SPC_PRINCE) )
      {
	if( wch->sex == SEX_FEMALE ) sprintf( king, "%s #o(#lExec#o)#n", king_table[wch->pcdata->kingdom].who_name);
        else sprintf( king, "%s #o(#lExec#o)#n", king_table[wch->pcdata->kingdom].who_name); 
      }
      else if ( !strcmp(wch->pcdata->switchname,king_table[wch->pcdata->kingdom].leader_name) )
      {
	if( wch->sex == SEX_FEMALE ) sprintf( king, "%s #o(#lCmdr#o)#n",king_table[wch->pcdata->kingdom].who_name );
	else sprintf( king, "%s #o(#lCmdr#o)#n",king_table[wch->pcdata->kingdom].who_name );
      }

      if ( wch->level > 4 )
        {
	sprintf( buf3 + strlen(buf3), "%-16s #c%-15s#n %-10s %s %s\n\r",
	    class,          
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);
	  imm = TRUE;
	}    
 
	else if ( wch->level >= 3 && wch->level <= 4 )
        {
          if ( wch->race >= 43 )
          {
            sprintf( buf4 + strlen(buf4), "%-16s #c%-15s#n %-10s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a16 = TRUE;
          }
          else if ( wch->race >= 40 && wch->race <= 42 )
          {
            sprintf( buf6 + strlen(buf6), "%-16s #c%-15s#n %-10s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a15 = TRUE;
          }
          else if ( wch->race >= 37 && wch->race <= 39 )
          {
           sprintf( buf7 + strlen(buf7), "%-16s #c%-15s#n %-10s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a14 = TRUE;
          }
          else if ( wch->race >= 34 && wch->race <= 36 )
          {
           sprintf( buf8 + strlen(buf8), "%-16s #c%-15s#n %-10s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);
		a13 = TRUE;
          }
          else if ( wch->race >= 31 && wch->race <= 33 )
          {
            sprintf( buf9 + strlen(buf9), "%-16s #c%-15s#n %-10s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a12 = TRUE;
          }
          else if ( wch->race >= 28 && wch->race <= 30 )
          {
            sprintf( buf10 + strlen(buf10), "%-16s #c%-15s#n %-10s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a11 = TRUE;
          }
          else if ( wch->race >= 25 && wch->race <= 27 )
          {
            sprintf( buf11 + strlen(buf11), "%-16s #c%-15s#n %-10s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a10 = TRUE;
          }
          else if ( wch->race >= 22 && wch->race <= 24 )
          {
            sprintf( buf12 + strlen(buf12), "%-16s #c%-15s#n %-10s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);
		a9 = TRUE;
          }
          else if ( wch->race >= 19 && wch->race <= 21 )
          {
            sprintf( buf13 + strlen(buf13), "%-16s #c%-15s#n %-22s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a8 = TRUE;
          }
          else if ( wch->race >= 16 && wch->race <= 18 )
          {
          sprintf( buf14 + strlen(buf14), "%-16s #c%-15s#n %-22s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a7 = TRUE;
          }
          else if ( wch->race >= 13 && wch->race <= 15 )
          {
            sprintf( buf15 + strlen(buf15), "%-16s #c%-15s#n %-22s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a6 = TRUE;
          }
          else if ( wch->race >= 10 && wch->race <= 12 )
          {
            sprintf( buf16 + strlen(buf16), "%-16s #c%-15s#n %-22s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

		a5 = TRUE;
          }
          else if ( wch->race >= 7 && wch->race <= 9 )
          {
            sprintf( buf17 + strlen(buf17), "%-16s #c%-15s#n %-22s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

	    a4 = TRUE;
          }
          else if ( wch->race >= 4 && wch->race <= 6 )
          {
            sprintf( buf18 + strlen(buf19), "%-16s #c%-15s#n %-22s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);
	    a3 = TRUE;
          }
          else if ( wch->race >= 1 && wch->race <= 3 )
          {
            sprintf( buf19 + strlen(buf19), "%-16s #c%-15s#n %-22s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);
	    a2 = TRUE;
          }
          else if ( wch->race == 0 )
          {
           sprintf( buf20 + strlen(buf20), "%-16s #c%-15s#n %-22s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

            a1 = TRUE;
          }
	  ava = TRUE;
        }

        else if ( wch->level < 3 )
        {
        sprintf( buf5 + strlen(buf5), "%-16s #c%-15s#n %-22s %s %s\n\r",
	    class,
	    wch->pcdata->switchname,
	    kav,
	    king,
            clan);

          mor = TRUE;
        }

   if ( !mains ) 
   {
      sprintf(buf2,"*");
      banner_to_char(buf2,ch);      
      mains = TRUE;
   }
     
  }  

    if ( imm )
    {
      if ( !immortal )
      { stc("\n\r",ch);immortalbanner_to_char("",ch); immortal = TRUE;}
      stc(buf3,ch);
    }

    if ( ava )
    {
      if ( !avatar )
      { stc("\n\r",ch);avatarbanner_to_char("",ch); avatar = TRUE; }
      if ( a16 ) stc(buf4, ch);
      if ( a15 ) stc(buf6, ch);
      if ( a14 ) stc(buf7, ch);
      if ( a13 ) stc(buf8, ch);
      if ( a12 ) stc(buf9, ch);
      if ( a11 ) stc(buf10,ch);
      if ( a10 ) stc(buf11,ch);
      if ( a9  ) stc(buf12,ch);
      if ( a8  ) stc(buf13,ch);
      if ( a7  ) stc(buf14,ch);
      if ( a6  ) stc(buf15,ch);
      if ( a5  ) stc(buf16,ch);
      if ( a4  ) stc(buf17,ch);
      if ( a3  ) stc(buf18,ch);
      if ( a2  ) stc(buf19,ch);
      if ( a1  ) stc(buf20,ch);
    }
 
    if ( mor )
    {
      if ( !mortal )
      { stc("\n\r",ch); mortalbanner_to_char("",ch); mortal = TRUE; }
      stc(buf5,ch);
    }

     
    stc("\n\r",ch);
    totalplayerbanner_to_char("",ch);
    return;

    stc("\n\r",ch);
    totalwizardbanner_to_char("",ch);
    return;

}



void do_inventory( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_INPUT_LENGTH];
    OBJ_DATA *obj;
    OBJ_DATA *portal;
    OBJ_DATA *portal_next;
    ROOM_INDEX_DATA *pRoomIndex;
    ROOM_INDEX_DATA *location;
    bool found;

    if (!IS_NPC(ch) && IS_HEAD(ch,LOST_HEAD))
        {send_to_char( "You are not a container.\n\r", ch ); return;}
    else if (!IS_NPC(ch) && IS_EXTRA(ch,EXTRA_OSWITCH))
    {
        if ( !IS_NPC(ch) && (obj = ch->pcdata->chobj) == NULL)
	    {send_to_char( "You are not a container.\n\r", ch ); return;}
	switch ( obj->item_type )
	{
	default:
	    send_to_char( "You are not a container.\n\r", ch );
	    break;

	case ITEM_PORTAL: 
	    pRoomIndex = get_room_index(obj->value[0]);
	    location = ch->in_room;
	    if ( pRoomIndex == NULL )
	    {
		send_to_char( "You don't seem to lead anywhere.\n\r", ch );
		return;
	    }
	    char_from_room(ch);
	    char_to_room(ch,pRoomIndex);

	    found = FALSE;
	    for ( portal = ch->in_room->contents; portal != NULL; portal = portal_next )
	    {
		portal_next = portal->next_content;
		if ( ( obj->value[0] == portal->value[3]  )
		    && (obj->value[3] == portal->value[0]) )
		{
		    found = TRUE;
		    if (IS_AFFECTED(ch, AFF_SHADOWPLANE) &&
			!IS_SET(portal->extra_flags, ITEM_SHADOWPLANE) )
		    {
			REMOVE_BIT(ch->affected_by, AFF_SHADOWPLANE);
	    		do_look(ch,"auto");
			SET_BIT(ch->affected_by, AFF_SHADOWPLANE);
			break;
		    }
		    else if (!IS_AFFECTED(ch, AFF_SHADOWPLANE) &&
			IS_SET(portal->extra_flags, ITEM_SHADOWPLANE) )
		    {
			SET_BIT(ch->affected_by, AFF_SHADOWPLANE);
	    		do_look(ch,"auto");
			REMOVE_BIT(ch->affected_by, AFF_SHADOWPLANE);
			break;
		    }
		    else
		    {
	    		do_look(ch,"auto");
			break;
		    }
	    	}
	    }
	    char_from_room(ch);
	    char_to_room(ch,location);
	    break;

	case ITEM_DRINK_CON:
	    if ( obj->value[1] <= 0 )
	    {
		send_to_char( "You are empty.\n\r", ch );
		break;
	    }
	    if (obj->value[1] < obj->value[0] / 5)
	    	sprintf( buf, "There is a little %s liquid left in you.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] < obj->value[0] / 4)
	    	sprintf( buf, "You contain a small about of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] < obj->value[0] / 3)
	    	sprintf( buf, "You're about a third full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] < obj->value[0] / 2)
	    	sprintf( buf, "You're about half full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] < obj->value[0])
	    	sprintf( buf, "You are almost full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else if (obj->value[1] == obj->value[0])
	    	sprintf( buf, "You're completely full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    else
	    	sprintf( buf, "Somehow you are MORE than full of %s liquid.\n\r",liq_table[obj->value[2]].liq_color);
	    send_to_char( buf, ch );
	    break;
	case ITEM_SLOT_MACHINE:
	case ITEM_CONTAINER:
	case ITEM_CORPSE_NPC:
	case ITEM_CORPSE_PC:
	    act( "$p contain:", ch, obj, NULL, TO_CHAR );
	    show_list_to_char( obj->contains, ch, TRUE, TRUE );
	    break;
	}
	return;
    }
    send_to_char( "You are carrying:\n\r", ch );
    show_list_to_char( ch->carrying, ch, TRUE, TRUE );
    return;
}



void do_equipment( CHAR_DATA *ch, char *argument )
{
    OBJ_DATA *obj;
    int iWear;
    bool found;

    send_to_char( "You are using:\n\r", ch );
    found = FALSE;
    for ( iWear = 0; iWear < MAX_WEAR; iWear++ )
    {
	if ( ( obj = get_eq_char( ch, iWear ) ) == NULL )
	    continue;

	send_to_char( where_name[iWear], ch );
	if ( can_see_obj( ch, obj ) )
	{
	    send_to_char( format_obj_to_char( obj, ch, TRUE ), ch );
	    send_to_char( "\n\r", ch );
	}
	else
	{
	    send_to_char( "something.\n\r", ch );
	}
	found = TRUE;
    }

    if ( !found )
	send_to_char( "Nothing.\n\r", ch );

    return;
}


void do_credits( CHAR_DATA *ch, char *argument )
{
    do_help( ch, "diku" );
    return;
}



void do_wizlist( CHAR_DATA *ch, char *argument )
{
    do_help( ch, "wizlist" );
    return;
}


void do_where( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    DESCRIPTOR_DATA *d;
    bool found;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
	send_to_char( "Players near you:\n\r", ch );
	found = FALSE;
	for ( d = descriptor_list; d != NULL; d = d->next )
	{
	    if ( ( d->connected == CON_PLAYING
	    ||   d->connected == CON_EDITING)
	    && ( victim = d->character ) != NULL
	    &&   !IS_NPC(victim)
	    &&   victim->in_room != NULL
	    &&   victim->in_room->area == ch->in_room->area
	    &&   victim->pcdata->chobj == NULL
	    &&   can_see( ch, victim ) )
	    {
		found = TRUE;
		sprintf( buf, "%-28s %s\n\r",
		    victim->name, victim->in_room->name );
		send_to_char( buf, ch );
	    }
	}
	if ( !found )
	    send_to_char( "None\n\r", ch );
    }
    else
    {
	found = FALSE;
	for ( victim = char_list; victim != NULL; victim = victim->next )
	{
	    if ( victim->in_room != NULL
	    &&   victim->in_room->area == ch->in_room->area
	    &&   !IS_AFFECTED(victim, AFF_HIDE)
	    &&   !IS_AFFECTED(victim, AFF_SNEAK)
	    &&   can_see( ch, victim )
	    &&   is_name( arg, victim->name ) )
	    {
		found = TRUE;
		sprintf( buf, "%-28s %s\n\r",
		    PERS(victim, ch), victim->in_room->name );
		send_to_char( buf, ch );
		break;
	    }
	}
	if ( !found )
	    act( "You didn't find any $T.", ch, NULL, arg, TO_CHAR );
    }

    return;
}




void do_consider( CHAR_DATA *ch, char *argument )
{
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    char *msg;
    int diff;
    int overall;
    int con_hit;
    int con_dam;
    int con_ac;
    int con_hp;

    one_argument( argument, arg );
    overall = 0;

    if ( arg[0] == '\0' )
    {
	send_to_char( "Consider killing whom?\n\r", ch );
	return;
    }

    if ( ( victim = get_char_room( ch, arg ) ) == NULL )
    {
	send_to_char( "They're not here.\n\r", ch );
	return;
    }

    act( "You examine $N closely, looking for $S weaknesses.", ch, NULL, victim, TO_CHAR );
    act( "$n examine $N closely, looking for $S weaknesses.", ch, NULL, victim, TO_NOTVICT );
    act( "$n examines you closely, looking for your weaknesses.", ch, NULL, victim, TO_VICT );

    if (!IS_NPC(victim)) do_skill(ch,victim->name);

    if (!IS_NPC(victim) && IS_CLASS(victim, CLASS_VAMPIRE) && 
	IS_EXTRA(victim, EXTRA_FAKE_CON))
    {
	con_hit = victim->pcdata->fake_hit;
	con_dam = victim->pcdata->fake_dam;
	con_ac = victim->pcdata->fake_ac;
	con_hp = victim->pcdata->fake_hp;
    }
    else
    {
	con_hit = char_hitroll(victim);
	con_dam = char_damroll(victim);
	con_ac = char_ac(victim);
	con_hp = victim->hit;
    }
    if (con_hp < 1) con_hp = 1;

    diff = victim->level - ch->level + con_hit - char_hitroll(ch);
         if ( diff <= -35 ) {msg = "You are FAR more skilled than $M."; overall = overall + 3;}
    else if ( diff <= -15 ) {msg = "$E is not as skilled as you are."; overall = overall + 2;}
    else if ( diff <=  -5 ) {msg = "$E doesn't seem quite as skilled as you."; overall = overall + 1;}
    else if ( diff <=   5 ) {msg = "You are about as skilled as $M.";}
    else if ( diff <=  15 ) {msg = "$E is slightly more skilled than you are."; overall = overall - 1;}
    else if ( diff <=  35 ) {msg = "$E seems more skilled than you are."; overall = overall -2;}
    else                    {msg = "$E is FAR more skilled than you."; overall = overall - 3;}
    act( msg, ch, NULL, victim, TO_CHAR );

    diff = victim->level - ch->level + con_dam - char_damroll(ch);
         if ( diff <= -35 ) {msg = "You are FAR more powerful than $M."; overall = overall + 3;}
    else if ( diff <= -15 ) {msg = "$E is not as powerful as you are."; overall = overall + 2;}
    else if ( diff <=  -5 ) {msg = "$E doesn't seem quite as powerful as you."; overall = overall + 1;}
    else if ( diff <=   5 ) {msg = "You are about as powerful as $M.";}
    else if ( diff <=  15 ) {msg = "$E is slightly more powerful than you are."; overall = overall - 1;}
    else if ( diff <=  35 ) {msg = "$E seems more powerful than you are."; overall = overall -2;}
    else                    {msg = "$E is FAR more powerful than you."; overall = overall - 3;}
    act( msg, ch, NULL, victim, TO_CHAR );

    diff = ch->hit * 100 / con_hp;
         if ( diff <=  10 ) {msg = "$E is currently FAR healthier than you are."; overall = overall - 3;}
    else if ( diff <=  50 ) {msg = "$E is currently much healthier than you are."; overall = overall - 2;}
    else if ( diff <=  75 ) {msg = "$E is currently slightly healthier than you are."; overall = overall - 1;}
    else if ( diff <= 125 ) {msg = "$E is currently about as healthy as you are.";}
    else if ( diff <= 200 ) {msg = "You are currently slightly healthier than $M."; overall = overall + 1;}
    else if ( diff <= 500 ) {msg = "You are currently much healthier than $M."; overall = overall + 2;}
    else                    {msg = "You are currently FAR healthier than $M."; overall = overall + 3;}
    act( msg, ch, NULL, victim, TO_CHAR );

    diff = con_ac - char_ac(ch);
         if ( diff <= -100) {msg = "$E is FAR better armoured than you."; overall = overall - 3;}
    else if ( diff <= -50 ) {msg = "$E looks much better armoured than you."; overall = overall - 2;}
    else if ( diff <= -25 ) {msg = "$E looks better armoured than you."; overall = overall - 1;}
    else if ( diff <=  25 ) {msg = "$E seems about as well armoured as you.";}
    else if ( diff <=  50 ) {msg = "You are better armoured than $M."; overall = overall + 1;}
    else if ( diff <=  100) {msg = "You are much better armoured than $M."; overall = overall + 2;}
    else                    {msg = "You are FAR better armoured than $M."; overall = overall + 3;}
    act( msg, ch, NULL, victim, TO_CHAR );

    diff = overall;
         if ( diff <= -11 ) msg = "Conclusion: $E would kill you in seconds.";
    else if ( diff <=  -7 ) msg = "Conclusion: You would need a lot of luck to beat $M.";
    else if ( diff <=  -3 ) msg = "Conclusion: You would need some luck to beat $N.";
    else if ( diff <=   2 ) msg = "Conclusion: It would be a very close fight.";
    else if ( diff <=   6 ) msg = "Conclusion: You shouldn't have a lot of trouble defeating $M.";
    else if ( diff <=  10 ) msg = "Conclusion: $N is no match for you.  You can easily beat $M.";
    else                    msg = "Conclusion: $E wouldn't last more than a few seconds against you.";
    act( msg, ch, NULL, victim, TO_CHAR );

    return;
}


void set_prefix( CHAR_DATA *ch, char *title )
{
    char buf[MAX_STRING_LENGTH];

    if ( IS_NPC(ch) )
    {
	bug( "Set_title: NPC.", 0 );
	return;
    }

    if ( isalpha(title[0]) || isdigit(title[0]) )
    {
	buf[0] = ' ';
	strcpy( buf+1, title );
    }
    else
    {
	strcpy( buf, title );
    }

    free_string( ch->prefix );
    ch->prefix = str_dup( buf );
    return;
}



void set_title( CHAR_DATA *ch, char *title )
{
    char buf[MAX_STRING_LENGTH];

    if ( IS_NPC(ch) )
    {
	bug( "Set_title: NPC.", 0 );
	return;
    }

    if ( isalpha(title[0]) || isdigit(title[0]) )
    {
	buf[0] = ' ';
	strcpy( buf+1, title );
    }
    else
    {
	strcpy( buf, title );
    }

    free_string( ch->pcdata->title );
    ch->pcdata->title = str_dup( buf );
    return;
}
void set_kingtitle( CHAR_DATA *ch, char *title )
{
    char buf[MAX_STRING_LENGTH];
    
    if ( IS_NPC(ch) )
    {
        bug( "Set_title: NPC.", 0 );
        return;
    }
     
    if ( isalpha(title[0]) || isdigit(title[0]) )
    {
        buf[0] = ' ';
        strcpy( buf+1, title );
    }
    else
    {
        strcpy( buf, title );
    }
    
    free_string( ch->pcdata->title );
    ch->pcdata->title = str_dup( buf );   
    return;
}    


void do_title( CHAR_DATA *ch, char *argument )
{
 
    char buf[MAX_STRING_LENGTH];

    if ( IS_NPC(ch) )
	return;

    if ( argument[0] == '\0' )
    {
	send_to_char( "Change your title to what?\n\r", ch );
	return;
    }

    if ( strlen(argument) > 17 )
	argument[17] = '\0';

    smash_tilde( argument );
    sprintf(buf,"#n");
    strcpy(buf,argument);
    set_title( ch, argument );
    send_to_char( "Ok.\n\r", ch );
}
void do_kingrank( CHAR_DATA *ch, char *argument )
{
     
    char buf[MAX_STRING_LENGTH];
        
    if ( IS_NPC(ch) )
        return;
    
    if ( argument[0] == '\0' )
    {
        send_to_char( "Change your title to what?\n\r", ch );
        return;
    }   
     
    if ( strlen(argument) > 17 )
        argument[17] = '\0';
 
    smash_tilde( argument );
    sprintf(buf,"#n");
    strcpy(buf,argument);
    set_kingtitle( ch, argument );
    send_to_char( "Ok.\n\r", ch ); 
}
void do_afk( CHAR_DATA *ch, char *argument ) 
{
    char buf[MAX_STRING_LENGTH];

	if ( IS_NPC(ch) )
	return;

        if (ch->fight_timer>0)
	{
	send_to_char("not with a fighttimer.\n\r",ch);
	return;
	}

        if (IS_SET(ch->extra, EXTRA_AFK))
	{
	send_to_char( "You are no longer AFK.\n\r", ch );
	sprintf(buf,"%s is no longer AFK!",ch->pcdata->switchname);
        ADD_COLOUR(ch,buf,L_RED);
	do_info(ch,buf);
	REMOVE_BIT(ch->extra,EXTRA_AFK);
        return;
	}
	
	else if (!IS_SET(ch->extra,EXTRA_AFK))
	{
	send_to_char( "You are now AFK.\n\r", ch );
	sprintf(buf,"%s is now AFK!",ch->pcdata->switchname);
	ADD_COLOUR(ch,buf,L_RED);
	do_info(ch,buf);
	SET_BIT(ch->extra,EXTRA_AFK);
	WAIT_STATE(ch, 2);
        return;
	}

else
return;

}


void do_description( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];

    if ( argument[0] != '\0' )
    {
	buf[0] = '\0';
	smash_tilde( argument );
	if ( argument[0] == '+' )
	{
	    if ( ch->description != NULL )
		strcat( buf, ch->description );
	    argument++;
	    while ( isspace(*argument) )
		argument++;
	}

	if ( strlen(buf) + strlen(argument) >= MAX_STRING_LENGTH - 2 )
	{
	    send_to_char( "Description too long.\n\r", ch );
	    return;
	}

	strcat( buf, argument );
	strcat( buf, "\n\r" );
	free_string( ch->description );
	ch->description = str_dup( buf );
    }

    send_to_char( "Your description is:\n\r", ch );
    send_to_char( ch->description ? ch->description : "(None).\n\r", ch );
    return;
}



void do_report( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *vch;
    CHAR_DATA *vch_next;
    char buf[MAX_STRING_LENGTH];
    char hit_str[MAX_INPUT_LENGTH];
    char mana_str[MAX_INPUT_LENGTH];
    char move_str[MAX_INPUT_LENGTH];
    char mhit_str[MAX_INPUT_LENGTH];
    char mmana_str[MAX_INPUT_LENGTH];
    char mmove_str[MAX_INPUT_LENGTH];
    char exp_str[MAX_INPUT_LENGTH];
    sprintf(hit_str, "%d", ch->hit);
    COL_SCALE(hit_str, ch, ch->hit, ch->max_hit);
    sprintf(mana_str, "%d", ch->mana);
    COL_SCALE(mana_str, ch, ch->mana, ch->max_mana);
    sprintf(move_str, "%d", ch->move);
    COL_SCALE(move_str, ch, ch->move, ch->max_move);
    sprintf(exp_str, "%d", ch->exp);
    COL_SCALE(exp_str, ch, ch->exp, 1000);
    sprintf(mhit_str, "%d", ch->max_hit);
    ADD_COLOUR(ch, mhit_str, L_CYAN);
    sprintf(mmana_str, "%d", ch->max_mana);
    ADD_COLOUR(ch, mmana_str, L_CYAN);
    sprintf(mmove_str, "%d", ch->max_move);
    ADD_COLOUR(ch, mmove_str, L_CYAN);
    sprintf( buf,
	"You report: %s/%s hp %s/%s mana %s/%s mv %s xp.\n\r",
	hit_str,  mhit_str,
	mana_str, mmana_str,
	move_str, mmove_str,
	exp_str   );

    send_to_char( buf, ch );

    for ( vch = char_list; vch != NULL; vch = vch_next )
    {
	vch_next	= vch->next;
	if ( vch == NULL ) continue;
	if ( vch == ch ) continue;
	if ( vch->in_room == NULL ) continue;
	if ( vch->in_room != ch->in_room ) continue;
    	sprintf(hit_str, "%d", ch->hit);
    	COL_SCALE(hit_str, vch, ch->hit, ch->max_hit);
    	sprintf(mana_str, "%d", ch->mana);
    	COL_SCALE(mana_str, vch, ch->mana, ch->max_mana);
    	sprintf(move_str, "%d", ch->move);
    	COL_SCALE(move_str, vch, ch->move, ch->max_move);
    	sprintf(exp_str, "%d", ch->exp);
    	COL_SCALE(exp_str, vch, ch->exp, 1000);
    	sprintf(mhit_str, "%d", ch->max_hit);
    	ADD_COLOUR(vch, mhit_str, L_CYAN);
    	sprintf(mmana_str, "%d", ch->max_mana);
    	ADD_COLOUR(vch, mmana_str, L_CYAN);
    	sprintf(mmove_str, "%d", ch->max_move);
    	ADD_COLOUR(vch, mmove_str, L_CYAN);
    	if (!IS_NPC(ch) && IS_AFFECTED(ch,AFF_POLYMORPH))
    	    sprintf( buf, "%s reports: %s/%s hp %s/%s mana %s/%s mv %s xp.\n\r",
	    ch->morph,
	    hit_str,  mhit_str,
	    mana_str, mmana_str,
	    move_str, mmove_str,
	    exp_str   );
        else
    	    sprintf( buf, "%s reports: %s/%s hp %s/%s mana %s/%s mv %s xp.\n\r",
	    IS_NPC(ch) ? capitalize(ch->short_descr) : ch->name,
	    hit_str,  mhit_str,
	    mana_str, mmana_str,
	    move_str, mmove_str,
	    exp_str   );
	buf[0] = UPPER(buf[0]);
    	send_to_char( buf, vch );
    }
    return;
}



void do_practice( CHAR_DATA *ch, char *argument ) 
{
    char buf[MAX_STRING_LENGTH];
    int sn;

    if ( IS_NPC(ch) )
	return;

    if ( argument[0] == '\0' )
    {
	int col, i;

	col    = 0;
	for (i = 0; i < 10; i++)
	{
	for ( sn = 0; sn < MAX_SKILL; sn++ ) 
	{
	    if ( skill_table[sn].name == NULL )
		break;
	    if ( ch->level < skill_table[sn].skill_level )
		continue;
	    if (skill_table[sn].target != i)
	      continue;
		switch (i)
		{
	case 0:
		sprintf(buf, "#5%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	case 1:
		sprintf(buf, "#r%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	case 2:
		sprintf(buf, "#l%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	case 3:
		sprintf(buf, "#g%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	case 4:
		sprintf(buf, "#o%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	case 5:
		sprintf(buf, "#y%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	case 6:
		sprintf(buf, "#L%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	case 7:
		sprintf(buf, "#p%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	case 8:
		sprintf(buf, "#c%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	case 9:
		sprintf(buf, "#7%18s #7%3d%% ", skill_table[sn].name, ch->pcdata->learned[sn]);
		break;
	default:
	    sprintf( buf, " ");
	    break;
	}
	    send_to_char( buf, ch );
	    if ( ++col % 3 == 0 )
		send_to_char( "\n\r", ch );
	  }
	}
	    send_to_char( "#n\n\r", ch );
	if (col % 3 != 0)
	send_to_char("\n\r",ch);

	sprintf( buf, "You have %d exp left.\n\r", ch->exp ); 
	send_to_char( buf, ch );
    }
    else if (!strcmp(argument, "all"))
    {
	for (sn = 0; sn < MAX_SKILL; sn++)
	{
	    if (ch->exp < 5000)
	    break;
	if ((skill_table[sn].name != NULL) && (ch->level >= skill_table[sn].skill_level) && ch->pcdata->learned[sn] < 100)
	{
	ch->pcdata->learned[sn] = 100;
	ch->exp -= 5000;
	}
	}
	    send_to_char( "Ok.\n\r", ch );
	    return;
	}
	else
	{
		if ( !IS_AWAKE(ch))
	{
	    send_to_char( "In your dreams, or what?\n\r", ch);
	    return;
	}
	if ( ch->exp <= 0 )
	{
	    send_to_char( "You have no exp left.\n\r",ch);
	    return;
	}
	if ((sn = skill_lookup(argument)) < 0 || (!IS_NPC(ch) && ch->level < skill_table[sn].skill_level))
	{
	    send_to_char("You can't practice that.\n\r", ch);
	    return;
	}
	    if ( ch->pcdata->learned[sn] >= SKILL_ADEPT )
	    {
	    sprintf(buf, "You are already an adept of %s.\n\r", skill_table[sn].name);
	    send_to_char(buf, ch);
	    }
	    else if (ch->pcdata->learned[sn] > 0 && ch->exp < 5000)
	    {
	    sprintf(buf, "You need 5000 exp to increase %s any more.\n\r", (skill_table[sn].name));
	    send_to_char(buf, ch);
	    }
	    else if (ch->pcdata->learned[sn] == 0 && ch->exp < 5000)
	    {
	sprintf(buf, "You need 5000 exp to increase %s.\n\r", skill_table[sn].name);
	send_to_char(buf, ch);
	}
	else
	{
	if (ch->pcdata->learned[sn] == 0)
	{
	ch->exp -= 5000;
	ch->pcdata->learned[sn] += 100;
	}
	else
	{
	  ch->exp -= (ch->pcdata->learned[sn] / 2);
	  ch->pcdata->learned[sn] += int_app[get_curr_int(ch)].learn;
	}
	if (ch->pcdata->learned[sn] < SKILL_ADEPT)
	{
	  act("You practice $T.", ch, NULL, skill_table[sn].name,TO_CHAR);
	}
	else
	{
	  ch->pcdata->learned[sn] = SKILL_ADEPT;
	  act("You are now an adept of $T.", ch, NULL, skill_table[sn].name, TO_CHAR);
	}
      }
    }
    return;
}

/*
 * 'Wimpy' originally by Dionysos.
 */
void do_wimpy( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    int wimpy;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
	wimpy = ch->max_hit / 5;
    else
	wimpy = atoi( arg );

    if ( wimpy < 0 )
    {
	send_to_char( "Your courage exceeds your wisdom.\n\r", ch );
	return;
    }

    if ( wimpy > ch->max_hit * 0.35 )
    {
	send_to_char( "Such cowardice ill becomes you.\n\r", ch );
	return;
    }

    ch->wimpy	= wimpy;
    sprintf( buf, "Wimpy set to %d hit points.\n\r", wimpy );
    send_to_char( buf, ch );
    return;
}



void do_password( CHAR_DATA *ch, char *argument )
{
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];
    char *pArg;
    char *pwdnew;
    char *p;
    char cEnd;

    if ( IS_NPC(ch) )
	return;

    /*
     * Can't use one_argument here because it smashes case.
     * So we just steal all its code.  Bleagh.
     */
    pArg = arg1;
    while ( isspace(*argument) )
	argument++;

    cEnd = ' ';
    if ( *argument == '\'' || *argument == '"' )
	cEnd = *argument++;

    while ( *argument != '\0' )
    {
	if ( *argument == cEnd )
	{
	    argument++;
	    break;
	}
	*pArg++ = *argument++;
    }
    *pArg = '\0';

    pArg = arg2;
    while ( isspace(*argument) )
	argument++;

    cEnd = ' ';
    if ( *argument == '\'' || *argument == '"' )
	cEnd = *argument++;

    while ( *argument != '\0' )
    {
	if ( *argument == cEnd )
	{
	    argument++;
	    break;
	}
	*pArg++ = *argument++;
    }
    *pArg = '\0';

    if ( arg1[0] == '\0' || arg2[0] == '\0' )
    {
	send_to_char( "#RSyntax#7:#R Password#0 <#yOld#0> <#YNew#0>\n\r", ch );
	return;
    }

    if ( str_cmp( arg1, ch->pcdata->pwd ) && str_cmp( crypt( arg1, ch->pcdata->pwd ), ch->pcdata->pwd ))
    {
	WAIT_STATE( ch, 40 );
	send_to_char( "Wrong password.  Wait 10 seconds.\n\r", ch );
	return;
    }

    if ( strlen(arg2) < 5 )
    {
	send_to_char(
	    "New password must be at least five characters long.\n\r", ch );
	return;
    }

    /*
     * No tilde allowed because of player file format.
     */
    pwdnew = crypt( arg2, ch->pcdata->switchname );
    for ( p = pwdnew; *p != '\0'; p++ )
    {
	if ( *p == '~' )
	{
	    send_to_char(
		"New password not acceptable, try again.\n\r", ch );
	    return;
	}
    }

    free_string( ch->pcdata->pwd );
    ch->pcdata->pwd = str_dup( pwdnew );
    if (!IS_EXTRA(ch,EXTRA_NEWPASS)) SET_BIT(ch->extra,EXTRA_NEWPASS);
    save_char_obj( ch );
    if (ch->desc != NULL && ch->desc->connected == CON_PLAYING )
	send_to_char( "Ok.\n\r", ch );
    return;
}



void do_socials( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    int iSocial;
    int col;

    col = 0;

    for ( iSocial = 0; social_table[iSocial].name[0] != '\0'; iSocial++ )
    {
	sprintf( buf, "%-12s", social_table[iSocial].name );
	send_to_char( buf, ch );
	if ( ++col % 6 == 0 )
	    send_to_char( "\n\r", ch );
    }
 
    if ( col % 6 != 0 )
	send_to_char( "\n\r", ch );

    return;
}



void do_xsocials( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    int iSocial;
    int col;

    col = 0;

    for ( iSocial = 0; xsocial_table[iSocial].name[0] != '\0'; iSocial++ )
    {
	sprintf( buf, "%-12s", xsocial_table[iSocial].name );
	send_to_char( buf, ch );
	if ( ++col % 6 == 0 )
	    send_to_char( "\n\r", ch );
    }
 
    if ( col % 6 != 0 )
	send_to_char( "\n\r", ch );

    return;
}



void do_spells( CHAR_DATA *ch, char *argument )  {
    char buf[MAX_STRING_LENGTH];
    int sn;
    int col;

    col = 0;
    for ( sn = 0; sn < MAX_SKILL && skill_table[sn].name != NULL; sn++ )
    {
	sprintf( buf, "%-12s", skill_table[sn].name );
	send_to_char( buf, ch );
	if ( ++col % 6 == 0 )
	    send_to_char( "\n\r", ch );
    }

    if ( col % 6 != 0 )
	send_to_char( "\n\r", ch );
    return;
}



/*
 * Contributed by Alander.
 */

void do_commands( CHAR_DATA *ch, char *argument ) 
{
    char buf[MAX_STRING_LENGTH];
    int cmd;
    int col;
 
    col = 0;
    for ( cmd = 0; cmd_table[cmd].name[0] != '\0'; cmd++ )
    {
        if ( cmd_table[cmd].level == 0
        &&   cmd_table[cmd].level <= get_trust( ch ) )
	{
	    sprintf( buf, "#o%-12s#n", cmd_table[cmd].name );
	    send_to_char( buf, ch );
	    if ( ++col % 6 == 0 )
		send_to_char( "\n\r", ch );
	}
    }
 
    if ( col % 6 != 0 )
	send_to_char( "\n\r", ch );
    return;
}



void do_channels( CHAR_DATA *ch, char *argument ) 
{
    char arg[MAX_INPUT_LENGTH];

    one_argument( argument, arg );

    if (IS_NPC(ch)) return;
    if ( arg[0] == '\0' )
    {
	send_to_char( "Channels:\n\r", ch ); 

	send_to_char( !IS_SET(ch->deaf, CHANNEL_CHAT) 
	    ? " +CHAT\n\r"
	    : " -chat\n\r",
	    ch );

	send_to_char( !IS_SET(ch->deaf, CHANNEL_FLAME) 
	    ? " +FLAME\n\r"
	    : " -flame\n\r",
	    ch );

	send_to_char( !IS_SET(ch->deaf, CHANNEL_WHINE) 
            ? " +WHINE\n\r"
            : " -whine\n\r",
            ch );

        send_to_char( !IS_SET(ch->deaf, CHANNEL_NOHINT)              
            ? " +HINT\n\r"                                                     
            : " -hint\n\r",                                                    
            ch );                                                               
	
	if ( IS_EMPLOYEE(ch) ) 
	{
	    send_to_char( !IS_SET(ch->deaf, CHANNEL_IMMTALK)
		? " +IMMTALK\n\r"
		: " -immtalk\n\r",
		ch );
	}
	if (IS_CLASS(ch, CLASS_WEREWOLF) || IS_EMPLOYEE(ch))
	{
	send_to_char( !IS_SET(ch->deaf, CHANNEL_HOWL) 
	    ? " +HOWL\n\r"
	    : " -howl\n\r",
	    ch );
	}
	if (IS_EMPLOYEE(ch))
	{
	    send_to_char( !IS_SET(ch->deaf, CHANNEL_LOG)
		? " +LOG\n\r"
		: " -log\n\r",
		ch );
	}
	if ( IS_CLASS(ch, CLASS_SHAPESHIFTER) || IS_EMPLOYEE(ch))
	{
		send_to_char( !IS_SET(ch->deaf, CHANNEL_TELEPATH)
			? " +TELE\n\r"
			: " -tele\n\r",
			ch );
	}
        if (IS_CLASS( ch, CLASS_MAGE) || IS_EMPLOYEE(ch)) 
        {
            send_to_char( !IS_SET(ch->deaf, CHANNEL_MAGETALK)
                ? " +MAGE\n\r"
                : " -mage\n\r",
                ch );
        }
	if (IS_CLASS(ch, CLASS_JEDI) || IS_EMPLOYEE(ch))
	{
	    send_to_char( !IS_SET(ch->deaf, CHANNEL_FORCETALK)
		? " +FORCETALK\n\r"
		: " -forcetalk\n\r",
		ch);
	}
	if (IS_CLASS(ch, CLASS_ELEMENT) || IS_EMPLOYEE(ch))
	{
	    send_to_char( !IS_SET(ch->deaf, CHANNEL_FOCUS)
		? " +FOCUS\n\r"
		: " -focus\n\r",
		ch);
	}
	if (IS_CLASS(ch, CLASS_MECHA) || IS_EMPLOYEE(ch)) 
	{
	    send_to_char( !IS_SET(ch->deaf, CHANNEL_VOX) 
		? " +VOX\n\r" 
		: " -vox\n\r",
		ch);
	}
        if (IS_CLASS(ch, CLASS_XOMBI) || IS_EMPLOYEE(ch)) 
        {
            send_to_char( !IS_SET(ch->deaf, CHANNEL_MOAN) 
                ? " +MOAN\n\r" 
                : " -moan\n\r",
                ch);
        }
        if (IS_CLASS( ch, CLASS_MONK) || IS_EMPLOYEE(ch))
        {
            send_to_char( !IS_SET(ch->deaf, CHANNEL_MONK)
                ? " +MONK\n\r"
                : " -monk\n\r",
                ch );
        }

	if (IS_CLASS(ch, CLASS_DEMON) || IS_EMPLOYEE(ch))
	{
	    send_to_char( !IS_SET(ch->deaf, CHANNEL_PRAY)
		? " +PRAY\n\r"
		: " -pray\n\r",
		ch );
	}

	  send_to_char( !IS_SET(ch->deaf, CHANNEL_INFO) 
	    ? " +INFO\n\r" 
	    : " -info\n\r",
	    ch );
	
	if (IS_CLASS(ch, CLASS_VAMPIRE) || IS_EMPLOYEE(ch))
	{
	    send_to_char( !IS_SET(ch->deaf, CHANNEL_VAMPTALK)
		? " +VAMP\n\r"
		: " -vamp\n\r",
		ch );
	}
	if (IS_CLASS(ch, CLASS_HIGHLANDER) || IS_EMPLOYEE(ch))
	{
		send_to_char( !IS_SET(ch->deaf, CHANNEL_HIGHTALK)
			? " +SAMT\n\r"
			: " -samt\n\r",
			ch );
	}
	if( IS_CLASS(ch, CLASS_DROW) || IS_EMPLOYEE(ch))
	{
		send_to_char( !IS_SET(ch->deaf, CHANNEL_SIGN)
			? " +SIGN\n\r"
			: " -sign\n\r",
			ch );
	}

	send_to_char( !IS_SET(ch->deaf, CHANNEL_TELL) 
	    ? " +TELL\n\r"
	    : " -tell\n\r",
	    ch );
    	
	send_to_char( !IS_SET(ch->deaf, CHANNEL_KTALK)
	   ? " +KTALK\n\r"
	   : " -ktalk\n\r",
	   ch );

	send_to_char("\n\r",ch);
	}
    	else
    	{
	bool fClear;
	int bit;

	     if ( arg[0] == '+' ) fClear = TRUE;
	else if ( arg[0] == '-' ) fClear = FALSE;
	else
	{
	    send_to_char( "Channels: -channel or +channel?\n\r", ch );
	    return;
	}
        if (!str_cmp(arg+1,"chat")) bit = CHANNEL_CHAT;
	else if (!str_cmp(arg+1,"immtalk")) bit = CHANNEL_IMMTALK;
        else if (!str_cmp(arg+1,"flame")) bit = CHANNEL_FLAME;
	else if (!str_cmp(arg+1,"howl")) bit = CHANNEL_HOWL;
	else if (IS_EMPLOYEE(ch) && !str_cmp(arg+1, "log")) bit = CHANNEL_LOG;
        else if (!str_cmp(arg+1,"monk")) bit = CHANNEL_MONK;          
        else if (!str_cmp(arg+1,"mage")) bit = CHANNEL_MAGETALK;
	else if (!str_cmp(arg+1,"info")) bit = CHANNEL_INFO;
	else if (!str_cmp(arg+1,"vamp")) bit = CHANNEL_VAMPTALK;
	else if (!str_cmp(arg+1,"tell")) bit = CHANNEL_TELL;
	else if (!str_cmp(arg+1,"forcetalk")) bit = CHANNEL_FORCETALK; 
        else if (!str_cmp(arg+1,"moan")) bit = CHANNEL_MOAN; 
	else if (!str_cmp(arg+1,"vox")) bit = CHANNEL_VOX; 
	else if (!str_cmp(arg+1,"focus")) bit = CHANNEL_FOCUS;
	else if (!str_cmp(arg+1,"ktalk")) bit = CHANNEL_KTALK;
        else if (!str_cmp(arg+1,"whine")) bit = CHANNEL_WHINE;
	else if (!str_cmp(arg+1,"hint")) bit = CHANNEL_NOHINT;
	else
	{
	    send_to_char( "Set or clear which channel?\n\r", ch );
	    return;
	}
	if ( fClear )
	    REMOVE_BIT (ch->deaf, bit);
	else
	    SET_BIT    (ch->deaf, bit);
	send_to_char( "Ok.\n\r", ch );
	}
    return;
}

void do_config( CHAR_DATA *ch, char *argument )  {
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH]; 

    if ( IS_NPC(ch) )
	return;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
        send_to_char( "[ Keyword  ] Option\n\r", ch );

	send_to_char(  IS_SET(ch->act, PLR_ANSI)
            ? "[+ANSI     ] You have ansi colour on.\n\r"
	    : "[-ansi     ] You have ansi colour off.\n\r"
	    , ch );

	send_to_char(  IS_SET(ch->act, PLR_AUTOEXIT)
            ? "[+AUTOEXIT ] You automatically see exits.\n\r"
	    : "[-autoexit ] You don't automatically see exits.\n\r"
	    , ch );

	send_to_char(  IS_SET(ch->act, PLR_AUTOLOOT)
	    ? "[+AUTOLOOT ] You automatically loot corpses.\n\r"
	    : "[-autoloot ] You don't automatically loot corpses.\n\r"
	    , ch );

        send_to_char( IS_SET(ch->act, PLR_AUTOSLAB) 
            ? "[+AUTOSLAB ] You automatically take slabs only.\n\r"
            : "[-autoslab ] You don't automatically take slabs only.\n\r"
            , ch );
 
        send_to_char( IS_SET(ch->act, PLR_AUTOSKIN) 
            ? "[+AUTOSKIN ] You automatically skin your corpses.\n\r"
            : "[-autoskin ] You don't automatically skin your corpses.\n\r"
            , ch );
 
	send_to_char( IS_SET(ch->act, PLR_AUTOSAC) 
	    ? "[+AUTOSAC  ] You automatically sacrifice corpses.\n\r"
	    : "[-autosac  ] You don't automatically sacrifice corpses.\n\r"
	    , ch );

	send_to_char(  IS_SET(ch->act, PLR_BLANK)
	    ? "[+BLANK    ] You have a blank line before your prompt.\n\r"
	    : "[-blank    ] You have no blank line before your prompt.\n\r"
	    , ch );

	send_to_char(  IS_SET(ch->act, PLR_BRIEF)
	    ? "[+BRIEF    ] You see brief descriptions.\n\r"
	    : "[-brief    ] You see long descriptions.\n\r"
	    , ch );
         
	send_to_char(  IS_SET(ch->act, PLR_COMBINE)
	    ? "[+COMBINE  ] You see object lists in combined format.\n\r"
	    : "[-combine  ] You see object lists in single format.\n\r"
	    , ch );

	send_to_char(  IS_SET(ch->act, PLR_PROMPT)
	    ? "[+PROMPT   ] You have a prompt.\n\r"
	    : "[-prompt   ] You don't have a prompt.\n\r"
	    , ch );

	send_to_char(  IS_SET(ch->act, PLR_TELNET_GA)
	    ? "[+TELNETGA ] You receive a telnet GA sequence.\n\r"
	    : "[-telnetga ] You don't receive a telnet GA sequence.\n\r"
	    , ch );
	send_to_char(IS_SET(ch->act, PLR_MAP)
	    ? "[+MAP      ] You see the automapper.\n\r"
	    : "[-map      ] You don't see the automapper.\n\r"
	    , ch); 
	send_to_char( IS_SET(ch->act, PLR_SILENCE) 
	    ? "[+SILENCE  ] You are silenced.\n\r"
	    : "\n\r"
	    , ch );

	send_to_char( !IS_SET(ch->act, PLR_NO_TELL)
	    ? "\n\r"
	    : "[-tell     ] You can't use tell.\n\r"
	    , ch );
    	}
	else
	{
	bool fSet; 
	int bit;
    	     if ( arg[0] == '+' ) fSet = TRUE;
	else if ( arg[0] == '-' ) fSet = FALSE;
	else
	{
	    send_to_char( "Config -option or +option?\n\r", ch );
	    return;
	}

             if ( !str_cmp( arg+1, "ansi"     ) ) bit = PLR_ANSI;
        else if ( !str_cmp( arg+1, "autoexit" ) ) bit = PLR_AUTOEXIT;
	else if ( !str_cmp( arg+1, "autoloot" ) ) bit = PLR_AUTOLOOT;
        else if ( !str_cmp( arg+1, "autoslab" ) ) bit = PLR_AUTOSLAB; 
	else if ( !str_cmp( arg+1, "autosac"  ) ) bit = PLR_AUTOSAC;
        else if ( !str_cmp( arg+1, "autoskin" ) ) bit = PLR_AUTOSKIN; 
	else if ( !str_cmp( arg+1, "blank"  ) ) bit = PLR_BLANK; 
	else if ( !str_cmp( arg+1, "brief"    ) ) bit = PLR_BRIEF;
        else if ( !str_cmp( arg+1, "brief2"  ) ) bit = PLR_BRIEF2; 
	else if ( !str_cmp( arg+1, "combine"  ) ) bit = PLR_COMBINE; 
        else if ( !str_cmp( arg+1, "prompt"   ) ) bit = PLR_PROMPT;
	else if ( !str_cmp( arg+1, "telnetga" ) ) bit = PLR_TELNET_GA;
	else if ( !str_cmp( arg+1, "map" ) ) bit = PLR_MAP;
	else
	{
	    send_to_char( "Config which option?\n\r", ch );
	    return;
	}
	if ( fSet )
	{
	    SET_BIT (ch->act, bit); 
            sprintf(buf,"%s is now ON\n\r",arg+1);
            send_to_char(buf,ch);
	}
	else
	{
	    REMOVE_BIT (ch->act, bit); 
            sprintf(buf,"%s is now OFF\n\r",arg+1);
            send_to_char(buf,ch);
	    }
	}
    return;
}

void do_ansi( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) ) return;
    if (IS_SET(ch->act, PLR_ANSI)) do_config(ch,"-ansi");
    else do_config(ch,"+ansi");
    return;
}

void do_autoexit( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) ) return;
    if (IS_SET(ch->act, PLR_AUTOEXIT)) do_config(ch,"-autoexit");
    else do_config(ch,"+autoexit");
    return;
}

void do_autoloot( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) ) return;
    if (IS_SET(ch->act, PLR_AUTOLOOT)) do_config(ch,"-autoloot");
    else do_config(ch,"+autoloot");
    return;
}

void do_autoslab( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) ) return;
    if (IS_SET(ch->act, PLR_AUTOSLAB)) do_config(ch,"-autoslab"); 
    else do_config(ch,"+autoslab");
    return;
}

void do_autosac( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) ) return;
    if (IS_SET(ch->act, PLR_AUTOSAC)) do_config(ch,"-autosac");
    else do_config(ch,"+autosac");
    return;
}
void do_autoskin( CHAR_DATA *ch, char *argument)
{
    if (IS_NPC(ch)) return;
    if (IS_SET(ch->act, PLR_AUTOSKIN)) do_config(ch,"-autoskin");
    else do_config(ch,"+autoskin");
    return;
}      
void do_blank( CHAR_DATA *ch, char *argument )  {
    if ( IS_NPC(ch) ) return;
    if (IS_SET(ch->act, PLR_BLANK)) do_config(ch,"-blank");
    else do_config(ch,"+blank");
    return;
}

void do_brief( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) ) return;
    if (IS_SET(ch->act, PLR_BRIEF)) do_config(ch,"-brief");
    else do_config(ch,"+brief");
    return;
}

void do_brief2( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) ) return;
    if (IS_SET(ch->act, PLR_BRIEF2)) do_config(ch,"-brief2");
    else do_config(ch,"+brief2");
    return;
}
void do_map(CHAR_DATA * ch, char *argument)  { 
  if (IS_NPC(ch))
    return;
  if (IS_SET(ch->act, PLR_MAP))
    do_config(ch, "-map");
  else
    do_config(ch, "+map");
  return;
}

void do_diagnose( CHAR_DATA *ch, char *argument )  {
    char buf [MAX_STRING_LENGTH]; 
    char arg  [MAX_INPUT_LENGTH];
    int teeth = 0;
    int ribs = 0;
    CHAR_DATA *victim;

    argument = one_argument( argument, arg );

    if (arg == '\0')
    {
	send_to_char("Who do you wish to diagnose?\n\r",ch);
	return;
    }

    if ( ( victim = get_char_room( ch, arg ) ) == NULL )
    {
	send_to_char("Nobody here by that name.\n\r",ch);
	return;
    }
    act("$n examines $N carefully, diagnosing $S injuries.",ch,NULL,victim,TO_NOTVICT);
    act("$n examines you carefully, diagnosing your injuries.",ch,NULL,victim,TO_VICT);
    act("Your diagnoses of $N reveals the following...",ch,NULL,victim,TO_CHAR);
    send_to_char("----------------------------------------------------------------------------\n\r",ch);
    if ( ( victim->loc_hp[0] + victim->loc_hp[1] + victim->loc_hp[2] +
	   victim->loc_hp[3] + victim->loc_hp[4] + victim->loc_hp[5] +
	   victim->loc_hp[6] + victim->loc_hp[9] + victim->loc_hp[10]+
	   victim->loc_hp[11] + victim->loc_hp[12]) == 0) 
    {
	act("$N has no apparent injuries.",ch,NULL,victim,TO_CHAR);
	send_to_char("----------------------------------------------------------------------------\n\r",ch);
	return;
    }
    /* Check head */
    if (IS_HEAD(victim,LOST_EYE_L) && IS_HEAD(victim,LOST_EYE_R))
	act("$N has lost both of $S eyes.",ch,NULL,victim,TO_CHAR);
    else if (IS_HEAD(victim,LOST_EYE_L))
	act("$N has lost $S left eye.",ch,NULL,victim,TO_CHAR);
    else if (IS_HEAD(victim,LOST_EYE_R))
	act("$N has lost $S right eye.",ch,NULL,victim,TO_CHAR);
    if (IS_HEAD(victim,LOST_EAR_L) && IS_HEAD(victim,LOST_EAR_R))
	act("$N has lost both of $S ears.",ch,NULL,victim,TO_CHAR);
    else if (IS_HEAD(victim,LOST_EAR_L))
	act("$N has lost $S left ear.",ch,NULL,victim,TO_CHAR);
    else if (IS_HEAD(victim,LOST_EAR_R))
	act("$N has lost $S right ear.",ch,NULL,victim,TO_CHAR);
    if (IS_HEAD(victim,LOST_NOSE))
	act("$N has lost $S nose.",ch,NULL,victim,TO_CHAR);
    else if (IS_HEAD(victim,BROKEN_NOSE))
	act("$N has got a broken nose.",ch,NULL,victim,TO_CHAR);
    if (IS_HEAD(victim,BROKEN_JAW))
	act("$N has got a broken jaw.",ch,NULL,victim,TO_CHAR);
    else if (IS_HEAD(victim,LOST_BRAIN))
        act("$N has a huge hole in their head and their brain is missing.",ch,NULL,victim,TO_CHAR);
    if (IS_HEAD(victim,LOST_TONGUE))
        act("$N opens $S mouth, but no sounds come out... $N is missing $S tongue!!",ch,NULL,victim,TO_CHAR); 
    if (IS_HEAD(victim,LOST_HEAD)) 
    {
	act("$N has had $S head cut off.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_HEAD))
	    act("...Blood is spurting from the stump of $S neck.",ch,NULL,victim,TO_CHAR);
    }
    else
    {
	if (IS_BODY(victim,BROKEN_NECK))
	    act("$N has got a broken neck.",ch,NULL,victim,TO_CHAR);
	if (IS_BODY(victim,CUT_THROAT))
	{
	    act("$N has had $S throat cut open.",ch,NULL,victim,TO_CHAR);
	    if (IS_BLEEDING(victim,BLEEDING_THROAT))
		act("...Blood is pouring from the wound.",ch,NULL,victim,TO_CHAR);
	}
    }
    if (IS_HEAD(victim,BROKEN_SKULL))
	act("$N has got a broken skull.",ch,NULL,victim,TO_CHAR);
    if (IS_HEAD(victim,LOST_TOOTH_1 )) teeth += 1;
    if (IS_HEAD(victim,LOST_TOOTH_2 )) teeth += 2;
    if (IS_HEAD(victim,LOST_TOOTH_4 )) teeth += 4;
    if (IS_HEAD(victim,LOST_TOOTH_8 )) teeth += 8;
    if (IS_HEAD(victim,LOST_TOOTH_16)) teeth += 16;
    if (teeth > 0)
    {
	sprintf(buf,"$N has had %d teeth knocked out.",teeth);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    if (IS_HEAD(victim,LOST_TONGUE))
	act("$N has had $S tongue ripped out.",ch,NULL,victim,TO_CHAR);
    if (IS_HEAD(victim,LOST_HEAD))
    {
    	send_to_char("----------------------------------------------------------------------------\n\r",ch);
    	return;
    }
    /* Check body */
    if (IS_BODY(victim,BROKEN_RIBS_1 )) ribs += 1;
    if (IS_BODY(victim,BROKEN_RIBS_2 )) ribs += 2;
    if (IS_BODY(victim,BROKEN_RIBS_4 )) ribs += 4;
    if (IS_BODY(victim,BROKEN_RIBS_8 )) ribs += 8;
    if (IS_BODY(victim,BROKEN_RIBS_16)) ribs += 16;
    if (ribs > 0)
    {
	sprintf(buf,"$N has got %d broken ribs.",ribs);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    if (IS_BODY(victim,BROKEN_SPINE))
	act("$N has got a broken spine.",ch,NULL,victim,TO_CHAR);
    /* Check arms */
    check_left_arm(ch,victim);
    check_right_arm(ch,victim);
    check_left_leg(ch,victim);
    check_right_leg(ch,victim);
    send_to_char("----------------------------------------------------------------------------\n\r",ch);
    return;
}

void check_left_arm( CHAR_DATA *ch, CHAR_DATA *victim )
{
    char buf    [MAX_STRING_LENGTH];
    char finger [10];
    int fingers = 0;

    if (IS_ARM_L(victim,LOST_ARM) && IS_ARM_R(victim,LOST_ARM))
    {
	act("$N has lost both of $S arms.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_ARM_L) && IS_BLEEDING(victim,BLEEDING_ARM_R))
	    act("...Blood is spurting from both stumps.",ch,NULL,victim,TO_CHAR);
	else if (IS_BLEEDING(victim,BLEEDING_ARM_L))
	    act("...Blood is spurting from the left stump.",ch,NULL,victim,TO_CHAR);
	else if (IS_BLEEDING(victim,BLEEDING_ARM_R))
	    act("...Blood is spurting from the right stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_ARM_L(victim,LOST_ARM))
    {
	act("$N has lost $S left arm.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_ARM_L))
	    act("...Blood is spurting from the stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_ARM_L(victim,BROKEN_ARM) && IS_ARM_R(victim,BROKEN_ARM))
	act("$N arms are both broken.",ch,NULL,victim,TO_CHAR);
    else if (IS_ARM_L(victim,BROKEN_ARM))
	act("$N's left arm is broken.",ch,NULL,victim,TO_CHAR);
    if (IS_ARM_L(victim,LOST_HAND) && IS_ARM_R(victim,LOST_HAND) &&
	!IS_ARM_R(victim,LOST_ARM))
    {
	act("$N has lost both of $S hands.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_HAND_L) && IS_BLEEDING(victim,BLEEDING_HAND_R))
	    act("...Blood is spurting from both stumps.",ch,NULL,victim,TO_CHAR);
	else if (IS_BLEEDING(victim,BLEEDING_HAND_L))
	    act("...Blood is spurting from the left stump.",ch,NULL,victim,TO_CHAR);
	else if (IS_BLEEDING(victim,BLEEDING_HAND_R))
	    act("...Blood is spurting from the right stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_ARM_L(victim,LOST_HAND))
    {
	act("$N has lost $S left hand.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_HAND_L))
	    act("...Blood is spurting from the stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_ARM_L(victim,LOST_FINGER_I)) fingers += 1;
    if (IS_ARM_L(victim,LOST_FINGER_M)) fingers += 1;
    if (IS_ARM_L(victim,LOST_FINGER_R)) fingers += 1;
    if (IS_ARM_L(victim,LOST_FINGER_L)) fingers += 1;
    if (fingers == 1) sprintf(finger,"finger");
    else sprintf(finger,"fingers");
    if (fingers > 0 && IS_ARM_L(victim,LOST_THUMB))
    {
	sprintf(buf,"$N has lost %d %s and $S thumb from $S left hand.",fingers,finger);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (fingers > 0)
    {
	sprintf(buf,"$N has lost %d %s from $S left hand.",fingers,finger);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (IS_ARM_L(victim,LOST_THUMB))
    {
	sprintf(buf,"$N has lost the thumb from $S left hand.");
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    fingers = 0;
    if (IS_ARM_L(victim,BROKEN_FINGER_I) && !IS_ARM_L(victim,LOST_FINGER_I)) fingers += 1;
    if (IS_ARM_L(victim,BROKEN_FINGER_M) && !IS_ARM_L(victim,LOST_FINGER_M)) fingers += 1;
    if (IS_ARM_L(victim,BROKEN_FINGER_R) && !IS_ARM_L(victim,LOST_FINGER_R)) fingers += 1;
    if (IS_ARM_L(victim,BROKEN_FINGER_L) && !IS_ARM_L(victim,LOST_FINGER_L)) fingers += 1;
    if (fingers == 1) sprintf(finger,"finger");
    else sprintf(finger,"fingers");
    if (fingers > 0 && IS_ARM_L(victim,BROKEN_THUMB) && !IS_ARM_L(victim,LOST_THUMB))
    {
	sprintf(buf,"$N has broken %d %s and $S thumb on $S left hand.",fingers,finger);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (fingers > 0)
    {
	sprintf(buf,"$N has broken %d %s on $S left hand.",fingers,finger);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (IS_ARM_L(victim,BROKEN_THUMB) && !IS_ARM_L(victim,LOST_THUMB))
    {
	sprintf(buf,"$N has broken the thumb on $S left hand.");
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    return;
}

void check_right_arm( CHAR_DATA *ch, CHAR_DATA *victim )
{
    char buf    [MAX_STRING_LENGTH];
    char finger [10];
    int fingers = 0;

    if (IS_ARM_L(victim,LOST_ARM) && IS_ARM_R(victim,LOST_ARM))
	return;
    if (IS_ARM_R(victim,LOST_ARM))
    {
	act("$N has lost $S right arm.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_ARM_R))
	    act("...Blood is spurting from the stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (!IS_ARM_L(victim,BROKEN_ARM) && IS_ARM_R(victim,BROKEN_ARM))
	act("$N's right arm is broken.",ch,NULL,victim,TO_CHAR);
    else if (IS_ARM_L(victim,LOST_ARM) && IS_ARM_R(victim,BROKEN_ARM))
	act("$N's right arm is broken.",ch,NULL,victim,TO_CHAR);
    if (IS_ARM_L(victim,LOST_HAND) && IS_ARM_R(victim,LOST_HAND))
	return;
    if (IS_ARM_R(victim,LOST_HAND))
    {
	act("$N has lost $S right hand.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_HAND_R))
	    act("...Blood is spurting from the stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_ARM_R(victim,LOST_FINGER_I)) fingers += 1;
    if (IS_ARM_R(victim,LOST_FINGER_M)) fingers += 1;
    if (IS_ARM_R(victim,LOST_FINGER_R)) fingers += 1;
    if (IS_ARM_R(victim,LOST_FINGER_L)) fingers += 1;
    if (fingers == 1) sprintf(finger,"finger");
    else sprintf(finger,"fingers");
    if (fingers > 0 && IS_ARM_R(victim,LOST_THUMB))
    {
	sprintf(buf,"$N has lost %d %s and $S thumb from $S right hand.",fingers,finger);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (fingers > 0)
    {
	sprintf(buf,"$N has lost %d %s from $S right hand.",fingers,finger);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (IS_ARM_R(victim,LOST_THUMB))
    {
	sprintf(buf,"$N has lost the thumb from $S right hand.");
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    fingers = 0;
    if (IS_ARM_R(victim,BROKEN_FINGER_I) && !IS_ARM_R(victim,LOST_FINGER_I)) fingers += 1;
    if (IS_ARM_R(victim,BROKEN_FINGER_M) && !IS_ARM_R(victim,LOST_FINGER_M)) fingers += 1;
    if (IS_ARM_R(victim,BROKEN_FINGER_R) && !IS_ARM_R(victim,LOST_FINGER_R)) fingers += 1;
    if (IS_ARM_R(victim,BROKEN_FINGER_L) && !IS_ARM_R(victim,LOST_FINGER_L)) fingers += 1;
    if (fingers == 1) sprintf(finger,"finger");
    else sprintf(finger,"fingers");
    if (fingers > 0 && IS_ARM_R(victim,BROKEN_THUMB) && !IS_ARM_R(victim,LOST_THUMB))
    {
	sprintf(buf,"$N has broken %d %s and $S thumb on $S right hand.",fingers,finger);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (fingers > 0)
    {
	sprintf(buf,"$N has broken %d %s on $S right hand.",fingers,finger);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (IS_ARM_R(victim,BROKEN_THUMB) && !IS_ARM_R(victim,LOST_THUMB))
    {
	sprintf(buf,"$N has broken the thumb on $S right hand.");
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    return;
}

void check_left_leg( CHAR_DATA *ch, CHAR_DATA *victim )
{
    char buf    [MAX_STRING_LENGTH];
    char toe [10];
    int toes = 0;

    if (IS_LEG_L(victim,LOST_LEG) && IS_LEG_R(victim,LOST_LEG))
    {
	act("$N has lost both of $S legs.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_LEG_L) && IS_BLEEDING(victim,BLEEDING_LEG_R))
	    act("...Blood is spurting from both stumps.",ch,NULL,victim,TO_CHAR);
	else if (IS_BLEEDING(victim,BLEEDING_LEG_L))
	    act("...Blood is spurting from the left stump.",ch,NULL,victim,TO_CHAR);
	else if (IS_BLEEDING(victim,BLEEDING_LEG_R))
	    act("...Blood is spurting from the right stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_LEG_L(victim,LOST_LEG))
    {
	act("$N has lost $S left leg.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_LEG_L))
	    act("...Blood is spurting from the stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_LEG_L(victim,BROKEN_LEG) && IS_LEG_R(victim,BROKEN_LEG))
	act("$N legs are both broken.",ch,NULL,victim,TO_CHAR);
    else if (IS_LEG_L(victim,BROKEN_LEG))
	act("$N's left leg is broken.",ch,NULL,victim,TO_CHAR);
    if (IS_LEG_L(victim,LOST_FOOT) && IS_LEG_R(victim,LOST_FOOT))
    {
	act("$N has lost both of $S feet.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_FOOT_L) && IS_BLEEDING(victim,BLEEDING_FOOT_R))
	    act("...Blood is spurting from both stumps.",ch,NULL,victim,TO_CHAR);
	else if (IS_BLEEDING(victim,BLEEDING_FOOT_L))
	    act("...Blood is spurting from the left stump.",ch,NULL,victim,TO_CHAR);
	else if (IS_BLEEDING(victim,BLEEDING_FOOT_R))
	    act("...Blood is spurting from the right stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_LEG_L(victim,LOST_FOOT))
    {
	act("$N has lost $S left foot.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_FOOT_L))
	    act("...Blood is spurting from the stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_LEG_L(victim,LOST_TOE_A)) toes += 1;
    if (IS_LEG_L(victim,LOST_TOE_B)) toes += 1;
    if (IS_LEG_L(victim,LOST_TOE_C)) toes += 1;
    if (IS_LEG_L(victim,LOST_TOE_D)) toes += 1;
    if (toes == 1) sprintf(toe,"toe");
    else sprintf(toe,"toes");
    if (toes > 0 && IS_LEG_L(victim,LOST_TOE_BIG))
    {
	sprintf(buf,"$N has lost %d %s and $S big toe from $S left foot.",toes,toe);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (toes > 0)
    {
	sprintf(buf,"$N has lost %d %s from $S left foot.",toes,toe);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (IS_LEG_L(victim,LOST_TOE_BIG))
    {
	sprintf(buf,"$N has lost the big toe from $S left foot.");
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    toes = 0;
    if (IS_LEG_L(victim,BROKEN_TOE_A) && !IS_LEG_L(victim,LOST_TOE_A)) toes += 1;
    if (IS_LEG_L(victim,BROKEN_TOE_B) && !IS_LEG_L(victim,LOST_TOE_B)) toes += 1;
    if (IS_LEG_L(victim,BROKEN_TOE_C) && !IS_LEG_L(victim,LOST_TOE_C)) toes += 1;
    if (IS_LEG_L(victim,BROKEN_TOE_D) && !IS_LEG_L(victim,LOST_TOE_D)) toes += 1;
    if (toes == 1) sprintf(toe,"toe");
    else sprintf(toe,"toes");
    if (toes > 0 && IS_LEG_L(victim,BROKEN_TOE_BIG) && !IS_LEG_L(victim,LOST_TOE_BIG))
    {
	sprintf(buf,"$N has broken %d %s and $S big toe from $S left foot.",toes,toe);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (toes > 0)
    {
	sprintf(buf,"$N has broken %d %s on $S left foot.",toes,toe);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (IS_LEG_L(victim,BROKEN_TOE_BIG) && !IS_LEG_L(victim,LOST_TOE_BIG))
    {
	sprintf(buf,"$N has broken the big toe on $S left foot.");
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    return;
}

void check_right_leg( CHAR_DATA *ch, CHAR_DATA *victim )
{
    char buf    [MAX_STRING_LENGTH];
    char toe [10];
    int toes = 0;

    if (IS_LEG_L(victim,LOST_LEG) && IS_LEG_R(victim,LOST_LEG))
	return;
    if (IS_LEG_R(victim,LOST_LEG))
    {
	act("$N has lost $S right leg.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_LEG_R))
	    act("...Blood is spurting from the stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (!IS_LEG_L(victim,BROKEN_LEG) && IS_LEG_R(victim,BROKEN_LEG))
	act("$N's right leg is broken.",ch,NULL,victim,TO_CHAR);
    if (IS_LEG_L(victim,LOST_FOOT) && IS_LEG_R(victim,LOST_FOOT))
	return;
    if (IS_LEG_R(victim,LOST_FOOT))
    {
	act("$N has lost $S right foot.",ch,NULL,victim,TO_CHAR);
	if (IS_BLEEDING(victim,BLEEDING_FOOT_R))
	    act("...Blood is spurting from the stump.",ch,NULL,victim,TO_CHAR);
	return;
    }
    if (IS_LEG_R(victim,LOST_TOE_A)) toes += 1;
    if (IS_LEG_R(victim,LOST_TOE_B)) toes += 1;
    if (IS_LEG_R(victim,LOST_TOE_C)) toes += 1;
    if (IS_LEG_R(victim,LOST_TOE_D)) toes += 1;
    if (toes == 1) sprintf(toe,"toe");
    else sprintf(toe,"toes");
    if (toes > 0 && IS_LEG_R(victim,LOST_TOE_BIG))
    {
	sprintf(buf,"$N has lost %d %s and $S big toe from $S right foot.",toes,toe);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (toes > 0)
    {
	sprintf(buf,"$N has lost %d %s from $S right foot.",toes,toe);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (IS_LEG_R(victim,LOST_TOE_BIG))
    {
	sprintf(buf,"$N has lost the big toe from $S right foot.");
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    toes = 0;
    if (IS_LEG_R(victim,BROKEN_TOE_A) && !IS_LEG_R(victim,LOST_TOE_A)) toes += 1;
    if (IS_LEG_R(victim,BROKEN_TOE_B) && !IS_LEG_R(victim,LOST_TOE_B)) toes += 1;
    if (IS_LEG_R(victim,BROKEN_TOE_C) && !IS_LEG_R(victim,LOST_TOE_C)) toes += 1;
    if (IS_LEG_R(victim,BROKEN_TOE_D) && !IS_LEG_R(victim,LOST_TOE_D)) toes += 1;
    if (toes == 1) sprintf(toe,"toe");
    else sprintf(toe,"toes");
    if (toes > 0 && IS_LEG_R(victim,BROKEN_TOE_BIG) && !IS_LEG_R(victim,LOST_TOE_BIG))
    {
	sprintf(buf,"$N has broken %d %s and $S big toe on $S right foot.",toes,toe);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (toes > 0)
    {
	sprintf(buf,"$N has broken %d %s on $S right foot.",toes,toe);
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    else if (IS_LEG_R(victim,BROKEN_TOE_BIG) && !IS_LEG_R(victim,LOST_TOE_BIG))
    {
	sprintf(buf,"$N has broken the big toe on $S right foot.");
	act(buf,ch,NULL,victim,TO_CHAR);
    }
    return;
}

void obj_score( CHAR_DATA *ch, OBJ_DATA *obj )
{
    char buf[MAX_STRING_LENGTH];
    AFFECT_DATA *paf;
    int itemtype;

    sprintf( buf,"You are %s.\n\r",obj->short_descr);
    send_to_char( buf, ch );

    sprintf( buf,"Type %s, Extra flags %s.\n\r",item_type_name(obj),
	extra_bit_name(obj->extra_flags));
    send_to_char( buf, ch );

    sprintf( buf,"You weigh %d pounds and are worth %d gold coins.\n\r",obj->weight,obj->cost);
    send_to_char( buf, ch );

    if (obj->questmaker != NULL && strlen(obj->questmaker) > 1 &&
	obj->questowner != NULL && strlen(obj->questowner) > 1)
    {
	sprintf( buf, "You were created by %s, and are owned by %s.\n\r", obj->questmaker,obj->questowner );
	send_to_char( buf, ch );
    }
    else if (obj->questmaker != NULL && strlen(obj->questmaker) > 1)
    {
	sprintf( buf, "You were created by %s.\n\r", obj->questmaker );
	send_to_char( buf, ch );
    }
    else if (obj->questowner != NULL && strlen(obj->questowner) > 1)
    {
	sprintf( buf, "You are owned by %s.\n\r", obj->questowner );
	send_to_char( buf, ch );
    }

    switch ( obj->item_type )
    {
    case ITEM_SCROLL: 
    case ITEM_POTION:
	sprintf( buf, "You contain level %d spells of:", obj->value[0] );
	send_to_char( buf, ch );

	if ( obj->value[1] >= 0 && obj->value[1] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[1]].name, ch );
	    send_to_char( "'", ch );
	}

	if ( obj->value[2] >= 0 && obj->value[2] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[2]].name, ch );
	    send_to_char( "'", ch );
	}

	if ( obj->value[3] >= 0 && obj->value[3] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[3]].name, ch );
	    send_to_char( "'", ch );
	}

	send_to_char( ".\n\r", ch );
	break;

    case ITEM_QUEST:
	sprintf( buf, "Your quest point value is %d.\n\r", obj->value[0] );
	send_to_char( buf, ch );
	break;

    case ITEM_WAND: 
    case ITEM_STAFF: 
	sprintf( buf, "You have %d(%d) charges of level %d",
	    obj->value[1], obj->value[2], obj->value[0] );
	send_to_char( buf, ch );

	if ( obj->value[3] >= 0 && obj->value[3] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[3]].name, ch );
	    send_to_char( "'", ch );
	}

	send_to_char( ".\n\r", ch );
	break;
      
    case ITEM_WEAPON:
	sprintf( buf, "You inflict %d to %d damage in combat (average %d).\n\r",
	    obj->value[1], obj->value[2],
	    ( obj->value[1] + obj->value[2] ) / 2 );
	send_to_char( buf, ch );

	if (obj->value[0] >= 1000)
	    itemtype = obj->value[0] - ((obj->value[0] / 1000) * 1000);
	else
	    itemtype = obj->value[0];

	if (itemtype > 0)
	{
	    if (obj->level < 10)
		sprintf(buf,"You are a minor spell weapon.\n\r");
	    else if (obj->level < 20)
		sprintf(buf,"You are a lesser spell weapon.\n\r");
	    else if (obj->level < 30)
		sprintf(buf,"You are an average spell weapon.\n\r");
	    else if (obj->level < 40)
		sprintf(buf,"You are a greater spell weapon.\n\r");
	    else if (obj->level < 50)
		sprintf(buf,"You are a major spell weapon.\n\r");
	    else
		sprintf(buf,"You are a supreme spell weapon.\n\r");
	    send_to_char(buf,ch);
	}

	if (itemtype == 1)
	    sprintf (buf, "You are dripping with corrosive acid.\n\r");
	else if (itemtype == 4)
	    sprintf (buf, "You radiate an aura of darkness.\n\r");
	else if (itemtype == 30)
	    sprintf (buf, "You are the bane of all evil.\n\r");
	else if (itemtype == 34)
	    sprintf (buf, "You drink the souls of your victims.\n\r");
	else if (itemtype == 37)
	    sprintf (buf, "You have been tempered in hellfire.\n\r");
	else if (itemtype == 48)
	    sprintf (buf, "You crackle with sparks of lightning.\n\r");
	else if (itemtype == 53)
	    sprintf (buf, "You are dripping with a dark poison.\n\r");
	else if (itemtype > 0)
	    sprintf (buf, "You have been imbued with the power of %s.\n\r",skill_table[itemtype].name);
	if (itemtype > 0)
	    send_to_char( buf, ch );

	if (obj->value[0] >= 1000)
	    itemtype = obj->value[0] / 1000;
	else
	    break;

	if (itemtype == 4 || itemtype == 1)
	    sprintf (buf, "You radiate an aura of darkness.\n\r");
	else if (itemtype == 27 || itemtype == 2)
	    sprintf (buf, "You allow your wielder to see invisible things.\n\r");
	else if (itemtype == 39 || itemtype == 3)
	    sprintf (buf, "You grant your wielder the power of flight.\n\r");
	else if (itemtype == 45 || itemtype == 4)
	    sprintf (buf, "You allow your wielder to see in the dark.\n\r");
	else if (itemtype == 46 || itemtype == 5)
	    sprintf (buf, "You render your wielder invisible to the human eye.\n\r");
	else if (itemtype == 52 || itemtype == 6)
	    sprintf (buf, "You allow your wielder to walk through solid doors.\n\r");
	else if (itemtype == 54 || itemtype == 7)
	    sprintf (buf, "You protect your wielder from evil.\n\r");
	else if (itemtype == 57 || itemtype == 8)
	    sprintf (buf, "You protect your wielder in combat.\n\r");
	else if (itemtype == 9)
	    sprintf (buf, "You allow your wielder to walk in complete silence.\n\r");
	else if (itemtype == 10)
	    sprintf (buf, "You surround your wielder with a shield of lightning.\n\r");
	else if (itemtype == 11)
	    sprintf (buf, "You surround your wielder with a shield of fire.\n\r");
	else if (itemtype == 12)
	    sprintf (buf, "You surround your wielder with a shield of ice.\n\r");
	else if (itemtype == 13)
	    sprintf (buf, "You surround your wielder with a shield of acid.\n\r");
	else if (itemtype == 14)
	    sprintf (buf, "You channel the power of god into your wielder.\n\r");
	else if (itemtype == 15)
	    sprintf (buf, "You surround your wielder with a shield of chaos.\n\r");
	else if (itemtype == 16)
	    sprintf (buf, "You regenerate the wounds of your wielder.\n\r");
	else if (itemtype == 17)
	    sprintf (buf, "You enable your wielder to move at supernatural speed.\n\r");
	else if (itemtype == 18)
	    sprintf (buf, "You can slice through armour without difficulty.\n\r");
	else if (itemtype == 19)
	    sprintf (buf, "You protect your wielder from player attacks.\n\r");
	else if (itemtype == 20)
	    sprintf (buf, "You surround your wielder with a shield of darkness.\n\r");
	else if (itemtype == 21)
	    sprintf (buf, "You grant your wielder superior protection.\n\r");
	else if (itemtype == 22)
	    sprintf (buf, "You grant your wielder supernatural vision.\n\r");
	else if (itemtype == 23)
	    sprintf (buf, "You make your wielder fleet-footed.\n\r");
	else if (itemtype == 24)
	    sprintf (buf, "You conceal your wielder from sight.\n\r");
	else if (itemtype == 25)
	    sprintf (buf, "You invoke the power of your wielders beast.\n\r");
	else
	    sprintf (buf, "You are bugged...please report it.\n\r");
	if (itemtype > 0)
	    send_to_char( buf, ch );
	break;

    case ITEM_ARMOR:
	sprintf( buf, "Your armor class is %d.\n\r", obj->value[0] );
	send_to_char( buf, ch );
	if (obj->value[3] < 1)
	    break;
	if (obj->value[3] == 4 || obj->value[3] == 1)
	    sprintf (buf, "You radiate an aura of darkness.\n\r");
	else if (obj->value[3] == 27 || obj->value[3] == 2)
	    sprintf (buf, "You allow your wearer to see invisible things.\n\r");
	else if (obj->value[3] == 39 || obj->value[3] == 3)
	    sprintf (buf, "You grant your wearer the power of flight.\n\r");
	else if (obj->value[3] == 45 || obj->value[3] == 4)
	    sprintf (buf, "You allow your wearer to see in the dark.\n\r");
	else if (obj->value[3] == 46 || obj->value[3] == 5)
	    sprintf (buf, "You render your wearer invisible to the human eye.\n\r");
	else if (obj->value[3] == 52 || obj->value[3] == 6)
	    sprintf (buf, "You allow your wearer to walk through solid doors.\n\r");
	else if (obj->value[3] == 54 || obj->value[3] == 7)
	    sprintf (buf, "You protect your wearer from evil.\n\r");
	else if (obj->value[3] == 57 || obj->value[3] == 8)
	    sprintf (buf, "You protect your wearer in combat.\n\r");
	else if (obj->value[3] == 9)
	    sprintf (buf, "You allow your wearer to walk in complete silence.\n\r");
	else if (obj->value[3] == 10)
	    sprintf (buf, "You surround your wearer with a shield of lightning.\n\r");
	else if (obj->value[3] == 11)
	    sprintf (buf, "You surround your wearer with a shield of fire.\n\r");
	else if (obj->value[3] == 12)
	    sprintf (buf, "You surround your wearer with a shield of ice.\n\r");
	else if (obj->value[3] == 13)
	    sprintf (buf, "You surround your wearer with a shield of acid.\n\r");
	else if (obj->value[3] == 14)
	    sprintf (buf, "You protect your wearer from attacks from DarkBlade clan guardians.\n\r");
	else if (obj->value[3] == 15)
	    sprintf (buf, "You surround your wielder with a shield of chaos.\n\r");
	else if (obj->value[3] == 16)
	    sprintf (buf, "You regenerate the wounds of your wielder.\n\r");
	else if (obj->value[3] == 17)
	    sprintf (buf, "You enable your wearer to move at supernatural speed.\n\r");
	else if (obj->value[3] == 18)
	    sprintf (buf, "You can slice through armour without difficulty.\n\r");
	else if (obj->value[3] == 19)
	    sprintf (buf, "You protect your wearer from player attacks.\n\r");
	else if (obj->value[3] == 20)
	    sprintf (buf, "You surround your wearer with a shield of darkness.\n\r");
	else if (obj->value[3] == 21)
	    sprintf (buf, "You grant your wearer superior protection.\n\r");
	else if (obj->value[3] == 22)
	    sprintf (buf, "You grant your wearer supernatural vision.\n\r");
	else if (obj->value[3] == 23)
	    sprintf (buf, "You make your wearer fleet-footed.\n\r");
	else if (obj->value[3] == 24)
	    sprintf (buf, "You conceal your wearer from sight.\n\r");
	else if (obj->value[3] == 25)
	    sprintf (buf, "You invoke the power of your wearers beast.\n\r");
	else
	    sprintf (buf, "You are bugged...please report it.\n\r");
	if (obj->value[3] > 0)
	    send_to_char( buf, ch );
	break;
    }

    for ( paf = obj->pIndexData->affected; paf != NULL; paf = paf->next )
    {
	if ( paf->location != APPLY_NONE && paf->modifier != 0 )
	{
	    sprintf( buf, "You affect %s by %d.\n\r",
		affect_loc_name( paf->location ), paf->modifier );
	    send_to_char( buf, ch );
	}
    }

    for ( paf = obj->affected; paf != NULL; paf = paf->next )
    {
	if ( paf->location != APPLY_NONE && paf->modifier != 0 )
	{
	    sprintf( buf, "You affect %s by %d.\n\r",
		affect_loc_name( paf->location ), paf->modifier );
	    send_to_char( buf, ch );
	}
    }
    return;
}

/* Do_prompt from Morgenes from Aldara Mud */
void do_prompt( CHAR_DATA *ch, char *argument )
{
   char buf [ MAX_STRING_LENGTH ];

   buf[0] = '\0';
   if ( IS_NPC(ch) ) return;

   if ( argument[0] == '\0' )
   {
       do_help( ch, "prompt" );
       return;
   }

   if( !strcmp( argument, "on" ) )
   {
      if (IS_EXTRA(ch, EXTRA_PROMPT))
         send_to_char("But you already have customised prompt on!\n\r",ch);
      else
      {
         send_to_char("Ok.\n\r",ch);
         SET_BIT(ch->extra, EXTRA_PROMPT);
      }
      return;
   }
   else if( !strcmp( argument, "off" ) )
   {
      if (!IS_EXTRA(ch, EXTRA_PROMPT))
         send_to_char("But you already have customised prompt off!\n\r",ch);
      else
      {
         send_to_char("Ok.\n\r",ch);
         REMOVE_BIT(ch->extra, EXTRA_PROMPT);
      }
      return;
   }
   else if( !strcmp( argument, "clear" ) )
   {
      free_string(ch->prompt);
      ch->prompt = str_dup( "" );
      return;
   }
   else
   {
      if ( strlen( argument ) > 50 )
	  argument[50] = '\0';
      smash_tilde( argument );
      strcat( buf, argument );
   }

   free_string( ch->prompt );
   ch->prompt = str_dup( buf );
   send_to_char( "Ok.\n\r", ch );
   return;
} 

/* Do_prompt from Morgenes from Aldara Mud */
void do_cprompt( CHAR_DATA *ch, char *argument )
{
   char buf [ MAX_STRING_LENGTH ];

   buf[0] = '\0';
   if ( IS_NPC(ch) ) return;

   if ( argument[0] == '\0' )
   {
       do_help( ch, "cprompt" );
       return;
   }

   if( !strcmp( argument, "clear" ) )
   {
      free_string(ch->cprompt);
      ch->cprompt = str_dup( "" );
      return;
   }
   else
   {
      if ( strlen( argument ) > 50 )
	  argument[50] = '\0';
      smash_tilde( argument );
      strcat( buf, argument );
   }

   free_string( ch->cprompt );
   ch->cprompt = str_dup( buf );
   send_to_char( "Ok.\n\r", ch );
   return;
} 


void do_email( CHAR_DATA *ch, char *argument ) 
{
    if ( IS_NPC(ch) )
	return;
    if ( argument[0] == '\0' )
    {
	send_to_char( "What do you wish to set your email address to?\n\r", ch );
	return;
    }
    if ( strlen(argument) > 50 )
	argument[50] = '\0';
    smash_tilde( argument );
    free_string( ch->pcdata->email );
    ch->pcdata->email = str_dup( argument );
    send_to_char( "Ok.\n\r", ch );
}


void do_finger( CHAR_DATA *ch, char *argument )  {
    char strsave[MAX_INPUT_LENGTH];
    char *buf;
    char buf2[MAX_INPUT_LENGTH];
    char status[MAX_INPUT_LENGTH];
    FILE *fp;
    int  num;
    int  num2;
    int extra; 

    if ( IS_NPC(ch) ) return;

    if (!check_parse_name( argument ))
    {
        send_to_char( "#7Thats an illegal name.\n\r", ch );
        return;
    }

    if ( !char_exists(TRUE,argument) )
    {
        send_to_char( "#7That player doesn't exist.\n\r", ch );
        return;
    }

    fclose( fpReserve );
    sprintf( strsave, "%sbackup/%s", PLAYER_DIR, capitalize(argument) );
    if ( ( fp = fopen( strsave, "r" ) ) != NULL )
    {

send_to_char("-------------------------------------------------------------------------\n\r",ch);

        buf=fread_string( fp );
        send_to_char(buf,ch);
        send_to_char(" ",ch);
        buf=fread_string( fp );
        send_to_char(buf,ch);
        send_to_char(".\n\r",ch);

if (IS_EMPLOYEE(ch))
{
send_to_char("-------------------------------------------------------------------------\n\r",ch);
        send_to_char("Last connected ",ch);
}
        buf=fread_string( fp );
     if (IS_EMPLOYEE(ch))
        send_to_char("at ",ch);
        buf=fread_string( fp );
     if (IS_EMPLOYEE(ch))
{
        send_to_char(buf,ch);
        send_to_char(".\n\r",ch);
}

send_to_char("-------------------------------------------------------------------------\n\r",ch);

        extra=fread_number( fp );
        num=fread_number( fp );
        send_to_char("Sex: ",ch);
        buf=fread_string( fp );
        if (num == SEX_MALE) send_to_char("#3Male. ",ch);
        else if (num == SEX_FEMALE)
        {
            send_to_char("Female. ",ch);
            if (IS_SET(extra, EXTRA_PREGNANT))
		other_age(ch,extra,TRUE,buf); 
        }
        else send_to_char("None. ",ch);
        buf=fread_string( fp );
        other_age(ch,extra,FALSE,buf);
        num=fread_number( fp );
        num2=fread_number( fp );
        switch ( num )
        {
            default:
                send_to_char("They are mortal, ",ch);
                break;
            case LEVEL_ADVOCATE: 
            {
                if (num2 < 1)
                    sprintf(status, "They are an Advocate with %d status,",num2);
                else if (num2 < 5)
                    sprintf(status, "They have %d status,", num2);
                send_to_char(status, ch);
                break;
                }
            case LEVEL_EMPLOYEE:
                send_to_char("--=(Employee)=--, ",ch);                   
                break;                                                          
            case LEVEL_MANAGER:
                send_to_char("--=(Manager)=--, ",ch);                   
                break;                                                           
	    case LEVEL_ADMINISTRATOR:
                send_to_char("--=(Administrator)=--, ",ch);                   
                break;                                                          
            case LEVEL_CHAIRPERSON:
                send_to_char("--=(Chairperson)=--, ",ch);                   
                break;                                                          
            case LEVEL_CEO:
                send_to_char("--=(CEO)=--, ",ch);                   
                break;                                                          
            case LEVEL_VICEPRESIDENT:
                send_to_char("--=(Vice President)=--, ",ch);
                break;
	    case LEVEL_PRESIDENT:
                send_to_char("--=(President)=--, ",ch);                   
                break;                                                          
        }
        num=fread_number( fp );
        if (num > 0) num2 = (2*(num / 7200)); else num2 = 0;
        sprintf(buf2,"and have been playing for %d hours.\n\r",num2);
        send_to_char(buf2,ch);
        buf=fread_string( fp ); 
        if (strlen(buf) > 2)
        {
            if (IS_SET(extra, EXTRA_MARRIED))
                sprintf(buf2,"They are married to %s.\n\r",buf);
            else
                sprintf(buf2,"They are engaged to %s.\n\r",buf);
            send_to_char(buf2,ch);
        }
        num=fread_number( fp );
        num2=fread_number( fp );
        sprintf(buf2,"Player kills: %d, Player Deaths:%d.\n\r",num,num2);
        send_to_char(buf2,ch);
        num=fread_number( fp );
        num2=fread_number( fp );
        sprintf(buf2,"Mob kills: %d, Mob Deaths:%d.\n\r",num,num2); 
        send_to_char(buf2,ch);
send_to_char("---------------------------------------------------------------------------\n\r",ch); 
       buf=fread_string( fp );
       if (strlen(buf) > 2)
        {
            sprintf(buf2,"Email: %s\n\r",buf);
            send_to_char(buf2,ch);
        }
        buf=fread_string( fp );
	if (strlen(buf) > 5)
	{
            sprintf(buf2,"Icq: %s\n\r",buf);
            send_to_char(buf2,ch);
	}
send_to_char("----------------------------------------------------------------------------\n\r",ch);
        }
    else
    {
        bug( "Do_finger: fopen", 0 );
    }
    fclose( fp );
    fpReserve = fopen( NULL_FILE, "r" );
    return;
}

void do_icq( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) )
      return;
    if ( argument[0] == '\0' )
    {
      send_to_char( "What do you wish to set your icq number to?\n\r", ch);
      send_to_char( "Icq Clear to clear your icq number.\r\n", ch);
      return;
    }
    if (!str_cmp(argument, "clear"))
    {
     free_string(ch->pcdata->icq);
     ch->pcdata->icq = str_dup("");
     send_to_char("ICQ number cleared.\r\n", ch);
    }
    if ( strlen(argument) > 50 )
      argument[50] = '\0';
    smash_tilde( argument );
    free_string( ch->pcdata->icq );
    ch->pcdata->icq = str_dup( argument );
    send_to_char( "Ok.\n\r", ch );
}
